' ########################################################################################
' * << Haru Free PDF Library 2.0.10 >> -- arc_demo.bas
' * It is provided "as is" without express or implied warranty.
' ########################################################################################

#COMPILE EXE
#DIM ALL
#INCLUDE ONCE "windows.inc"
#INCLUDE ONCE "hpdf.inc"
#INCLUDE ONCE "grid_sheet.inc"

' ========================================================================================
' Callback error handler procedure
' ========================================================================================
SUB HPDF_Error_Handler HPDF_CALLCONV() ( _
   BYVAL error_no AS HPDF_STATUS, _
   BYVAL detail_no AS HPDF_STATUS, _
   BYVAL user_data AS DWORD)

   LOCAL strMsg AS STRING

   strMsg = "Error number = " & STR$(error_no) & " [&H" & HEX$(error_no) & "]" & $CRLF
   strMsg = strMsg & "Detail number = " & STR$(detail_no) & " [&H" & HEX$(detail_no) & "]"
   ? strMsg

END SUB
' ========================================================================================

' ========================================================================================
' Main
' ========================================================================================
FUNCTION PBMAIN

   LOCAL pdf AS HPDF_Doc
   LOCAL hPage AS HPDF_Page
   LOCAL fname AS ASCIIZ * 256
   LOCAL ptPos AS HPDF_Point

   fname = "arc_demo.pdf"

   pdf = HPDF_New(CODEPTR(HPDF_Error_Handler), %NULL)
   IF pdf = %NULL THEN
      ? "Error: cannot create PdfDoc object"
      EXIT FUNCTION
   END IF

   ' /* add a new page object. */
   hPage = HPDF_AddPage (pdf)

   HPDF_Page_SetHeight (hPage, 220)
   HPDF_Page_SetWidth (hPage, 200)

   ' /* draw grid to the hPage */
   print_grid  (pdf, hPage)

   ' /* draw pie chart
   '  *
   '  *   A: 45% Red
   '  *   B: 25% Blue
   '  *   C: 15% green
   '  *   D: other yellow
   '  */

   ' /* A */
   HPDF_Page_SetRGBFill (hPage, 1.0, 0, 0)
   HPDF_Page_MoveTo (hPage, 100, 100)
   HPDF_Page_LineTo (hPage, 100, 180)
   HPDF_Page_Arc (hPage, 100, 100, 80, 0, 360 * 0.45)
   HPDF_Page_GetCurrentPos2 (hPage, ptPos)
   HPDF_Page_LineTo (hPage, 100, 100)
   HPDF_Page_Fill (hPage)

   ' /* B */
   HPDF_Page_SetRGBFill (hPage, 0, 0, 1.0)
   HPDF_Page_MoveTo (hPage, 100, 100)
   HPDF_Page_LineTo (hPage, ptPos.x, ptPos.y)
   HPDF_Page_Arc (hPage, 100, 100, 80, 360 * 0.45, 360 * 0.7)
   HPDF_Page_GetCurrentPos2 (hPage, ptPos)
   HPDF_Page_LineTo (hPage, 100, 100)
   HPDF_Page_Fill (hPage)

   ' /* C */
   HPDF_Page_SetRGBFill (hPage, 0, 1.0, 0)
   HPDF_Page_MoveTo (hPage, 100, 100)
   HPDF_Page_LineTo (hPage, ptPos.x, ptPos.y)
   HPDF_Page_Arc (hPage, 100, 100, 80, 360 * 0.7, 360 * 0.85)
   HPDF_Page_GetCurrentPos2 (hPage, ptPos)
   HPDF_Page_LineTo (hPage, 100, 100)
   HPDF_Page_Fill (hPage)

   ' /* D */
   HPDF_Page_SetRGBFill (hPage, 1.0, 1.0, 0)
   HPDF_Page_MoveTo (hPage, 100, 100)
   HPDF_Page_LineTo (hPage, ptPos.x, ptPos.y)
   HPDF_Page_Arc (hPage, 100, 100, 80, 360 * 0.85, 360)
   HPDF_Page_GetCurrentPos2 (hPage, ptPos)
   HPDF_Page_LineTo (hPage, 100, 100)
   HPDF_Page_Fill (hPage)

   ' /* draw center circle */
   HPDF_Page_SetGrayStroke (hPage, 0)
   HPDF_Page_SetGrayFill (hPage, 1)
   HPDF_Page_Circle (hPage, 100, 100, 30)
   HPDF_Page_Fill (hPage)

   ' /* save the document to a file */
   HPDF_SaveToFile (pdf, fname)

   ' /* clean up */
   HPDF_Free (pdf)

   ? "Document created"

   #IF %DEF(%PB_CC32)
      WAITKEY$
   #ENDIF

END FUNCTION
' ========================================================================================
