' ########################################################################################
' * << Haru Free PDF Library 2.0.0 >> -- ext_gstate_demo.c
' * It is provided "as is" without express or implied warranty.
' ########################################################################################

' SED_PBWIN - Use the PBWIN compiler
#COMPILE EXE
#DIM ALL
#INCLUDE ONCE "windows.inc"
#INCLUDE ONCE "hpdf.inc"

' ========================================================================================
' Callback error handler procedure
' ========================================================================================
SUB HPDF_Error_Handler HPDF_CALLCONV() ( _
   BYVAL error_no AS HPDF_STATUS, _
   BYVAL detail_no AS HPDF_STATUS, _
   BYVAL user_data AS DWORD)

   LOCAL strMsg AS STRING

   strMsg = "Error number = " & STR$(error_no) & " [&H" & HEX$(error_no) & "]" & $CRLF
   strMsg = strMsg & "Detail number = " & STR$(detail_no) & " [&H" & HEX$(detail_no) & "]"
   ? strMsg

END SUB
' ========================================================================================

' ========================================================================================
' Draws circles
' ========================================================================================
SUB draw_circles (BYVAL hPage AS HPDF_Page, BYREF description AS ASCIIZ, BYVAL x AS HPDF_REAL, BYVAL y AS HPDF_REAL)

   HPDF_Page_SetLineWidth (hPage, 1.0!)
   HPDF_Page_SetRGBStroke (hPage, 0.0!, 0.0!, 0.0!)
   HPDF_Page_SetRGBFill (hPage, 1.0!, 0.0!, 0.0!)
   HPDF_Page_Circle (hPage, x + 40, y + 40, 40)
   HPDF_Page_ClosePathFillStroke (hPage)
   HPDF_Page_SetRGBFill (hPage, 0.0!, 1.0!, 0.0!)
   HPDF_Page_Circle (hPage, x + 100, y + 40, 40)
   HPDF_Page_ClosePathFillStroke (hPage)
   HPDF_Page_SetRGBFill (hPage, 0.0!, 0.0!, 1.0!)
   HPDF_Page_Circle (hPage, x + 70, y + 74.64, 40)
   HPDF_Page_ClosePathFillStroke (hPage)

   HPDF_Page_SetRGBFill (hPage, 0.0!, 0.0!, 0.0!)
   HPDF_Page_BeginText (hPage)
   HPDF_Page_TextOut (hPage, x + 0.0!, y + 130.0!, description)
   HPDF_Page_EndText (hPage)

END SUB
' ========================================================================================

' ========================================================================================
' Main
' ========================================================================================
FUNCTION PBMAIN

   LOCAL pdf AS HPDF_Doc
   LOCAL hPage AS HPDF_Page
   LOCAL fname AS ASCIIZ * 256
   LOCAL hFont AS HPDF_Font
   LOCAL gstate AS HPDF_ExtGState
   LOCAL PAGE_WIDTH AS HPDF_REAL
   LOCAL PAGE_HEIGHT AS HPDF_REAL

   PAGE_WIDTH = 600
   PAGE_HEIGHT = 900

   fname = "ext_gstate_demo.pdf"

   pdf = HPDF_New(CODEPTR(HPDF_Error_Handler), %NULL)
   IF pdf = %NULL THEN
      ? "Error: cannot create PdfDoc object"
      EXIT FUNCTION
   END IF

   hFont = HPDF_GetFont (pdf, "Helvetica-Bold", BYVAL %NULL)

   ' /* add a new page object. */
   hPage = HPDF_AddPage (pdf)

   HPDF_Page_SetFontAndSize (hPage, hFont, 10)

   HPDF_Page_SetHeight (hPage, PAGE_HEIGHT)
   HPDF_Page_SetWidth (hPage, PAGE_WIDTH)

   ' /* normal */
   HPDF_Page_GSave (hPage)
   draw_circles (hPage, "normal", 40.0!, PAGE_HEIGHT - 170)
   HPDF_Page_GRestore (hPage)

   ' /* transparency (0.8) */
   HPDF_Page_GSave (hPage)
   gstate = HPDF_CreateExtGState (pdf)
   HPDF_ExtGState_SetAlphaFill (gstate, 0.8)
   HPDF_ExtGState_SetAlphaStroke (gstate, 0.8)
   HPDF_Page_SetExtGState (hPage, gstate)
   draw_circles (hPage, "alpha fill = 0.8", 230.0!, PAGE_HEIGHT - 170)
   HPDF_Page_GRestore (hPage)

   ' /* transparency (0.4) */
   HPDF_Page_GSave (hPage)
   gstate = HPDF_CreateExtGState (pdf)
   HPDF_ExtGState_SetAlphaFill (gstate, 0.4)
   HPDF_Page_SetExtGState (hPage, gstate)
   draw_circles (hPage, "alpha fill = 0.4", 420.0!, PAGE_HEIGHT - 170)
   HPDF_Page_GRestore (hPage)

   ' /* blend-mode=HPDF_BM_MULTIPLY */
   HPDF_Page_GSave (hPage)
   gstate = HPDF_CreateExtGState (pdf)
   HPDF_ExtGState_SetBlendMode (gstate, %HPDF_BM_MULTIPLY)
   HPDF_Page_SetExtGState (hPage, gstate)
   draw_circles (hPage, "HPDF_BM_MULTIPLY", 40.0!, PAGE_HEIGHT - 340)
   HPDF_Page_GRestore (hPage)

   ' /* blend-mode=HPDF_BM_SCREEN */
   HPDF_Page_GSave (hPage)
   gstate = HPDF_CreateExtGState (pdf)
   HPDF_ExtGState_SetBlendMode (gstate, %HPDF_BM_SCREEN)
   HPDF_Page_SetExtGState (hPage, gstate)
   draw_circles (hPage, "HPDF_BM_SCREEN", 230.0!, PAGE_HEIGHT - 340)
   HPDF_Page_GRestore (hPage)

   ' /* blend-mode=HPDF_BM_OVERLAY */
   HPDF_Page_GSave (hPage)
   gstate = HPDF_CreateExtGState (pdf)
   HPDF_ExtGState_SetBlendMode (gstate, %HPDF_BM_OVERLAY)
   HPDF_Page_SetExtGState (hPage, gstate)
   draw_circles (hPage, "HPDF_BM_OVERLAY", 420.0!, PAGE_HEIGHT - 340)
   HPDF_Page_GRestore (hPage)

   ' /* blend-mode=HPDF_BM_DARKEN */
   HPDF_Page_GSave (hPage)
   gstate = HPDF_CreateExtGState (pdf)
   HPDF_ExtGState_SetBlendMode (gstate, %HPDF_BM_DARKEN)
   HPDF_Page_SetExtGState (hPage, gstate)
   draw_circles (hPage, "HPDF_BM_DARKEN", 40.0!, PAGE_HEIGHT - 510)
   HPDF_Page_GRestore (hPage)

   ' /* blend-mode=HPDF_BM_LIGHTEN */
   HPDF_Page_GSave (hPage)
   gstate = HPDF_CreateExtGState (pdf)
   HPDF_ExtGState_SetBlendMode (gstate, %HPDF_BM_LIGHTEN)
   HPDF_Page_SetExtGState (hPage, gstate)
   draw_circles (hPage, "HPDF_BM_LIGHTEN", 230.0!, PAGE_HEIGHT - 510)
   HPDF_Page_GRestore (hPage)

   ' /* blend-mode=HPDF_BM_COLOR_DODGE */
   HPDF_Page_GSave (hPage)
   gstate = HPDF_CreateExtGState (pdf)
   HPDF_ExtGState_SetBlendMode (gstate, %HPDF_BM_COLOR_DODGE)
   HPDF_Page_SetExtGState (hPage, gstate)
   draw_circles (hPage, "HPDF_BM_COLOR_DODGE", 420.0!, PAGE_HEIGHT - 510)
   HPDF_Page_GRestore (hPage)

   ' /* blend-mode=HPDF_BM_COLOR_BUM */
   HPDF_Page_GSave (hPage)
   gstate = HPDF_CreateExtGState (pdf)
   HPDF_ExtGState_SetBlendMode (gstate, %HPDF_BM_COLOR_BUM)
   HPDF_Page_SetExtGState (hPage, gstate)
   draw_circles (hPage, "HPDF_BM_COLOR_BUM", 40.0!, PAGE_HEIGHT - 680)
   HPDF_Page_GRestore (hPage)

   ' /* blend-mode=HPDF_BM_HARD_LIGHT */
   HPDF_Page_GSave (hPage)
   gstate = HPDF_CreateExtGState (pdf)
   HPDF_ExtGState_SetBlendMode (gstate, %HPDF_BM_HARD_LIGHT)
   HPDF_Page_SetExtGState (hPage, gstate)
   draw_circles (hPage, "HPDF_BM_HARD_LIGHT", 230.0!, PAGE_HEIGHT - 680)
   HPDF_Page_GRestore (hPage)

   ' /* blend-mode=HPDF_BM_SOFT_LIGHT */
   HPDF_Page_GSave (hPage)
   gstate = HPDF_CreateExtGState (pdf)
   HPDF_ExtGState_SetBlendMode (gstate, %HPDF_BM_SOFT_LIGHT)
   HPDF_Page_SetExtGState (hPage, gstate)
   draw_circles (hPage, "HPDF_BM_SOFT_LIGHT", 420.0!, PAGE_HEIGHT - 680)
   HPDF_Page_GRestore (hPage)

   ' /* blend-mode=HPDF_BM_DIFFERENCE */
   HPDF_Page_GSave (hPage)
   gstate = HPDF_CreateExtGState (pdf)
   HPDF_ExtGState_SetBlendMode (gstate, %HPDF_BM_DIFFERENCE)
   HPDF_Page_SetExtGState (hPage, gstate)
   draw_circles (hPage, "HPDF_BM_DIFFERENCE", 40.0!, PAGE_HEIGHT - 850)
   HPDF_Page_GRestore (hPage)

   ' /* blend-mode=HPDF_BM_EXCLUSHON */
   HPDF_Page_GSave (hPage)
   gstate = HPDF_CreateExtGState (pdf)
   HPDF_ExtGState_SetBlendMode (gstate, %HPDF_BM_EXCLUSHON)
   HPDF_Page_SetExtGState (hPage, gstate)
   draw_circles (hPage, "HPDF_BM_EXCLUSHON", 230.0!, PAGE_HEIGHT - 850)
   HPDF_Page_GRestore (hPage)


   ' /* save the document to a file */
   HPDF_SaveToFile (pdf, fname)

   ' /* clean up */
   HPDF_Free (pdf)

   ? "Document created"

END FUNCTION
' ========================================================================================
