' ########################################################################################
' * << Haru Free PDF Library 2.0.0 >> -- font_demo.bas
' * It is provided "as is" without express or implied warranty.
' ########################################################################################

' SED_PBWIN - Use the PBWIN compiler
#COMPILE EXE
#DIM ALL
#INCLUDE ONCE "windows.inc"
#INCLUDE ONCE "hpdf.inc"

' ========================================================================================
' Callback error handler procedure
' ========================================================================================
SUB HPDF_Error_Handler HPDF_CALLCONV() ( _
   BYVAL error_no AS HPDF_STATUS, _
   BYVAL detail_no AS HPDF_STATUS, _
   BYVAL user_data AS DWORD)

   LOCAL strMsg AS STRING

   strMsg = "Error number = " & STR$(error_no) & " [&H" & HEX$(error_no) & "]" & $CRLF
   strMsg = strMsg & "Detail number = " & STR$(detail_no) & " [&H" & HEX$(detail_no) & "]"
   ? strMsg

END SUB
' ========================================================================================

' ========================================================================================
' Main
' ========================================================================================
FUNCTION PBMAIN

   LOCAL pdf AS HPDF_Doc
   LOCAL fname AS ASCIIZ * 256
   LOCAL hPage AS HPDF_Page
   LOCAL def_font AS HPDF_Font
   LOCAL tw AS HPDF_REAL
   LOCAL nHeight AS HPDF_REAL
   LOCAL nWidth AS HPDF_REAL
   LOCAL i AS LONG
   LOCAL hFont AS HPDF_Font
   LOCAL page_title AS ASCIIZ * 256
   LOCAL samp_text AS ASCIIZ * 256
   DIM   font_list(0 TO 13) AS ASCIIZ * 256

   page_title = "Font Demo"
   samp_text = "abcdefgABCDEFG12345!#$%&+-@?"
   fname = "font_demo.pdf"

   ARRAY ASSIGN font_list() = "Courier", "Courier-Bold", "Courier-Oblique", "Courier-BoldOblique", _
         "Helvetica", "Helvetica-Bold", "Helvetica-Oblique", "Helvetica-BoldOblique", _
         "Times-Roman", "Times-Bold", "Times-Italic", "Times-BoldItalic", "Symbol", "ZapfDingbats"

   pdf = HPDF_New(CODEPTR(HPDF_Error_Handler), %NULL)
   IF pdf = %NULL THEN
      ? "Error: cannot create PdfDoc object"
      EXIT FUNCTION
   END IF

   ' /* Add a new page object. */
   hPage = HPDF_AddPage (pdf)

   nHeight = HPDF_Page_GetHeight (hPage)
   nWidth = HPDF_Page_GetWidth (hPage)

   ' /* Print the lines of the page. */
   HPDF_Page_SetLineWidth (hPage, 1)
   HPDF_Page_Rectangle (hPage, 50, 50, nWidth - 100, nHeight - 110)
   HPDF_Page_Stroke (hPage)

   ' /* Print the title of the page (with positioning center). */
   def_font = HPDF_GetFont (pdf, "Helvetica", BYVAL %NULL)
   HPDF_Page_SetFontAndSize (hPage, def_font, 24)

   tw = HPDF_Page_TextWidth (hPage, page_title)
   HPDF_Page_BeginText (hPage)
   HPDF_Page_TextOut (hPage, (nWidth - tw) / 2, nHeight - 50, page_title)
   HPDF_Page_EndText (hPage)

   ' /* output subtitle. */
   HPDF_Page_BeginText (hPage)
   HPDF_Page_SetFontAndSize (hPage, def_font, 16)
   HPDF_Page_TextOut (hPage, 60, nHeight - 80, "<Standard Type1 fonts samples>")
   HPDF_Page_EndText (hPage)

   HPDF_Page_BeginText (hPage)
   HPDF_Page_MoveTextPos (hPage, 60, nHeight - 105)

    FOR i = LBOUND(font_list) TO UBOUND(font_list)
      hFont = HPDF_GetFont (pdf, font_list(i), BYVAL %NULL)
      ' /* print a label of text */
      HPDF_Page_SetFontAndSize (hPage, def_font, 9)
      HPDF_Page_ShowText (hPage, font_list(i))
      HPDF_Page_MoveTextPos (hPage, 0, -18)
      ' /* print a sample text. */
      HPDF_Page_SetFontAndSize (hPage, hFont, 20)
      HPDF_Page_ShowText (hPage, samp_text)
      HPDF_Page_MoveTextPos (hPage, 0, -20)
   NEXT

   HPDF_Page_EndText (hPage)

   HPDF_SaveToFile (pdf, fname)

   ' /* clean up */
   HPDF_Free (pdf)

   ? "Document created"

END FUNCTION
' ========================================================================================
