' ########################################################################################
' * << Haru Free PDF Library 2.0.10 >> -- grid_sheet.inc
' * It is provided "as is" without express or implied warranty.
' ########################################################################################

' ========================================================================================
' Prints the grid
' ========================================================================================
SUB print_grid (BYVAL pdf AS HPDF_Doc, BYVAL hPage AS DWORD)

   LOCAL nHeight AS HPDF_REAL
   LOCAL nWidth AS HPDF_REAL
   LOCAL hFont AS HPDF_Font
   LOCAL x AS HPDF_UINT
   LOCAL y AS HPDF_UINT
   LOCAL buf AS ASCIIZ * 12

   nHeight = HPDF_Page_GetHeight (hPage)
   nWidth = HPDF_Page_GetWidth (hPage)
   hFont = HPDF_GetFont (pdf, "Helvetica", BYVAL %NULL)

   HPDF_Page_SetFontAndSize (hPage, hFont, 5)
   HPDF_Page_SetGrayFill (hPage, 0.5)
   HPDF_Page_SetGrayStroke (hPage, 0.8)

   ' /* Draw horizontal lines */
   y = 0
   WHILE (y < nHeight)
      IF (y MOD 10 = 0) THEN
         HPDF_Page_SetLineWidth (hPage, 0.5)
      ELSE
         IF (HPDF_Page_GetLineWidth (hPage) <> 0.25) THEN _
            HPDF_Page_SetLineWidth (hPage, 0.25)
      END IF

      HPDF_Page_MoveTo (hPage, 0, y)
      HPDF_Page_LineTo (hPage, nWidth, y)
      HPDF_Page_Stroke (hPage)

      IF (y MOD 10 = 0 AND y > 0) THEN
         HPDF_Page_SetGrayStroke (hPage, 0.5)

         HPDF_Page_MoveTo (hPage, 0, y)
         HPDF_Page_LineTo (hPage, 5, y)
         HPDF_Page_Stroke (hPage)

         HPDF_Page_SetGrayStroke (hPage, 0.8)
      END IF

      y = y + 5
   WEND


   ' /* Draw virtical lines */
   x = 0
   WHILE (x < nWidth)
      IF (x MOD 10 = 0) THEN
         HPDF_Page_SetLineWidth (hPage, 0.5)
      ELSE
         IF (HPDF_Page_GetLineWidth (hPage) <> 0.25) THEN _
            HPDF_Page_SetLineWidth (hPage, 0.25)
      END IF

      HPDF_Page_MoveTo (hPage, x, 0)
      HPDF_Page_LineTo (hPage, x, nHeight)
      HPDF_Page_Stroke (hPage)

      IF (x MOD 50 = 0 AND x > 0) THEN
         HPDF_Page_SetGrayStroke (hPage, 0.5)

         HPDF_Page_MoveTo (hPage, x, 0)
         HPDF_Page_LineTo (hPage, x, 5)
         HPDF_Page_Stroke (hPage)

         HPDF_Page_MoveTo (hPage, x, nHeight)
         HPDF_Page_LineTo (hPage, x, nHeight - 5)
         HPDF_Page_Stroke (hPage)

         HPDF_Page_SetGrayStroke (hPage, 0.8)
      END IF

      x = x + 5
   WEND

   ' /* Draw horizontal text */
   y = 0
   WHILE (y < nHeight)
      IF (y MOD 10 = 0 AND y > 0) THEN
         HPDF_Page_BeginText (hPage)
         HPDF_Page_MoveTextPos (hPage, 5, y - 2)
         buf = FORMAT$(y)
         HPDF_Page_ShowText (hPage, buf)
         HPDF_Page_EndText (hPage)
      END IF

      y = y + 5
   WEND


   ' /* Draw virtical text */
   x = 0
   WHILE (x < nWidth)
      IF (x MOD 50 = 0 AND x > 0) THEN
         HPDF_Page_BeginText (hPage)
         HPDF_Page_MoveTextPos (hPage, x, 5)
         buf = FORMAT$(x)
         HPDF_Page_ShowText (hPage, buf)
         HPDF_Page_EndText (hPage)

         HPDF_Page_BeginText (hPage)
         HPDF_Page_MoveTextPos (hPage, x, nHeight - 10)
         HPDF_Page_ShowText (hPage, buf)
         HPDF_Page_EndText (hPage)
      END IF

      x = x + 5
   WEND

   HPDF_Page_SetGrayFill (hPage, 0)
   HPDF_Page_SetGrayStroke (hPage, 0)

END SUB
' ========================================================================================
