'/*
' * << Haru Free PDF Library 2.1.0 >> -- hpdf.h
' *
' * URL http://libharu.org
' *
' * Copyright (c) 1999-2006 Takeshi Kanno <takeshi_kanno@est.hi-ho.ne.jp>
' * Copyright (c) 2007-2008 Antony Dovgal <tony@daylessday.org>
' *
' * Permission to use, copy, modify, distribute and sell this software
' * and its documentation for any purpose is hereby granted without fee,
' * provided that the above copyright notice appear in all copies and
' * that both that copyright notice and this permission notice appear
' * in supporting documentation.
' * It is provided "as is" without express or implied warranty.
' *
' */

#IF NOT %DEF(%HPDF_INC)
    %HPDF_INC = 1

#INCLUDE ONCE "hpdf_types.inc"
#INCLUDE ONCE "hpdf_consts.inc"

MACRO HPDF_CALLCONV = CDECL

MACRO HPDF_HANDLE      = DWORD         ' void
MACRO HPDF_Doc         = HPDF_HANDLE
MACRO HPDF_Page        = HPDF_HANDLE
MACRO HPDF_Pages       = HPDF_HANDLE
MACRO HPDF_Stream      = HPDF_HANDLE
MACRO HPDF_Image       = HPDF_HANDLE
MACRO HPDF_Font        = HPDF_HANDLE
MACRO HPDF_Outline     = HPDF_HANDLE
MACRO HPDF_Encoder     = HPDF_HANDLE
MACRO HPDF_Destination = HPDF_HANDLE
MACRO HPDF_XObject     = HPDF_HANDLE
MACRO HPDF_Annotation  = HPDF_HANDLE
MACRO HPDF_ExtGState   = HPDF_HANDLE

' ========================================================================================
DECLARE FUNCTION HPDF_GetVersion HPDF_CALLCONV LIB "LIBHPDF.DLL" ALIAS "HPDF_GetVersion" ( _
 ) AS DWORD                                   ' char *
' ========================================================================================

' ========================================================================================
DECLARE FUNCTION HPDF_NewEx HPDF_CALLCONV LIB "LIBHPDF.DLL" ALIAS "HPDF_NewEx" ( _
   BYVAL DWORD _                              ' HPDF_Error_Handler   user_error_fn
 , BYVAL DWORD _                              ' HPDF_Alloc_Func      user_alloc_fn
 , BYVAL DWORD _                              ' HPDF_Free_Func       user_free_fn
 , BYVAL HPDF_UINT _                          ' HPDF_UINT            mem_pool_buf_size
 , BYVAL DWORD _                              ' void                *user_data
 ) AS HPDF_Doc                                ' HPDF_Doc
' ========================================================================================

' ========================================================================================
DECLARE FUNCTION HPDF_New HPDF_CALLCONV LIB "LIBHPDF.DLL" ALIAS "HPDF_New" ( _
   BYVAL DWORD _                              ' HPDF_Error_Handler  user_error_fn
 , BYVAL DWORD _                              ' void               *user_data
 ) AS HPDF_Doc                                ' HPDF_Doc
' ========================================================================================

' ========================================================================================
DECLARE FUNCTION HPDF_SetErrorHandler HPDF_CALLCONV LIB "LIBHPDF.DLL" ALIAS "HPDF_SetErrorHandler" ( _
   BYVAL HPDF_Doc _                           ' HPDF_Doc            pdf
 , BYVAL DWORD _                              ' HPDF_Error_Handler  user_error_fn
 ) AS HPDF_STATUS                             ' HPDF_STATUS
' ========================================================================================

' ========================================================================================
DECLARE SUB HPDF_Free HPDF_CALLCONV LIB "LIBHPDF.DLL" ALIAS "HPDF_Free" ( _
   BYVAL HPDF_Doc _                           ' HPDF_Doc  pdf
 )                                            ' void
' ========================================================================================

' ========================================================================================
DECLARE FUNCTION HPDF_NewDoc HPDF_CALLCONV LIB "LIBHPDF.DLL" ALIAS "HPDF_NewDoc" ( _
   BYVAL HPDF_Doc _                           ' HPDF_Doc  pdf
 ) AS HPDF_STATUS                             ' HPDF_STATUS
' ========================================================================================

' ========================================================================================
DECLARE SUB HPDF_FreeDoc HPDF_CALLCONV LIB "LIBHPDF.DLL" ALIAS "HPDF_FreeDoc" ( _
   BYVAL HPDF_Doc _                           ' HPDF_Doc  pdf
 )                                            ' void
' ========================================================================================

' ========================================================================================
DECLARE FUNCTION HPDF_HasDoc HPDF_CALLCONV LIB "LIBHPDF.DLL" ALIAS "HPDF_HasDoc" ( _
   BYVAL HPDF_Doc _                           ' HPDF_Doc  pdf
 ) AS HPDF_BOOL                               ' HPDF_BOOL
' ========================================================================================

' ========================================================================================
DECLARE SUB HPDF_FreeDocAll HPDF_CALLCONV LIB "LIBHPDF.DLL" ALIAS "HPDF_FreeDocAll" ( _
   BYVAL HPDF_Doc _                           ' HPDF_Doc  pdf
 )                                            ' void
' ========================================================================================

' ========================================================================================
DECLARE FUNCTION HPDF_SaveToStream HPDF_CALLCONV LIB "LIBHPDF.DLL" ALIAS "HPDF_SaveToStream" ( _
   BYVAL HPDF_Doc _                           ' HPDF_Doc   pdf
 ) AS HPDF_STATUS                             ' HPDF_STATUS
' ========================================================================================

' ========================================================================================
DECLARE FUNCTION HPDF_GetStreamSize HPDF_CALLCONV LIB "LIBHPDF.DLL" ALIAS "HPDF_GetStreamSize" ( _
   BYVAL HPDF_Doc _                           ' HPDF_Doc   pdf
 ) AS HPDF_UINT32                             ' HPDF_UINT32
' ========================================================================================

' ========================================================================================
DECLARE FUNCTION HPDF_ReadFromStream HPDF_CALLCONV LIB "LIBHPDF.DLL" ALIAS "HPDF_ReadFromStream" ( _
   BYVAL HPDF_Doc _                           ' HPDF_Doc       pdf
 , BYREF HPDF_BYTE _                          ' HPDF_BYTE     *buf
 , BYREF HPDF_UINT32 _                        ' HPDF_UINT32   *size
 ) AS HPDF_STATUS                             ' HPDF_STATUS
' ========================================================================================

' ========================================================================================
DECLARE FUNCTION HPDF_ResetStream HPDF_CALLCONV LIB "LIBHPDF.DLL" ALIAS "HPDF_ResetStream" ( _
   BYVAL HPDF_Doc _                           ' HPDF_Doc     pdf
 ) AS HPDF_STATUS                             ' HPDF_STATUS
' ========================================================================================

' ========================================================================================
DECLARE FUNCTION HPDF_SaveToFile HPDF_CALLCONV LIB "LIBHPDF.DLL" ALIAS "HPDF_SaveToFile" ( _
   BYVAL HPDF_Doc _                           ' HPDF_Doc     pdf
 , BYREF ASCIIZ _                             ' const char  *file_name
 ) AS HPDF_STATUS                             ' HPDF_STATUS
' ========================================================================================

' ========================================================================================
DECLARE FUNCTION HPDF_GetError HPDF_CALLCONV LIB "LIBHPDF.DLL" ALIAS "HPDF_GetError" ( _
   BYVAL HPDF_Doc _                           ' HPDF_Doc   pdf
 ) AS HPDF_STATUS                             ' HPDF_STATUS
' ========================================================================================

' ========================================================================================
DECLARE FUNCTION HPDF_GetErrorDetail HPDF_CALLCONV LIB "LIBHPDF.DLL" ALIAS "HPDF_GetErrorDetail" ( _
   BYVAL HPDF_Doc _                           ' HPDF_Doc   pdf
 ) AS HPDF_STATUS                             ' HPDF_STATUS
' ========================================================================================

' ========================================================================================
DECLARE SUB HPDF_ResetError HPDF_CALLCONV LIB "LIBHPDF.DLL" ALIAS "HPDF_ResetError" ( _
   BYVAL HPDF_Doc _                           ' HPDF_Doc   pdf
 )                                            ' void
' ========================================================================================

' ========================================================================================
DECLARE FUNCTION HPDF_SetPagesConfiguration HPDF_CALLCONV LIB "LIBHPDF.DLL" ALIAS "HPDF_SetPagesConfiguration" ( _
   BYVAL HPDF_Doc _                           ' HPDF_Doc   pdf
 , BYVAL HPDF_UINT _                          ' HPDF_UINT  page_per_pages
 ) AS HPDF_STATUS                             ' HPDF_STATUS
' ========================================================================================

' ========================================================================================
DECLARE FUNCTION HPDF_GetPageByIndex HPDF_CALLCONV LIB "LIBHPDF.DLL" ALIAS "HPDF_GetPageByIndex" ( _
   BYVAL HPDF_Doc _                           ' HPDF_Doc   pdf
 , BYVAL HPDF_UINT _                          ' HPDF_UINT  index
 ) AS HPDF_Page                               ' HPDF_Page
' ========================================================================================

'/*---------------------------------------------------------------------------*/
'/*---------------------------------------------------------------------------*/

' ========================================================================================
DECLARE FUNCTION HPDF_GetPageLayout HPDF_CALLCONV LIB "LIBHPDF.DLL" ALIAS "HPDF_GetPageLayout" ( _
   BYVAL HPDF_Doc _                           ' HPDF_Doc   pdf
 ) AS HPDF_PageLayout                         ' HPDF_PageLayout
' ========================================================================================

' ========================================================================================
DECLARE FUNCTION HPDF_SetPageLayout HPDF_CALLCONV LIB "LIBHPDF.DLL" ALIAS "HPDF_SetPageLayout" ( _
   BYVAL HPDF_Doc _                           ' HPDF_Doc          pdf
 , BYVAL HPDF_PageLayout _                    ' HPDF_PageLayout   layout
 ) AS HPDF_STATUS                             ' HPDF_STATUS
' ========================================================================================

' ========================================================================================
DECLARE FUNCTION HPDF_GetPageMode HPDF_CALLCONV LIB "LIBHPDF.DLL" ALIAS "HPDF_GetPageMode" ( _
   BYVAL HPDF_Doc _                           ' HPDF_Doc   pdf
 ) AS HPDF_PageMode                           ' HPDF_PageMode
' ========================================================================================

' ========================================================================================
DECLARE FUNCTION HPDF_SetPageMode HPDF_CALLCONV LIB "LIBHPDF.DLL" ALIAS "HPDF_SetPageMode" ( _
   BYVAL HPDF_Doc _                           ' HPDF_Doc        pdf
 , BYVAL HPDF_PageMode _                      ' HPDF_PageMode   mode
 ) AS HPDF_STATUS                             ' HPDF_STATUS
' ========================================================================================

' ========================================================================================
DECLARE FUNCTION HPDF_GetViewerPreference HPDF_CALLCONV LIB "LIBHPDF.DLL" ALIAS "HPDF_GetViewerPreference" ( _
   BYVAL HPDF_Doc _                           ' HPDF_Doc   pdf
 ) AS HPDF_UINT                               ' HPDF_UINT
' ========================================================================================

' ========================================================================================
DECLARE FUNCTION HPDF_SetViewerPreference HPDF_CALLCONV LIB "LIBHPDF.DLL" ALIAS "HPDF_SetViewerPreference" ( _
   BYVAL HPDF_Doc _                           ' HPDF_Doc     pdf
 , BYVAL HPDF_UINT _                          ' HPDF_UINT    value
 ) AS HPDF_STATUS                             ' HPDF_STATUS
' ========================================================================================

' ========================================================================================
DECLARE FUNCTION HPDF_SetOpenAction HPDF_CALLCONV LIB "LIBHPDF.DLL" ALIAS "HPDF_SetOpenAction" ( _
   BYVAL HPDF_Doc _                           ' HPDF_Doc           pdf
 , BYVAL HPDF_Destination _                   ' HPDF_Destination   open_action
 ) AS HPDF_STATUS                             ' HPDF_STATUS
' ========================================================================================

'/*---------------------------------------------------------------------------*/
'/*----- page handling -------------------------------------------------------*/

' ========================================================================================
DECLARE FUNCTION HPDF_GetCurrentPage HPDF_CALLCONV LIB "LIBHPDF.DLL" ALIAS "HPDF_GetCurrentPage" ( _
   BYVAL HPDF_Doc _                           ' HPDF_Doc   pdf
 ) AS HPDF_Page                               ' HPDF_Page
' ========================================================================================

' ========================================================================================
DECLARE FUNCTION HPDF_AddPage HPDF_CALLCONV LIB "LIBHPDF.DLL" ALIAS "HPDF_AddPage" ( _
   BYVAL HPDF_Doc _                           ' HPDF_Doc   pdf
 ) AS HPDF_Page                               ' HPDF_Page
' ========================================================================================

' ========================================================================================
DECLARE FUNCTION HPDF_InsertPage HPDF_CALLCONV LIB "LIBHPDF.DLL" ALIAS "HPDF_InsertPage" ( _
   BYVAL HPDF_Doc _                           ' HPDF_Doc   pdf
 , BYVAL HPDF_Page _                          ' HPDF_Page  page
 ) AS HPDF_Page                               ' HPDF_Page
' ========================================================================================

' ========================================================================================
DECLARE FUNCTION HPDF_Page_SetWidth HPDF_CALLCONV LIB "LIBHPDF.DLL" ALIAS "HPDF_Page_SetWidth" ( _
   BYVAL HPDF_Page _                          ' HPDF_Page   page
 , BYVAL HPDF_REAL _                          ' HPDF_REAL   value
 ) AS HPDF_STATUS                             ' HPDF_STATUS
' ========================================================================================

' ========================================================================================
DECLARE FUNCTION HPDF_Page_SetHeight HPDF_CALLCONV LIB "LIBHPDF.DLL" ALIAS "HPDF_Page_SetHeight" ( _
   BYVAL HPDF_Page _                          ' HPDF_Page   page
 , BYVAL HPDF_REAL _                          ' HPDF_REAL   value
 ) AS HPDF_STATUS                             ' HPDF_STATUS
' ========================================================================================

' ========================================================================================
DECLARE FUNCTION HPDF_Page_SetSize HPDF_CALLCONV LIB "LIBHPDF.DLL" ALIAS "HPDF_Page_SetSize" ( _
   BYVAL HPDF_Page _                          ' HPDF_Page            page
 , BYVAL HPDF_PageSizes _                     ' HPDF_PageSizes       size
 , BYVAL HPDF_PageDirection _                 ' HPDF_PageDirection   direction
 ) AS HPDF_STATUS                             ' HPDF_STATUS
' ========================================================================================

' ========================================================================================
DECLARE FUNCTION HPDF_Page_SetRotate HPDF_CALLCONV LIB "LIBHPDF.DLL" ALIAS "HPDF_Page_SetRotate" ( _
   BYVAL HPDF_Page _                          ' HPDF_Page     page
 , BYVAL HPDF_UINT16 _                        ' HPDF_UINT16   angle
 ) AS HPDF_STATUS                             ' HPDF_STATUS
' ========================================================================================

'/*---------------------------------------------------------------------------*/
'/*----- font handling -------------------------------------------------------*/


' ========================================================================================
DECLARE FUNCTION HPDF_GetFont HPDF_CALLCONV LIB "LIBHPDF.DLL" ALIAS "HPDF_GetFont" ( _
   BYVAL HPDF_Doc _                           ' HPDF_Doc     pdf
 , BYREF ASCIIZ _                             ' const char  *font_name
 , BYREF ASCIIZ _                             ' const char  *encoding_name
 ) AS HPDF_Font                               ' HPDF_Font
' ========================================================================================

' ========================================================================================
DECLARE FUNCTION HPDF_LoadType1FontFromFile HPDF_CALLCONV LIB "LIBHPDF.DLL" ALIAS "HPDF_LoadType1FontFromFile" ( _
   BYVAL HPDF_Doc _                           ' HPDF_Doc     pdf
 , BYREF ASCIIZ _                             ' const char  *afm_file_name
 , BYREF ASCIIZ _                             ' const char  *data_file_name
 ) AS DWORD                                   ' const char*
' ========================================================================================

' ========================================================================================
DECLARE FUNCTION HPDF_LoadTTFontFromFile HPDF_CALLCONV LIB "LIBHPDF.DLL" ALIAS "HPDF_LoadTTFontFromFile" ( _
   BYVAL HPDF_Doc _                           ' HPDF_Doc     pdf
 , BYREF ASCIIZ _                             ' const char  *file_name
 , BYVAL HPDF_BOOL _                          ' HPDF_BOOL    embedding
 ) AS DWORD                                   ' const char*
' ========================================================================================

' ========================================================================================
DECLARE FUNCTION HPDF_LoadTTFontFromFile2 HPDF_CALLCONV LIB "LIBHPDF.DLL" ALIAS "HPDF_LoadTTFontFromFile2" ( _
   BYVAL HPDF_Doc _                           ' HPDF_Doc     pdf
 , BYREF ASCIIZ _                             ' const char  *file_name
 , BYVAL HPDF_UINT _                          ' HPDF_UINT    index
 , BYVAL HPDF_BOOL _                          ' HPDF_BOOL    embedding
 ) AS DWORD                                   ' const char*
' ========================================================================================

' ========================================================================================
DECLARE FUNCTION HPDF_AddPageLabel HPDF_CALLCONV LIB "LIBHPDF.DLL" ALIAS "HPDF_AddPageLabel" ( _
   BYVAL HPDF_Doc _                           ' HPDF_Doc            pdf
 , BYVAL HPDF_UINT _                          ' HPDF_UINT           page_num
 , BYVAL HPDF_PageNumStyle _                  ' HPDF_PageNumStyle   style
 , BYVAL HPDF_UINT _                          ' HPDF_UINT           first_page
 , BYREF ASCIIZ _                             ' const char         *prefix
 ) AS HPDF_STATUS                             ' HPDF_STATUS
' ========================================================================================

' ========================================================================================
DECLARE FUNCTION HPDF_UseJPFonts HPDF_CALLCONV LIB "LIBHPDF.DLL" ALIAS "HPDF_UseJPFonts" ( _
   BYVAL HPDF_Doc _                           ' HPDF_Doc   pdf
 ) AS HPDF_STATUS                             ' HPDF_STATUS
' ========================================================================================

' ========================================================================================
DECLARE FUNCTION HPDF_UseKRFonts HPDF_CALLCONV LIB "LIBHPDF.DLL" ALIAS "HPDF_UseKRFonts" ( _
   BYVAL HPDF_Doc _                           ' HPDF_Doc   pdf
 ) AS HPDF_STATUS                             ' HPDF_STATUS
' ========================================================================================

' ========================================================================================
DECLARE FUNCTION HPDF_UseCNSFonts HPDF_CALLCONV LIB "LIBHPDF.DLL" ALIAS "HPDF_UseCNSFonts" ( _
   BYVAL HPDF_Doc _                           ' HPDF_Doc   pdf
 ) AS HPDF_STATUS                             ' HPDF_STATUS
' ========================================================================================

' ========================================================================================
DECLARE FUNCTION HPDF_UseCNTFonts HPDF_CALLCONV LIB "LIBHPDF.DLL" ALIAS "HPDF_UseCNTFonts" ( _
   BYVAL HPDF_Doc _                           ' HPDF_Doc   pdf
 ) AS HPDF_STATUS                             ' HPDF_STATUS
' ========================================================================================

'/*--------------------------------------------------------------------------*/
'/*----- outline ------------------------------------------------------------*/

' ========================================================================================
DECLARE FUNCTION HPDF_CreateOutline HPDF_CALLCONV LIB "LIBHPDF.DLL" ALIAS "HPDF_CreateOutline" ( _
   BYVAL HPDF_Doc _                           ' HPDF_Doc       pdf
 , BYVAL HPDF_Outline _                       ' HPDF_Outline   parent
 , BYREF ASCIIZ _                             ' const char    *title
 , BYVAL HPDF_Encoder _                       ' HPDF_Encoder   encoder
 ) AS HPDF_Outline                            ' HPDF_Outline
' ========================================================================================

' ========================================================================================
DECLARE FUNCTION HPDF_Outline_SetOpened HPDF_CALLCONV LIB "LIBHPDF.DLL" ALIAS "HPDF_Outline_SetOpened" ( _
   BYVAL HPDF_Outline _                       ' HPDF_Outline  outline
 , BYVAL HPDF_BOOL _                          ' HPDF_BOOL     opened
 ) AS HPDF_STATUS                             ' HPDF_STATUS
' ========================================================================================

' ========================================================================================
DECLARE FUNCTION HPDF_Outline_SetDestination HPDF_CALLCONV LIB "LIBHPDF.DLL" ALIAS "HPDF_Outline_SetDestination" ( _
   BYVAL HPDF_Outline _                       ' HPDF_Outline      outline
 , BYVAL HPDF_Destination _                   ' HPDF_Destination  dst
 ) AS HPDF_STATUS                             ' HPDF_STATUS
' ========================================================================================

'/*--------------------------------------------------------------------------*/
'/*----- destination --------------------------------------------------------*/

' ========================================================================================
DECLARE FUNCTION HPDF_Page_CreateDestination HPDF_CALLCONV LIB "LIBHPDF.DLL" ALIAS "HPDF_Page_CreateDestination" ( _
   BYVAL HPDF_Page _                          ' HPDF_Page   page
 ) AS HPDF_Destination                        ' HPDF_Destination
' ========================================================================================

' ========================================================================================
DECLARE FUNCTION HPDF_Destination_SetXYZ HPDF_CALLCONV LIB "LIBHPDF.DLL" ALIAS "HPDF_Destination_SetXYZ" ( _
   BYVAL HPDF_Destination _                   ' HPDF_Destination  dst
 , BYVAL HPDF_REAL _                          ' HPDF_REAL         left
 , BYVAL HPDF_REAL _                          ' HPDF_REAL         top
 , BYVAL HPDF_REAL _                          ' HPDF_REAL         zoom
 ) AS HPDF_STATUS                             ' HPDF_STATUS
' ========================================================================================

' ========================================================================================
DECLARE FUNCTION HPDF_Destination_SetFit HPDF_CALLCONV LIB "LIBHPDF.DLL" ALIAS "HPDF_Destination_SetFit" ( _
   BYVAL HPDF_Destination _                   ' HPDF_Destination  dst
 ) AS HPDF_STATUS                             ' HPDF_STATUS
' ========================================================================================

' ========================================================================================
DECLARE FUNCTION HPDF_Destination_SetFitH HPDF_CALLCONV LIB "LIBHPDF.DLL" ALIAS "HPDF_Destination_SetFitH" ( _
   BYVAL HPDF_Destination _                   ' HPDF_Destination  dst
 , BYVAL HPDF_REAL _                          ' HPDF_REAL         top
 ) AS HPDF_STATUS                             ' HPDF_STATUS
' ========================================================================================

' ========================================================================================
DECLARE FUNCTION HPDF_Destination_SetFitV HPDF_CALLCONV LIB "LIBHPDF.DLL" ALIAS "HPDF_Destination_SetFitV" ( _
   BYVAL HPDF_Destination _                   ' HPDF_Destination  dst
 , BYVAL HPDF_REAL _                          ' HPDF_REAL         left
 ) AS HPDF_STATUS                             ' HPDF_STATUS
' ========================================================================================

' ========================================================================================
DECLARE FUNCTION HPDF_Destination_SetFitR HPDF_CALLCONV LIB "LIBHPDF.DLL" ALIAS "HPDF_Destination_SetFitR" ( _
   BYVAL HPDF_Destination _                   ' HPDF_Destination  dst
 , BYVAL HPDF_REAL _                          ' HPDF_REAL         left
 , BYVAL HPDF_REAL _                          ' HPDF_REAL         bottom
 , BYVAL HPDF_REAL _                          ' HPDF_REAL         right
 , BYVAL HPDF_REAL _                          ' HPDF_REAL         top
 ) AS HPDF_STATUS                             ' HPDF_STATUS
' ========================================================================================

' ========================================================================================
DECLARE FUNCTION HPDF_Destination_SetFitB HPDF_CALLCONV LIB "LIBHPDF.DLL" ALIAS "HPDF_Destination_SetFitB" ( _
   BYVAL HPDF_Destination _                   ' HPDF_Destination  dst
 ) AS HPDF_STATUS                             ' HPDF_STATUS
' ========================================================================================

' ========================================================================================
DECLARE FUNCTION HPDF_Destination_SetFitBH HPDF_CALLCONV LIB "LIBHPDF.DLL" ALIAS "HPDF_Destination_SetFitBH" ( _
   BYVAL HPDF_Destination _                   ' HPDF_Destination  dst
 , BYVAL HPDF_REAL _                          ' HPDF_REAL         top
 ) AS HPDF_STATUS                             ' HPDF_STATUS
' ========================================================================================

' ========================================================================================
DECLARE FUNCTION HPDF_Destination_SetFitBV HPDF_CALLCONV LIB "LIBHPDF.DLL" ALIAS "HPDF_Destination_SetFitBV" ( _
   BYVAL HPDF_Destination _                   ' HPDF_Destination  dst
 , BYVAL HPDF_REAL _                          ' HPDF_REAL         left
 ) AS HPDF_STATUS                             ' HPDF_STATUS
' ========================================================================================

'/*--------------------------------------------------------------------------*/
'/*----- encoder ------------------------------------------------------------*/

' ========================================================================================
DECLARE FUNCTION HPDF_GetEncoder HPDF_CALLCONV LIB "LIBHPDF.DLL" ALIAS "HPDF_GetEncoder" ( _
   BYVAL HPDF_Doc _                           ' HPDF_Doc     pdf
 , BYREF ASCIIZ _                             ' const char  *encoding_name
 ) AS HPDF_Encoder                            ' HPDF_Encoder
' ========================================================================================

' ========================================================================================
DECLARE FUNCTION HPDF_GetCurrentEncoder HPDF_CALLCONV LIB "LIBHPDF.DLL" ALIAS "HPDF_GetCurrentEncoder" ( _
   BYVAL HPDF_Doc _                           ' HPDF_Doc     pdf
 ) AS HPDF_Encoder                            ' HPDF_Encoder
' ========================================================================================

' ========================================================================================
DECLARE FUNCTION HPDF_SetCurrentEncoder HPDF_CALLCONV LIB "LIBHPDF.DLL" ALIAS "HPDF_SetCurrentEncoder" ( _
   BYVAL HPDF_Doc _                           ' HPDF_Doc     pdf
 , BYREF ASCIIZ _                             ' const char  *encoding_name
 ) AS HPDF_STATUS                             ' HPDF_STATUS
' ========================================================================================

' ========================================================================================
DECLARE FUNCTION HPDF_Encoder_GetType HPDF_CALLCONV LIB "LIBHPDF.DLL" ALIAS "HPDF_Encoder_GetType" ( _
   BYVAL HPDF_Encoder _                       ' HPDF_Encoder   encoder
 ) AS HPDF_EncoderType                        ' HPDF_EncoderType
' ========================================================================================

' ========================================================================================
DECLARE FUNCTION HPDF_Encoder_GetByteType HPDF_CALLCONV LIB "LIBHPDF.DLL" ALIAS "HPDF_Encoder_GetByteType" ( _
   BYVAL HPDF_Encoder _                       ' HPDF_Encoder   encoder
 , BYREF ASCIIZ _                             ' const char     *text
 , BYVAL HPDF_UINT _                          ' HPDF_UINT       index
 ) AS HPDF_ByteType                           ' HPDF_ByteType
' ========================================================================================

' ========================================================================================
DECLARE FUNCTION HPDF_Encoder_GetUnicode HPDF_CALLCONV LIB "LIBHPDF.DLL" ALIAS "HPDF_Encoder_GetUnicode" ( _
   BYVAL HPDF_Encoder _                       ' HPDF_Encoder   encoder
 , BYVAL HPDF_UINT16 _                        ' HPDF_UINT16    code
 ) AS HPDF_UNICODE                            ' HPDF_UNICODE
' ========================================================================================

' ========================================================================================
DECLARE FUNCTION HPDF_Encoder_GetWritingMode HPDF_CALLCONV LIB "LIBHPDF.DLL" ALIAS "HPDF_Encoder_GetWritingMode" ( _
   BYVAL HPDF_Encoder _                       ' HPDF_Encoder   encoder
 ) AS HPDF_WritingMode                        ' HPDF_WritingMode
' ========================================================================================

' ========================================================================================
DECLARE FUNCTION HPDF_UseJPEncodings HPDF_CALLCONV LIB "LIBHPDF.DLL" ALIAS "HPDF_UseJPEncodings" ( _
   BYVAL HPDF_Doc _                           ' HPDF_Doc   pdf
 ) AS HPDF_STATUS                             ' HPDF_STATUS
' ========================================================================================

' ========================================================================================
DECLARE FUNCTION HPDF_UseKREncodings HPDF_CALLCONV LIB "LIBHPDF.DLL" ALIAS "HPDF_UseKREncodings" ( _
   BYVAL HPDF_Doc _                           ' HPDF_Doc   pdf
 ) AS HPDF_STATUS                             ' HPDF_STATUS
' ========================================================================================

' ========================================================================================
DECLARE FUNCTION HPDF_UseCNSEncodings HPDF_CALLCONV LIB "LIBHPDF.DLL" ALIAS "HPDF_UseCNSEncodings" ( _
   BYVAL HPDF_Doc _                           ' HPDF_Doc   pdf
 ) AS HPDF_STATUS                             ' HPDF_STATUS
' ========================================================================================

' ========================================================================================
DECLARE FUNCTION HPDF_UseCNTEncodings HPDF_CALLCONV LIB "LIBHPDF.DLL" ALIAS "HPDF_UseCNTEncodings" ( _
   BYVAL HPDF_Doc _                           ' HPDF_Doc   pdf
 ) AS HPDF_STATUS                             ' HPDF_STATUS
' ========================================================================================

'/*--------------------------------------------------------------------------*/
'/*----- annotation ---------------------------------------------------------*/

' ========================================================================================
DECLARE FUNCTION HPDF_Page_CreateTextAnnot HPDF_CALLCONV LIB "LIBHPDF.DLL" ALIAS "HPDF_Page_CreateTextAnnot" ( _
   BYVAL HPDF_Page _                          ' HPDF_Page       page
 , BYVAL HPDF_Rect _                          ' HPDF_Rect       rect (must be byval)
 , BYREF ASCIIZ _                             ' const char     *text
 , BYVAL HPDF_Encoder _                       ' HPDF_Encoder    encoder
 ) AS HPDF_Annotation                         ' HPDF_Annotation
' ========================================================================================

' ========================================================================================
DECLARE FUNCTION HPDF_Page_CreateLinkAnnot HPDF_CALLCONV LIB "LIBHPDF.DLL" ALIAS "HPDF_Page_CreateLinkAnnot" ( _
   BYVAL HPDF_Page _                          ' HPDF_Page          page
 , BYVAL HPDF_Rect _                          ' HPDF_Rect          rect (must be byval)
 , BYVAL HPDF_Destination _                   ' HPDF_Destination   dst
 ) AS HPDF_Annotation                         ' HPDF_Annotation
' ========================================================================================

' ========================================================================================
DECLARE FUNCTION HPDF_Page_CreateURILinkAnnot HPDF_CALLCONV LIB "LIBHPDF.DLL" ALIAS "HPDF_Page_CreateURILinkAnnot" ( _
   BYVAL HPDF_Page _                          ' HPDF_Page       page
 , BYVAL HPDF_Rect _                          ' HPDF_Rect       rect (must be byval)
 , BYREF ASCIIZ _                             ' const char      *uri
 ) AS HPDF_Annotation                         ' HPDF_Annotation
' ========================================================================================

' ========================================================================================
DECLARE FUNCTION HPDF_LinkAnnot_SetHighlightMode HPDF_CALLCONV LIB "LIBHPDF.DLL" ALIAS "HPDF_LinkAnnot_SetHighlightMode" ( _
   BYVAL HPDF_Annotation _                    ' HPDF_Annotation           annot
 , BYREF HPDF_AnnotHighlightMode _            ' HPDF_AnnotHighlightMode   mode
 ) AS HPDF_STATUS                             ' HPDF_STATUS
' ========================================================================================

' ========================================================================================
DECLARE FUNCTION HPDF_LinkAnnot_SetBorderStyle HPDF_CALLCONV LIB "LIBHPDF.DLL" ALIAS "HPDF_LinkAnnot_SetBorderStyle" ( _
   BYVAL HPDF_Annotation  _                   ' HPDF_Annotation  annot
 , BYVAL HPDF_REAL _                          ' HPDF_REAL        width
 , BYVAL HPDF_UINT16 _                        ' HPDF_UINT16      dash_on
 , BYVAL HPDF_UINT16 _                        ' HPDF_UINT16      dash_off
 ) AS HPDF_STATUS                             ' HPDF_STATUS
' ========================================================================================

' ========================================================================================
DECLARE FUNCTION HPDF_TextAnnot_SetIcon HPDF_CALLCONV LIB "LIBHPDF.DLL" ALIAS "HPDF_TextAnnot_SetIcon" ( _
   BYVAL HPDF_Annotation _                    ' HPDF_Annotation   annot
 , BYVAL HPDF_AnnotIcon _                     ' HPDF_AnnotIcon    icon
 ) AS HPDF_STATUS                             ' HPDF_STATUS
' ========================================================================================

' ========================================================================================
DECLARE FUNCTION HPDF_TextAnnot_SetOpened HPDF_CALLCONV LIB "LIBHPDF.DLL" ALIAS "HPDF_TextAnnot_SetOpened" ( _
   BYVAL HPDF_Annotation _                    ' HPDF_Annotation   annot
 , BYVAL HPDF_BOOL _                          ' HPDF_BOOL          opened
 ) AS HPDF_STATUS                             ' HPDF_STATUS
' ========================================================================================

'/*--------------------------------------------------------------------------*/
'/*----- image data ---------------------------------------------------------*/

' ========================================================================================
DECLARE FUNCTION HPDF_LoadPngImageFromFile HPDF_CALLCONV LIB "LIBHPDF.DLL" ALIAS "HPDF_LoadPngImageFromFile" ( _
   BYVAL HPDF_Doc _                           ' HPDF_Doc      pdf
 , BYREF ASCIIZ _                             ' const char    *filename
 ) AS HPDF_Image                              ' HPDF_Image
' ========================================================================================

' ========================================================================================
DECLARE FUNCTION HPDF_LoadPngImageFromFile2 HPDF_CALLCONV LIB "LIBHPDF.DLL" ALIAS "HPDF_LoadPngImageFromFile2" ( _
   BYVAL HPDF_Doc _                           ' HPDF_Doc      pdf
 , BYREF ASCIIZ _                             ' const char    *filename
 ) AS HPDF_Image                              ' HPDF_Image
' ========================================================================================

' ========================================================================================
DECLARE FUNCTION HPDF_LoadJpegImageFromFile HPDF_CALLCONV LIB "LIBHPDF.DLL" ALIAS "HPDF_LoadJpegImageFromFile" ( _
   BYVAL HPDF_Doc _                           ' HPDF_Doc      pdf
 , BYREF ASCIIZ _                             ' const char    *filename
 ) AS HPDF_Image                              ' HPDF_Image
' ========================================================================================

' ========================================================================================
DECLARE FUNCTION HPDF_LoadRawImageFromFile HPDF_CALLCONV LIB "LIBHPDF.DLL" ALIAS "HPDF_LoadRawImageFromFile" ( _
   BYVAL HPDF_Doc _                           ' HPDF_Doc           pdf
 , BYREF ASCIIZ _                             ' const char        *filename
 , BYVAL HPDF_UINT _                          ' HPDF_UINT          width
 , BYVAL HPDF_UINT _                          ' HPDF_UINT          height
 , BYVAL HPDF_ColorSpace _                    ' HPDF_ColorSpace    color_space
 ) AS HPDF_Image                              ' HPDF_Image
' ========================================================================================

' ========================================================================================
DECLARE FUNCTION HPDF_LoadRawImageFromMem HPDF_CALLCONV LIB "LIBHPDF.DLL" ALIAS "HPDF_LoadRawImageFromMem" ( _
   BYVAL HPDF_Doc _                           ' HPDF_Doc           pdf
 , BYREF HPDF_BYTE _                          ' const HPDF_BYTE   *buf
 , BYVAL HPDF_UINT _                          ' HPDF_UINT          width
 , BYVAL HPDF_UINT _                          ' HPDF_UINT          height
 , BYVAL HPDF_ColorSpace _                    ' HPDF_ColorSpace    color_space
 , BYVAL HPDF_UINT _                          ' HPDF_UINT          bits_per_component
 ) AS HPDF_Image                              ' HPDF_Image
' ========================================================================================

' ========================================================================================
DECLARE FUNCTION HPDF_Image_GetSize HPDF_CALLCONV LIB "LIBHPDF.DLL" ALIAS "HPDF_Image_GetSize" ( _
   BYVAL HPDF_Image _                         ' HPDF_Image  image
 ) AS DWORD                                   ' HPDF_Point
' ========================================================================================

' ========================================================================================
DECLARE FUNCTION HPDF_Image_GetSize2 HPDF_CALLCONV LIB "LIBHPDF.DLL" ALIAS "HPDF_Image_GetSize2" ( _
   BYVAL HPDF_Image, _                        ' HPDF_Image  image
   BYREF HPDF_Point _                         ' HPDF_Point *size
 ) AS HPDF_STATUS                             ' HPDF_STATUS
' ========================================================================================

' ========================================================================================
DECLARE FUNCTION HPDF_Image_GetWidth HPDF_CALLCONV LIB "LIBHPDF.DLL" ALIAS "HPDF_Image_GetWidth" ( _
   BYVAL HPDF_Image _                         ' HPDF_Image  image
 ) AS HPDF_UINT                               ' HPDF_UINT
' ========================================================================================

' ========================================================================================
DECLARE FUNCTION HPDF_Image_GetHeight HPDF_CALLCONV LIB "LIBHPDF.DLL" ALIAS "HPDF_Image_GetHeight" ( _
   BYVAL HPDF_Image _                         ' HPDF_Image  image
 ) AS HPDF_UINT                               ' HPDF_UINT
' ========================================================================================

' ========================================================================================
DECLARE FUNCTION HPDF_Image_GetBitsPerComponent HPDF_CALLCONV LIB "LIBHPDF.DLL" ALIAS "HPDF_Image_GetBitsPerComponent" ( _
   BYVAL HPDF_Image _                         ' HPDF_Image  image
 ) AS HPDF_UINT                               ' HPDF_UINT
' ========================================================================================

' ========================================================================================
DECLARE FUNCTION HPDF_Image_GetColorSpace HPDF_CALLCONV LIB "LIBHPDF.DLL" ALIAS "HPDF_Image_GetColorSpace" ( _
   BYVAL HPDF_Image _                         ' HPDF_Image  image
 ) AS DWORD                                   ' const char*
' ========================================================================================

' ========================================================================================
DECLARE FUNCTION HPDF_Image_SetColorMask HPDF_CALLCONV LIB "LIBHPDF.DLL" ALIAS "HPDF_Image_SetColorMask" ( _
   BYVAL HPDF_Image _                         ' HPDF_Image   image
 , BYVAL HPDF_UINT _                          ' HPDF_UINT    rmin
 , BYVAL HPDF_UINT _                          ' HPDF_UINT    rmax
 , BYVAL HPDF_UINT _                          ' HPDF_UINT    gmin
 , BYVAL HPDF_UINT _                          ' HPDF_UINT    gmax
 , BYVAL HPDF_UINT _                          ' HPDF_UINT    bmin
 , BYVAL HPDF_UINT _                          ' HPDF_UINT    bmax
 ) AS HPDF_STATUS                             ' HPDF_STATUS
' ========================================================================================

' ========================================================================================
DECLARE FUNCTION HPDF_Image_SetMaskImage HPDF_CALLCONV LIB "LIBHPDF.DLL" ALIAS "HPDF_Image_SetMaskImage" ( _
   BYVAL HPDF_Image _                         ' HPDF_Image   image
 , BYVAL HPDF_Image _                         ' HPDF_Image   mask_image
 ) AS HPDF_STATUS                             ' HPDF_STATUS
' ========================================================================================

'/*--------------------------------------------------------------------------*/
'/*----- info dictionary ----------------------------------------------------*/


' ========================================================================================
DECLARE FUNCTION HPDF_SetInfoAttr HPDF_CALLCONV LIB "LIBHPDF.DLL" ALIAS "HPDF_SetInfoAttr" ( _
   BYVAL HPDF_Doc _                           ' HPDF_Doc        pdf
 , BYVAL HPDF_InfoType _                      ' HPDF_InfoType   type
 , BYREF ASCIIZ _                             ' const char     *value
 ) AS HPDF_STATUS                             ' HPDF_STATUS
' ========================================================================================

' ========================================================================================
DECLARE FUNCTION HPDF_GetInfoAttr HPDF_CALLCONV LIB "LIBHPDF.DLL" ALIAS "HPDF_GetInfoAttr" ( _
   BYVAL HPDF_Doc _                           ' HPDF_Doc        pdf
 , BYVAL HPDF_InfoType _                      ' HPDF_InfoType   type
 ) AS DWORD                                   ' const char*
' ========================================================================================

' ========================================================================================
DECLARE FUNCTION HPDF_SetInfoDateAttr HPDF_CALLCONV LIB "LIBHPDF.DLL" ALIAS "HPDF_SetInfoDateAttr" ( _
   BYVAL HPDF_Doc _                           ' HPDF_Doc        pdf
 , BYVAL HPDF_InfoType _                      ' HPDF_InfoType   type
 , BYREF HPDF_Date _                          ' HPDF_Date       value
 ) AS HPDF_STATUS                             ' HPDF_STATUS
' ========================================================================================

'/*--------------------------------------------------------------------------*/
'/*----- encryption ---------------------------------------------------------*/

' ========================================================================================
DECLARE FUNCTION HPDF_SetPassword HPDF_CALLCONV LIB "LIBHPDF.DLL" ALIAS "HPDF_SetPassword" ( _
   BYVAL HPDF_Doc _                           ' HPDF_Doc     pdf
 , BYREF ASCIIZ _                             ' const char   *owner_passwd
 , BYREF ASCIIZ _                             ' const char   *user_passwd
 ) AS HPDF_STATUS                             ' HPDF_STATUS
' ========================================================================================

' ========================================================================================
DECLARE FUNCTION HPDF_SetPermission HPDF_CALLCONV LIB "LIBHPDF.DLL" ALIAS "HPDF_SetPermission" ( _
   BYVAL HPDF_Doc _                           ' HPDF_Doc    pdf
 , BYVAL HPDF_UINT _                          ' HPDF_UINT   permission
 ) AS HPDF_STATUS                             ' HPDF_STATUS
' ========================================================================================

' ========================================================================================
DECLARE FUNCTION HPDF_SetEncryptionMode HPDF_CALLCONV LIB "LIBHPDF.DLL" ALIAS "HPDF_SetEncryptionMode" ( _
   BYVAL HPDF_Doc _                           ' HPDF_Doc           pdf
 , BYVAL HPDF_EncryptMode _                   ' HPDF_EncryptMode   mode
 , BYVAL HPDF_UINT _                          ' HPDF_UINT          key_len
 ) AS HPDF_STATUS                             ' HPDF_STATUS
' ========================================================================================

'/*--------------------------------------------------------------------------*/
'/*----- compression --------------------------------------------------------*/

' ========================================================================================
DECLARE FUNCTION HPDF_SetCompressionMode HPDF_CALLCONV LIB "LIBHPDF.DLL" ALIAS "HPDF_SetCompressionMode" ( _
   BYVAL HPDF_Doc _                           ' HPDF_Doc    pdf
 , BYVAL HPDF_Doc _                           ' HPDF_Doc   mode
 ) AS HPDF_STATUS                             ' HPDF_STATUS
' ========================================================================================

'/*--------------------------------------------------------------------------*/
'/*----- font ---------------------------------------------------------------*/

' ========================================================================================
DECLARE FUNCTION HPDF_Font_GetFontName HPDF_CALLCONV LIB "LIBHPDF.DLL" ALIAS "HPDF_Font_GetFontName" ( _
   BYVAL HPDF_Font _                          ' HPDF_Font    font
 ) AS DWORD                                   ' const char*
' ========================================================================================

' ========================================================================================
DECLARE FUNCTION HPDF_Font_GetEncodingName HPDF_CALLCONV LIB "LIBHPDF.DLL" ALIAS "HPDF_Font_GetEncodingName" ( _
   BYVAL HPDF_Font _                          ' HPDF_Font    font
 ) AS DWORD                                   ' const char*
' ========================================================================================

'HPDF_EXPORT(HPDF_INT)
'HPDF_Font_GetUnicodeWidth  (HPDF_Font       font,
'                            HPDF_UNICODE    code);

' ========================================================================================
DECLARE FUNCTION HPDF_Font_GetUnicodeWidth HPDF_CALLCONV LIB "LIBHPDF.DLL" ALIAS "HPDF_Font_GetUnicodeWidth" ( _
   BYVAL HPDF_Font _                          ' HPDF_Font       font
 , BYVAL HPDF_UNICODE _                       ' HPDF_UNICODE    code
 ) AS HPDF_INT                                ' HPDF_INT
' ========================================================================================

' ========================================================================================
DECLARE FUNCTION HPDF_Font_GetBBox HPDF_CALLCONV LIB "LIBHPDF.DLL" ALIAS "HPDF_Font_GetBBox" ( _
   BYVAL HPDF_Font _                          ' HPDF_Font       font
 ) AS DWORD                                   ' HPDF_Box
' ========================================================================================

' ========================================================================================
DECLARE FUNCTION HPDF_Font_GetAscent HPDF_CALLCONV LIB "LIBHPDF.DLL" ALIAS "HPDF_Font_GetAscent" ( _
   BYVAL HPDF_Font _                          ' HPDF_Font  font
 ) AS HPDF_INT                                ' HPDF_INT
' ========================================================================================

' ========================================================================================
DECLARE FUNCTION HPDF_Font_GetDescent HPDF_CALLCONV LIB "LIBHPDF.DLL" ALIAS "HPDF_Font_GetDescent" ( _
   BYVAL HPDF_Font _                          ' HPDF_Font  font
 ) AS HPDF_INT                                ' HPDF_INT
' ========================================================================================

' ========================================================================================
DECLARE FUNCTION HPDF_Font_GetXHeight HPDF_CALLCONV LIB "LIBHPDF.DLL" ALIAS "HPDF_Font_GetXHeight" ( _
   BYVAL HPDF_Font _                          ' HPDF_Font  font
 ) AS HPDF_INT                                ' HPDF_INT
' ========================================================================================

' ========================================================================================
DECLARE FUNCTION HPDF_Font_GetCapHeight HPDF_CALLCONV LIB "LIBHPDF.DLL" ALIAS "HPDF_Font_GetCapHeight" ( _
   BYVAL HPDF_Font _                          ' HPDF_Font  font
 ) AS HPDF_INT                                ' HPDF_INT
' ========================================================================================

' ========================================================================================
DECLARE FUNCTION HPDF_Font_TextWidth HPDF_CALLCONV LIB "LIBHPDF.DLL" ALIAS "HPDF_Font_TextWidth" ( _
   BYVAL HPDF_Font _                          ' HPDF_Font          font
 , BYREF HPDF_BYTE _                          ' const HPDF_BYTE   *text
 , BYREF LONG _                               ' HPDF_UINT          len
 ) AS DWORD                                   ' HPDF_TextWidth
' ========================================================================================

' ========================================================================================
DECLARE FUNCTION HPDF_Font_MeasureText HPDF_CALLCONV LIB "LIBHPDF.DLL" ALIAS "HPDF_Font_MeasureText" ( _
   BYVAL HPDF_Font _                          ' HPDF_Font          font
 , BYREF HPDF_BYTE _                          ' const HPDF_BYTE   *text
 , BYVAL HPDF_UINT _                          ' HPDF_UINT          len
 , BYVAL HPDF_REAL _                          ' HPDF_REAL          width
 , BYVAL HPDF_REAL _                          ' HPDF_REAL          font_size
 , BYVAL HPDF_REAL _                          ' HPDF_REAL          char_space
 , BYVAL HPDF_REAL _                          ' HPDF_REAL          word_space
 , BYVAL HPDF_BOOL _                          ' HPDF_BOOL          wordwrap
 , BYREF HPDF_REAL _                          ' HPDF_REAL         *real_width
 ) AS HPDF_UINT                               ' HPDF_UINT
' ========================================================================================

'/*--------------------------------------------------------------------------*/
'/*----- extended graphics state --------------------------------------------*/

' ========================================================================================
DECLARE FUNCTION HPDF_CreateExtGState HPDF_CALLCONV LIB "LIBHPDF.DLL" ALIAS "HPDF_CreateExtGState" ( _
   BYVAL HPDF_Doc _                           ' HPDF_Doc  pdf
 ) AS HPDF_ExtGState                          ' HPDF_ExtGState
' ========================================================================================

' ========================================================================================
DECLARE FUNCTION HPDF_ExtGState_SetAlphaStroke HPDF_CALLCONV LIB "LIBHPDF.DLL" ALIAS "HPDF_ExtGState_SetAlphaStroke" ( _
   BYVAL HPDF_ExtGState _                     ' HPDF_ExtGState   ext_gstate
 , BYVAL HPDF_REAL _                          ' HPDF_REAL        value
 ) AS HPDF_STATUS                             ' HPDF_STATUS
' ========================================================================================

' ========================================================================================
DECLARE FUNCTION HPDF_ExtGState_SetAlphaFill HPDF_CALLCONV LIB "LIBHPDF.DLL" ALIAS "HPDF_ExtGState_SetAlphaFill" ( _
   BYVAL HPDF_ExtGState _                     ' HPDF_ExtGState   ext_gstate
 , BYVAL HPDF_REAL _                          ' HPDF_REAL        value
 ) AS HPDF_STATUS                             ' HPDF_STATUS
' ========================================================================================

' ========================================================================================
DECLARE FUNCTION HPDF_ExtGState_SetBlendMode HPDF_CALLCONV LIB "LIBHPDF.DLL" ALIAS "HPDF_ExtGState_SetBlendMode" ( _
   BYVAL HPDF_ExtGState _                     ' HPDF_ExtGState   ext_gstate
 , BYVAL HPDF_BlendMode _                     ' HPDF_BlendMode   mode
 ) AS HPDF_STATUS                             ' HPDF_STATUS
' ========================================================================================

'/*--------------------------------------------------------------------------*/
'/*--------------------------------------------------------------------------*/

' ========================================================================================
DECLARE FUNCTION HPDF_Page_TextWidth HPDF_CALLCONV LIB "LIBHPDF.DLL" ALIAS "HPDF_Page_TextWidth" ( _
   BYVAL HPDF_Page _                          ' HPDF_Page    page
 , BYREF ASCIIZ _                             ' const char  *text
 ) AS HPDF_REAL                               ' HPDF_REAL
' ========================================================================================

' ========================================================================================
DECLARE FUNCTION HPDF_Page_MeasureText HPDF_CALLCONV LIB "LIBHPDF.DLL" ALIAS "HPDF_Page_MeasureText" ( _
   BYVAL HPDF_Page _                          ' HPDF_Page    page
 , BYREF ASCIIZ _                             ' const char  *text
 , BYVAL HPDF_REAL _                          ' HPDF_REAL    width
 , BYVAL HPDF_BOOL _                          ' HPDF_BOOL    wordwrap
 , BYREF HPDF_REAL _                          ' HPDF_REAL   *real_width
 ) AS HPDF_UINT                               ' HPDF_UINT
' ========================================================================================

' ========================================================================================
DECLARE FUNCTION HPDF_Page_GetWidth HPDF_CALLCONV LIB "LIBHPDF.DLL" ALIAS "HPDF_Page_GetWidth" ( _
   BYVAL HPDF_Page _                          ' HPDF_Page    page
 ) AS HPDF_REAL                               ' HPDF_REAL
' ========================================================================================

' ========================================================================================
DECLARE FUNCTION HPDF_Page_GetHeight HPDF_CALLCONV LIB "LIBHPDF.DLL" ALIAS "HPDF_Page_GetHeight" ( _
   BYVAL HPDF_Page _                          ' HPDF_Page    page
 ) AS HPDF_REAL                               ' HPDF_REAL
' ========================================================================================

' ========================================================================================
DECLARE FUNCTION HPDF_Page_GetGMode HPDF_CALLCONV LIB "LIBHPDF.DLL" ALIAS "HPDF_Page_GetGMode" ( _
   BYVAL HPDF_Page _                          ' HPDF_Page   page
 ) AS DWORD                                   ' HPDF_UINT16
' ========================================================================================

' ========================================================================================
DECLARE FUNCTION HPDF_Page_GetCurrentPos HPDF_CALLCONV LIB "LIBHPDF.DLL" ALIAS "HPDF_Page_GetCurrentPos" ( _
   BYVAL HPDF_Page _                          ' HPDF_Page   page
 ) AS DWORD                                   ' HPDF_Point
' ========================================================================================

' ========================================================================================
DECLARE FUNCTION HPDF_Page_GetCurrentPos2 HPDF_CALLCONV LIB "LIBHPDF.DLL" ALIAS "HPDF_Page_GetCurrentPos2" ( _
   BYVAL HPDF_Page _                          ' HPDF_Page   page
 , BYREF HPDF_Point _                         ' HPDF_Point  *pos
 ) AS HPDF_STATUS                             ' HPDF_STATUS
' ========================================================================================

' ========================================================================================
DECLARE FUNCTION HPDF_Page_GetCurrentTextPos HPDF_CALLCONV LIB "LIBHPDF.DLL" ALIAS "HPDF_Page_GetCurrentTextPos" ( _
   BYVAL HPDF_Page _                          ' HPDF_Page   page
 ) AS DWORD                                   ' HPDF_Point
' ========================================================================================

' ========================================================================================
DECLARE FUNCTION HPDF_Page_GetCurrentTextPos2 HPDF_CALLCONV LIB "LIBHPDF.DLL" ALIAS "HPDF_Page_GetCurrentTextPos2" ( _
   BYVAL HPDF_Page _                          ' HPDF_Page   page
 , BYREF HPDF_Point _                         ' HPDF_Point  *pos
 ) AS HPDF_STATUS                             ' HPDF_STATUS
' ========================================================================================

' ========================================================================================
DECLARE FUNCTION HPDF_Page_GetCurrentFont HPDF_CALLCONV LIB "LIBHPDF.DLL" ALIAS "HPDF_Page_GetCurrentFont" ( _
   BYVAL HPDF_Page _                          ' HPDF_Page   page
 ) AS HPDF_Font                               ' HPDF_Font
' ========================================================================================

' ========================================================================================
DECLARE FUNCTION HPDF_Page_GetCurrentFontSize HPDF_CALLCONV LIB "LIBHPDF.DLL" ALIAS "HPDF_Page_GetCurrentFontSize" ( _
   BYVAL HPDF_Page _                          ' HPDF_Page   page
 ) AS HPDF_REAL                               ' HPDF_REAL
' ========================================================================================

' ========================================================================================
DECLARE FUNCTION HPDF_Page_GetTransMatrix HPDF_CALLCONV LIB "LIBHPDF.DLL" ALIAS "HPDF_Page_GetTransMatrix" ( _
   BYVAL HPDF_Page _                          ' HPDF_Page   page
 ) AS DWORD                                   ' HPDF_TransMatrix
' ========================================================================================

' ========================================================================================
DECLARE FUNCTION HPDF_Page_GetLineWidth HPDF_CALLCONV LIB "LIBHPDF.DLL" ALIAS "HPDF_Page_GetLineWidth" ( _
   BYVAL HPDF_Page _                          ' HPDF_Page   page
 ) AS HPDF_REAL                               ' HPDF_REAL
' ========================================================================================

' ========================================================================================
DECLARE FUNCTION HPDF_Page_GetLineCap HPDF_CALLCONV LIB "LIBHPDF.DLL" ALIAS "HPDF_Page_GetLineCap" ( _
   BYVAL HPDF_Page _                          ' HPDF_Page   page
 ) AS HPDF_LineCap                            ' HPDF_LineCap
' ========================================================================================

' ========================================================================================
DECLARE FUNCTION HPDF_Page_GetLineJoin HPDF_CALLCONV LIB "LIBHPDF.DLL" ALIAS "HPDF_Page_GetLineJoin" ( _
   BYVAL HPDF_Page _                          ' HPDF_Page   page
 ) AS HPDF_LineJoin                           ' HPDF_LineJoin
' ========================================================================================

' ========================================================================================
DECLARE FUNCTION HPDF_Page_GetMiterLimit HPDF_CALLCONV LIB "LIBHPDF.DLL" ALIAS "HPDF_Page_GetMiterLimit" ( _
   BYVAL HPDF_Page _                          ' HPDF_Page   page
 ) AS HPDF_REAL                               ' HPDF_REAL
' ========================================================================================

' ========================================================================================
DECLARE FUNCTION HPDF_Page_GetDash HPDF_CALLCONV LIB "LIBHPDF.DLL" ALIAS "HPDF_Page_GetDash" ( _
   BYVAL HPDF_Page _                          ' HPDF_Page   page
 ) AS DWORD                                   ' HPDF_DashMode
' ========================================================================================

' ========================================================================================
DECLARE FUNCTION HPDF_Page_GetFlat HPDF_CALLCONV LIB "LIBHPDF.DLL" ALIAS "HPDF_Page_GetFlat" ( _
   BYVAL HPDF_Page _                          ' HPDF_Page   page
 ) AS HPDF_REAL                               ' HPDF_REAL
' ========================================================================================

' ========================================================================================
DECLARE FUNCTION HPDF_Page_GetCharSpace HPDF_CALLCONV LIB "LIBHPDF.DLL" ALIAS "HPDF_Page_GetCharSpace" ( _
   BYVAL HPDF_Page _                          ' HPDF_Page   page
 ) AS HPDF_REAL                               ' HPDF_REAL
' ========================================================================================

' ========================================================================================
DECLARE FUNCTION HPDF_Page_GetWordSpace HPDF_CALLCONV LIB "LIBHPDF.DLL" ALIAS "HPDF_Page_GetWordSpace" ( _
   BYVAL HPDF_Page _                          ' HPDF_Page   page
 ) AS HPDF_REAL                               ' HPDF_REAL
' ========================================================================================

' ========================================================================================
DECLARE FUNCTION HPDF_Page_GetHorizontalScalling HPDF_CALLCONV LIB "LIBHPDF.DLL" ALIAS "HPDF_Page_GetHorizontalScalling" ( _
   BYVAL HPDF_Page _                          ' HPDF_Page   page
 ) AS HPDF_REAL                               ' HPDF_REAL
' ========================================================================================

' ========================================================================================
DECLARE FUNCTION HPDF_Page_GetTextLeading HPDF_CALLCONV LIB "LIBHPDF.DLL" ALIAS "HPDF_Page_GetTextLeading" ( _
   BYVAL HPDF_Page _                          ' HPDF_Page   page
 ) AS HPDF_REAL                               ' HPDF_REAL
' ========================================================================================

' ========================================================================================
DECLARE FUNCTION HPDF_Page_GetTextRenderingMode HPDF_CALLCONV LIB "LIBHPDF.DLL" ALIAS "HPDF_Page_GetTextRenderingMode" ( _
   BYVAL HPDF_Page _                          ' HPDF_Page   page
 ) AS HPDF_TextRenderingMode                  ' HPDF_TextRenderingMode
' ========================================================================================

'/* This function is obsolete. Use HPDF_Page_GetTextRise.  */
' ========================================================================================
DECLARE FUNCTION HPDF_Page_GetTextRaise HPDF_CALLCONV LIB "LIBHPDF.DLL" ALIAS "HPDF_Page_GetTextRaise" ( _
   BYVAL HPDF_Page _                          ' HPDF_Page   page
 ) AS HPDF_REAL                               ' HPDF_REAL
' ========================================================================================

' ========================================================================================
DECLARE FUNCTION HPDF_Page_GetTextRise HPDF_CALLCONV LIB "LIBHPDF.DLL" ALIAS "HPDF_Page_GetTextRise" ( _
   BYVAL HPDF_Page _                          ' HPDF_Page   page
 ) AS HPDF_REAL                               ' HPDF_REAL
' ========================================================================================

' ========================================================================================
DECLARE FUNCTION HPDF_Page_GetRGBFill HPDF_CALLCONV LIB "LIBHPDF.DLL" ALIAS "HPDF_Page_GetRGBFill" ( _
   BYVAL HPDF_Page _                          ' HPDF_Page   page
 ) AS DWORD                                   ' HPDF_RGBColor
' ========================================================================================

' ========================================================================================
DECLARE FUNCTION HPDF_Page_GetRGBStroke HPDF_CALLCONV LIB "LIBHPDF.DLL" ALIAS "HPDF_Page_GetRGBStroke" ( _
   BYVAL HPDF_Page _                          ' HPDF_Page   page
 ) AS DWORD                                   ' HPDF_RGBColor
' ========================================================================================

' ========================================================================================
DECLARE FUNCTION HPDF_Page_GetCMYKFill HPDF_CALLCONV LIB "LIBHPDF.DLL" ALIAS "HPDF_Page_GetCMYKFill" ( _
   BYVAL HPDF_Page _                          ' HPDF_Page   page
 ) AS DWORD                                   ' HPDF_CMYKColor
' ========================================================================================

' ========================================================================================
DECLARE FUNCTION HPDF_Page_GetCMYKStroke HPDF_CALLCONV LIB "LIBHPDF.DLL" ALIAS "HPDF_Page_GetCMYKStroke" ( _
   BYVAL HPDF_Page _                          ' HPDF_Page   page
 ) AS DWORD                                   ' HPDF_CMYKColor
' ========================================================================================

' ========================================================================================
DECLARE FUNCTION HPDF_Page_GetGrayFill HPDF_CALLCONV LIB "LIBHPDF.DLL" ALIAS "HPDF_Page_GetGrayFill" ( _
   BYVAL HPDF_Page _                          ' HPDF_Page   page
 ) AS HPDF_REAL                               ' HPDF_REAL
' ========================================================================================

' ========================================================================================
DECLARE FUNCTION HPDF_Page_GetGrayStroke HPDF_CALLCONV LIB "LIBHPDF.DLL" ALIAS "HPDF_Page_GetGrayStroke" ( _
   BYVAL HPDF_Page _                          ' HPDF_Page   page
 ) AS HPDF_REAL                               ' HPDF_REAL
' ========================================================================================

' ========================================================================================
DECLARE FUNCTION HPDF_Page_GetStrokingColorSpace HPDF_CALLCONV LIB "LIBHPDF.DLL" ALIAS "HPDF_Page_GetStrokingColorSpace" ( _
   BYVAL HPDF_Page _                          ' HPDF_Page   page
 ) AS HPDF_ColorSpace                         ' HPDF_ColorSpace
' ========================================================================================

' ========================================================================================
DECLARE FUNCTION HPDF_Page_GetFillingColorSpace HPDF_CALLCONV LIB "LIBHPDF.DLL" ALIAS "HPDF_Page_GetFillingColorSpace" ( _
   BYVAL HPDF_Page _                          ' HPDF_Page   page
 ) AS HPDF_ColorSpace                         ' HPDF_ColorSpace
' ========================================================================================

' ========================================================================================
DECLARE FUNCTION HPDF_Page_GetTextMatrix HPDF_CALLCONV LIB "LIBHPDF.DLL" ALIAS "HPDF_Page_GetTextMatrix" ( _
   BYVAL HPDF_Page _                          ' HPDF_Page   page
 ) AS DWORD                                   ' HPDF_TransMatrix
' ========================================================================================

' ========================================================================================
DECLARE FUNCTION HPDF_Page_GetGStateDepth HPDF_CALLCONV LIB "LIBHPDF.DLL" ALIAS "HPDF_Page_GetGStateDepth" ( _
   BYVAL HPDF_Page _                          ' HPDF_Page   page
 ) AS HPDF_UINT                               ' HPDF_UINT
' ========================================================================================

'/*--------------------------------------------------------------------------*/
'/*----- GRAPHICS OPERATORS -------------------------------------------------*/


'/*--- General graphics state ---------------------------------------------*/

' ========================================================================================
DECLARE FUNCTION HPDF_Page_SetLineWidth HPDF_CALLCONV LIB "LIBHPDF.DLL" ALIAS "HPDF_Page_SetLineWidth" ( _
   BYVAL HPDF_Page _                          ' HPDF_Page   page
 , BYVAL HPDF_REAL _                          ' HPDF_REAL   line_width
 ) AS HPDF_STATUS                             ' HPDF_STATUS
' ========================================================================================

' ========================================================================================
DECLARE FUNCTION HPDF_Page_SetLineCap HPDF_CALLCONV LIB "LIBHPDF.DLL" ALIAS "HPDF_Page_SetLineCap" ( _
   BYVAL HPDF_Page _                          ' HPDF_Page     page
 , BYVAL HPDF_LineCap _                       ' HPDF_LineCap  line_cap
 ) AS HPDF_STATUS                             ' HPDF_STATUS
' ========================================================================================

' ========================================================================================
DECLARE FUNCTION HPDF_Page_SetLineJoin HPDF_CALLCONV LIB "LIBHPDF.DLL" ALIAS "HPDF_Page_SetLineJoin" ( _
   BYVAL HPDF_Page _                          ' HPDF_Page      page
 , BYVAL HPDF_LineJoin _                      ' HPDF_LineJoin  line_join
 ) AS HPDF_STATUS                             ' HPDF_STATUS
' ========================================================================================

' ========================================================================================
DECLARE FUNCTION HPDF_Page_SetMiterLimit HPDF_CALLCONV LIB "LIBHPDF.DLL" ALIAS "HPDF_Page_SetMiterLimit" ( _
   BYVAL HPDF_Page _                          ' HPDF_Page  page
 , BYVAL HPDF_REAL _                          ' HPDF_REAL  miter_limit
 ) AS HPDF_STATUS                             ' HPDF_STATUS
' ========================================================================================

' ========================================================================================
DECLARE FUNCTION HPDF_Page_SetDash HPDF_CALLCONV LIB "LIBHPDF.DLL" ALIAS "HPDF_Page_SetDash" ( _
   BYVAL HPDF_Page _                          ' HPDF_Page           page
 , BYREF HPDF_UINT16 _                        ' const HPDF_UINT16  *dash_ptn
 , BYVAL HPDF_UINT _                          ' HPDF_UINT           num_param
 , BYVAL HPDF_UINT _                          ' HPDF_UINT           phase
 ) AS HPDF_STATUS                             ' HPDF_STATUS
' ========================================================================================

' ========================================================================================
DECLARE FUNCTION HPDF_Page_SetFlat HPDF_CALLCONV LIB "LIBHPDF.DLL" ALIAS "HPDF_Page_SetFlat" ( _
   BYVAL HPDF_Page _                          ' HPDF_Page    page
 , BYVAL HPDF_REAL _                          ' HPDF_REAL    flatness
 ) AS HPDF_STATUS                             ' HPDF_STATUS
' ========================================================================================

' ========================================================================================
DECLARE FUNCTION HPDF_Page_SetExtGState HPDF_CALLCONV LIB "LIBHPDF.DLL" ALIAS "HPDF_Page_SetExtGState" ( _
   BYVAL HPDF_Page _                          ' HPDF_Page    page
 , BYVAL HPDF_ExtGState _                     ' HPDF_REAL    flatness
 ) AS HPDF_STATUS                             ' HPDF_STATUS
' ========================================================================================

'/*--- Special graphic state operator --------------------------------------*/

' ========================================================================================
DECLARE FUNCTION HPDF_Page_GSave HPDF_CALLCONV LIB "LIBHPDF.DLL" ALIAS "HPDF_Page_GSave" ( _
   BYVAL HPDF_Page _                          ' HPDF_Page    page
 ) AS HPDF_STATUS                             ' HPDF_STATUS
' ========================================================================================

' ========================================================================================
DECLARE FUNCTION HPDF_Page_GRestore HPDF_CALLCONV LIB "LIBHPDF.DLL" ALIAS "HPDF_Page_GRestore" ( _
   BYVAL HPDF_Page _                          ' HPDF_Page    page
 ) AS HPDF_STATUS                             ' HPDF_STATUS
' ========================================================================================

' ========================================================================================
DECLARE FUNCTION HPDF_Page_Concat HPDF_CALLCONV LIB "LIBHPDF.DLL" ALIAS "HPDF_Page_Concat" ( _
   BYVAL HPDF_Page _                          ' HPDF_Page    page
 , BYVAL HPDF_REAL _                          ' HPDF_REAL    a
 , BYVAL HPDF_REAL _                          ' HPDF_REAL    b
 , BYVAL HPDF_REAL _                          ' HPDF_REAL    c
 , BYVAL HPDF_REAL _                          ' HPDF_REAL    d
 , BYVAL HPDF_REAL _                          ' HPDF_REAL    x
 , BYVAL HPDF_REAL _                          ' HPDF_REAL    y
 ) AS HPDF_STATUS                             ' HPDF_STATUS
' ========================================================================================

'/*--- Path construction operator ------------------------------------------*/

' ========================================================================================
DECLARE FUNCTION HPDF_Page_MoveTo HPDF_CALLCONV LIB "LIBHPDF.DLL" ALIAS "HPDF_Page_MoveTo" ( _
   BYVAL HPDF_Page _                          ' HPDF_Page    page
 , BYVAL HPDF_REAL _                          ' HPDF_REAL    x
 , BYVAL HPDF_REAL _                          ' HPDF_REAL    y
 ) AS HPDF_STATUS                             ' HPDF_STATUS
' ========================================================================================

' ========================================================================================
DECLARE FUNCTION HPDF_Page_LineTo HPDF_CALLCONV LIB "LIBHPDF.DLL" ALIAS "HPDF_Page_LineTo" ( _
   BYVAL HPDF_Page _                          ' HPDF_Page    page
 , BYVAL HPDF_REAL _                          ' HPDF_REAL    x
 , BYVAL HPDF_REAL _                          ' HPDF_REAL    y
 ) AS HPDF_STATUS                             ' HPDF_STATUS
' ========================================================================================

' ========================================================================================
DECLARE FUNCTION HPDF_Page_CurveTo HPDF_CALLCONV LIB "LIBHPDF.DLL" ALIAS "HPDF_Page_CurveTo" ( _
   BYVAL HPDF_Page _                          ' HPDF_Page    page
 , BYVAL HPDF_REAL _                          ' HPDF_REAL    x1
 , BYVAL HPDF_REAL _                          ' HPDF_REAL    y1
 , BYVAL HPDF_REAL _                          ' HPDF_REAL    x2
 , BYVAL HPDF_REAL _                          ' HPDF_REAL    y2
 , BYVAL HPDF_REAL _                          ' HPDF_REAL    x3
 , BYVAL HPDF_REAL _                          ' HPDF_REAL    y3
 ) AS HPDF_STATUS                             ' HPDF_STATUS
' ========================================================================================

' ========================================================================================
DECLARE FUNCTION HPDF_Page_CurveTo2 HPDF_CALLCONV LIB "LIBHPDF.DLL" ALIAS "HPDF_Page_CurveTo2" ( _
   BYVAL HPDF_Page _                          ' HPDF_Page    page
 , BYVAL HPDF_REAL _                          ' HPDF_REAL    x2
 , BYVAL HPDF_REAL _                          ' HPDF_REAL    y2
 , BYVAL HPDF_REAL _                          ' HPDF_REAL    x3
 , BYVAL HPDF_REAL _                          ' HPDF_REAL    y3
 ) AS HPDF_STATUS                             ' HPDF_STATUS
' ========================================================================================

' ========================================================================================
DECLARE FUNCTION HPDF_Page_CurveTo3 HPDF_CALLCONV LIB "LIBHPDF.DLL" ALIAS "HPDF_Page_CurveTo3" ( _
   BYVAL HPDF_Page _                          ' HPDF_Page    page
 , BYVAL HPDF_REAL _                          ' HPDF_REAL    x1
 , BYVAL HPDF_REAL _                          ' HPDF_REAL    y1
 , BYVAL HPDF_REAL _                          ' HPDF_REAL    x3
 , BYVAL HPDF_REAL _                          ' HPDF_REAL    y3
 ) AS HPDF_STATUS                             ' HPDF_STATUS
' ========================================================================================

' ========================================================================================
DECLARE FUNCTION HPDF_Page_ClosePath HPDF_CALLCONV LIB "LIBHPDF.DLL" ALIAS "HPDF_Page_ClosePath" ( _
   BYVAL HPDF_Page _                          ' HPDF_Page  page
 ) AS HPDF_STATUS                             ' HPDF_STATUS
' ========================================================================================

' ========================================================================================
DECLARE FUNCTION HPDF_Page_Rectangle HPDF_CALLCONV LIB "LIBHPDF.DLL" ALIAS "HPDF_Page_Rectangle" ( _
   BYVAL HPDF_Page _                          ' HPDF_Page  page
 , BYVAL HPDF_REAL _                          ' HPDF_REAL  x
 , BYVAL HPDF_REAL _                          ' HPDF_REAL  y
 , BYVAL HPDF_REAL _                          ' HPDF_REAL  width
 , BYVAL HPDF_REAL _                          ' HPDF_REAL  height
 ) AS HPDF_STATUS                             ' HPDF_STATUS
' ========================================================================================

'/*--- Path painting operator ---------------------------------------------*/

' ========================================================================================
DECLARE FUNCTION HPDF_Page_Stroke HPDF_CALLCONV LIB "LIBHPDF.DLL" ALIAS "HPDF_Page_Stroke" ( _
   BYVAL HPDF_Page _                          ' HPDF_Page  page
 ) AS HPDF_STATUS                             ' HPDF_STATUS
' ========================================================================================

' ========================================================================================
DECLARE FUNCTION HPDF_Page_ClosePathStroke HPDF_CALLCONV LIB "LIBHPDF.DLL" ALIAS "HPDF_Page_ClosePathStroke" ( _
   BYVAL HPDF_Page _                          ' HPDF_Page  page
 ) AS HPDF_STATUS                             ' HPDF_STATUS
' ========================================================================================

' ========================================================================================
DECLARE FUNCTION HPDF_Page_Fill HPDF_CALLCONV LIB "LIBHPDF.DLL" ALIAS "HPDF_Page_Fill" ( _
   BYVAL HPDF_Page _                          ' HPDF_Page  page
 ) AS HPDF_STATUS                             ' HPDF_STATUS
' ========================================================================================

' ========================================================================================
DECLARE FUNCTION HPDF_Page_Eofill HPDF_CALLCONV LIB "LIBHPDF.DLL" ALIAS "HPDF_Page_Eofill" ( _
   BYVAL HPDF_Page _                          ' HPDF_Page  page
 ) AS HPDF_STATUS                             ' HPDF_STATUS
' ========================================================================================

' ========================================================================================
DECLARE FUNCTION HPDF_Page_FillStroke HPDF_CALLCONV LIB "LIBHPDF.DLL" ALIAS "HPDF_Page_FillStroke" ( _
   BYVAL HPDF_Page _                          ' HPDF_Page  page
 ) AS HPDF_STATUS                             ' HPDF_STATUS
' ========================================================================================

' ========================================================================================
DECLARE FUNCTION HPDF_Page_EofillStroke HPDF_CALLCONV LIB "LIBHPDF.DLL" ALIAS "HPDF_Page_EofillStroke" ( _
   BYVAL HPDF_Page _                          ' HPDF_Page  page
 ) AS HPDF_STATUS                             ' HPDF_STATUS
' ========================================================================================

' ========================================================================================
DECLARE FUNCTION HPDF_Page_ClosePathFillStroke HPDF_CALLCONV LIB "LIBHPDF.DLL" ALIAS "HPDF_Page_ClosePathFillStroke" ( _
   BYVAL HPDF_Page _                          ' HPDF_Page  page
 ) AS HPDF_STATUS                             ' HPDF_STATUS
' ========================================================================================

' ========================================================================================
DECLARE FUNCTION HPDF_Page_ClosePathEofillStroke HPDF_CALLCONV LIB "LIBHPDF.DLL" ALIAS "HPDF_Page_ClosePathEofillStroke" ( _
   BYVAL HPDF_Page _                          ' HPDF_Page  page
 ) AS HPDF_STATUS                             ' HPDF_STATUS
' ========================================================================================

' ========================================================================================
DECLARE FUNCTION HPDF_Page_EndPath HPDF_CALLCONV LIB "LIBHPDF.DLL" ALIAS "HPDF_Page_EndPath" ( _
   BYVAL HPDF_Page _                          ' HPDF_Page  page
 ) AS HPDF_STATUS                             ' HPDF_STATUS
' ========================================================================================


'/*--- Clipping paths operator --------------------------------------------*/

' ========================================================================================
DECLARE FUNCTION HPDF_Page_Clip HPDF_CALLCONV LIB "LIBHPDF.DLL" ALIAS "HPDF_Page_Clip" ( _
   BYVAL HPDF_Page _                          ' HPDF_Page  page
 ) AS HPDF_STATUS                             ' HPDF_STATUS
' ========================================================================================

' ========================================================================================
DECLARE FUNCTION HPDF_Page_Eoclip HPDF_CALLCONV LIB "LIBHPDF.DLL" ALIAS "HPDF_Page_Eoclip" ( _
   BYVAL HPDF_Page _                          ' HPDF_Page  page
 ) AS HPDF_STATUS                             ' HPDF_STATUS
' ========================================================================================

'/*--- Text object operator -----------------------------------------------*/

' ========================================================================================
DECLARE FUNCTION HPDF_Page_BeginText HPDF_CALLCONV LIB "LIBHPDF.DLL" ALIAS "HPDF_Page_BeginText" ( _
   BYVAL HPDF_Page _                          ' HPDF_Page  page
 ) AS HPDF_STATUS                             ' HPDF_STATUS
' ========================================================================================

' ========================================================================================
DECLARE FUNCTION HPDF_Page_EndText HPDF_CALLCONV LIB "LIBHPDF.DLL" ALIAS "HPDF_Page_EndText" ( _
   BYVAL HPDF_Page _                          ' HPDF_Page  page
 ) AS HPDF_STATUS                             ' HPDF_STATUS
' ========================================================================================

'/*--- Text state ---------------------------------------------------------*/

' ========================================================================================
DECLARE FUNCTION HPDF_Page_SetCharSpace HPDF_CALLCONV LIB "LIBHPDF.DLL" ALIAS "HPDF_Page_SetCharSpace" ( _
   BYVAL HPDF_Page _                          ' HPDF_Page  page
 , BYVAL HPDF_REAL _                          ' HPDF_REAL  value
 ) AS HPDF_STATUS                             ' HPDF_STATUS
' ========================================================================================

' ========================================================================================
DECLARE FUNCTION HPDF_Page_SetWordSpace HPDF_CALLCONV LIB "LIBHPDF.DLL" ALIAS "HPDF_Page_SetWordSpace" ( _
   BYVAL HPDF_Page _                          ' HPDF_Page  page
 , BYVAL HPDF_REAL _                          ' HPDF_REAL  value
 ) AS HPDF_STATUS                             ' HPDF_STATUS
' ========================================================================================

' ========================================================================================
DECLARE FUNCTION HPDF_Page_SetHorizontalScalling HPDF_CALLCONV LIB "LIBHPDF.DLL" ALIAS "HPDF_Page_SetHorizontalScalling" ( _
   BYVAL HPDF_Page _                          ' HPDF_Page  page
 , BYVAL HPDF_REAL _                          ' HPDF_REAL  value
 ) AS HPDF_STATUS                             ' HPDF_STATUS
' ========================================================================================

' ========================================================================================
DECLARE FUNCTION HPDF_Page_SetTextLeading HPDF_CALLCONV LIB "LIBHPDF.DLL" ALIAS "HPDF_Page_SetTextLeading" ( _
   BYVAL HPDF_Page _                          ' HPDF_Page  page
 , BYVAL HPDF_REAL _                          ' HPDF_REAL  value
 ) AS HPDF_STATUS                             ' HPDF_STATUS
' ========================================================================================

' ========================================================================================
DECLARE FUNCTION HPDF_Page_SetFontAndSize HPDF_CALLCONV LIB "LIBHPDF.DLL" ALIAS "HPDF_Page_SetFontAndSize" ( _
   BYVAL HPDF_Page _                          ' HPDF_Page  page
 , BYVAL HPDF_Font _                          ' HPDF_Font  font
 , BYVAL HPDF_REAL _                          ' HPDF_REAL  size
 ) AS HPDF_STATUS                             ' HPDF_STATUS
' ========================================================================================

' ========================================================================================
DECLARE FUNCTION HPDF_Page_SetTextRenderingMode HPDF_CALLCONV LIB "LIBHPDF.DLL" ALIAS "HPDF_Page_SetTextRenderingMode" ( _
   BYVAL HPDF_Page _                          ' HPDF_Page               page
 , BYVAL HPDF_TextRenderingMode _             ' HPDF_TextRenderingMode  mode
 ) AS HPDF_STATUS                             ' HPDF_STATUS
' ========================================================================================

' ========================================================================================
DECLARE FUNCTION HPDF_Page_SetTextRise HPDF_CALLCONV LIB "LIBHPDF.DLL" ALIAS "HPDF_Page_SetTextRise" ( _
   BYVAL HPDF_Page _                          ' HPDF_Page   page
 , BYVAL HPDF_REAL _                          ' HPDF_REAL   value
 ) AS HPDF_STATUS                             ' HPDF_STATUS
' ========================================================================================

'/* This function is obsolete. Use HPDF_Page_SetTextRise.  */
' ========================================================================================
DECLARE FUNCTION HPDF_Page_SetTextRaise HPDF_CALLCONV LIB "LIBHPDF.DLL" ALIAS "HPDF_Page_SetTextRaise" ( _
   BYVAL HPDF_Page _                          ' HPDF_Page  page
 , BYVAL HPDF_REAL _                          ' HPDF_REAL  value
 ) AS HPDF_STATUS                             ' HPDF_STATUS
' ========================================================================================

'/*--- Text positioning ---------------------------------------------------*/

' ========================================================================================
DECLARE FUNCTION HPDF_Page_MoveTextPos HPDF_CALLCONV LIB "LIBHPDF.DLL" ALIAS "HPDF_Page_MoveTextPos" ( _
   BYVAL HPDF_Page _                          ' HPDF_Page  page
 , BYVAL HPDF_REAL _                          ' HPDF_REAL   x
 , BYVAL HPDF_REAL _                          ' HPDF_REAL   y
 ) AS HPDF_STATUS                             ' HPDF_STATUS
' ========================================================================================

' ========================================================================================
DECLARE FUNCTION HPDF_Page_MoveTextPos2 HPDF_CALLCONV LIB "LIBHPDF.DLL" ALIAS "HPDF_Page_MoveTextPos2" ( _
   BYVAL HPDF_Page _                          ' HPDF_Page  page
 , BYVAL HPDF_REAL _                          ' HPDF_REAL   x
 , BYVAL HPDF_REAL _                          ' HPDF_REAL   y
 ) AS HPDF_STATUS                             ' HPDF_STATUS
' ========================================================================================

' ========================================================================================
DECLARE FUNCTION HPDF_Page_SetTextMatrix HPDF_CALLCONV LIB "LIBHPDF.DLL" ALIAS "HPDF_Page_SetTextMatrix" ( _
   BYVAL HPDF_Page _                          ' HPDF_Page    page
 , BYVAL HPDF_REAL _                          ' HPDF_REAL    a
 , BYVAL HPDF_REAL _                          ' HPDF_REAL    b
 , BYVAL HPDF_REAL _                          ' HPDF_REAL    c
 , BYVAL HPDF_REAL _                          ' HPDF_REAL    d
 , BYVAL HPDF_REAL _                          ' HPDF_REAL    x
 , BYVAL HPDF_REAL _                          ' HPDF_REAL    y
 ) AS HPDF_STATUS                             ' HPDF_STATUS
' ========================================================================================

' ========================================================================================
DECLARE FUNCTION HPDF_Page_MoveToNextLine HPDF_CALLCONV LIB "LIBHPDF.DLL" ALIAS "HPDF_Page_MoveToNextLine" ( _
   BYVAL HPDF_Page _                          ' HPDF_Page  page
 ) AS HPDF_STATUS                             ' HPDF_STATUS
' ========================================================================================

'/*--- Text showing -------------------------------------------------------*/

' ========================================================================================
DECLARE FUNCTION HPDF_Page_ShowText HPDF_CALLCONV LIB "LIBHPDF.DLL" ALIAS "HPDF_Page_ShowText" ( _
   BYVAL HPDF_Page _                          ' HPDF_Page   page
 , BYREF ASCIIZ _                             ' const char  *text
 ) AS HPDF_STATUS                             ' HPDF_STATUS
' ========================================================================================

' ========================================================================================
DECLARE FUNCTION HPDF_Page_ShowTextNextLine HPDF_CALLCONV LIB "LIBHPDF.DLL" ALIAS "HPDF_Page_ShowTextNextLine" ( _
   BYVAL HPDF_Page _                          ' HPDF_Page   page
 , BYREF ASCIIZ _                             ' const char  *text
 ) AS HPDF_STATUS                             ' HPDF_STATUS
' ========================================================================================

' ========================================================================================
DECLARE FUNCTION HPDF_Page_ShowTextNextLineEx HPDF_CALLCONV LIB "LIBHPDF.DLL" ALIAS "HPDF_Page_ShowTextNextLineEx" ( _
   BYVAL HPDF_Page _                          ' HPDF_Page    page
 , BYVAL HPDF_REAL _                          ' HPDF_REAL    word_space
 , BYVAL HPDF_REAL _                          ' HPDF_REAL    char_space
 , BYREF ASCIIZ _                             ' const char  *text
 ) AS HPDF_STATUS                             ' HPDF_STATUS
' ========================================================================================


'/*--- Color showing ------------------------------------------------------*/

'/* cs --not implemented yet */
'/* CS --not implemented yet */
'/* sc --not implemented yet */
'/* scn --not implemented yet */
'/* SC --not implemented yet */
'/* SCN --not implemented yet */

' ========================================================================================
DECLARE FUNCTION HPDF_Page_SetGrayFill HPDF_CALLCONV LIB "LIBHPDF.DLL" ALIAS "HPDF_Page_SetGrayFill" ( _
   BYVAL HPDF_Page _                          ' HPDF_Page   page
 , BYVAL HPDF_REAL _                          ' HPDF_REAL   gray
 ) AS HPDF_STATUS                             ' HPDF_STATUS
' ========================================================================================

' ========================================================================================
DECLARE FUNCTION HPDF_Page_SetGrayStroke HPDF_CALLCONV LIB "LIBHPDF.DLL" ALIAS "HPDF_Page_SetGrayStroke" ( _
   BYVAL HPDF_Page _                          ' HPDF_Page   page
 , BYVAL HPDF_REAL _                          ' HPDF_REAL   gray
 ) AS HPDF_STATUS                             ' HPDF_STATUS
' ========================================================================================

' ========================================================================================
DECLARE FUNCTION HPDF_Page_SetRGBFill HPDF_CALLCONV LIB "LIBHPDF.DLL" ALIAS "HPDF_Page_SetRGBFill" ( _
   BYVAL HPDF_Page _                          ' HPDF_Page  page
 , BYVAL HPDF_REAL _                          ' HPDF_REAL  r
 , BYVAL HPDF_REAL _                          ' HPDF_REAL  g
 , BYVAL HPDF_REAL _                          ' HPDF_REAL  b
 ) AS HPDF_STATUS                             ' HPDF_STATUS
' ========================================================================================

' ========================================================================================
DECLARE FUNCTION HPDF_Page_SetRGBStroke HPDF_CALLCONV LIB "LIBHPDF.DLL" ALIAS "HPDF_Page_SetRGBStroke" ( _
   BYVAL HPDF_Page _                          ' HPDF_Page  page
 , BYVAL HPDF_REAL _                          ' HPDF_REAL  r
 , BYVAL HPDF_REAL _                          ' HPDF_REAL  g
 , BYVAL HPDF_REAL _                          ' HPDF_REAL  b
 ) AS HPDF_STATUS                             ' HPDF_STATUS
' ========================================================================================

' ========================================================================================
DECLARE FUNCTION HPDF_Page_SetCMYKFill HPDF_CALLCONV LIB "LIBHPDF.DLL" ALIAS "HPDF_Page_SetCMYKFill" ( _
   BYVAL HPDF_Page _                          ' HPDF_Page  page
 , BYVAL HPDF_REAL _                          ' HPDF_REAL  c
 , BYVAL HPDF_REAL _                          ' HPDF_REAL  m
 , BYVAL HPDF_REAL _                          ' HPDF_REAL  y
 , BYVAL HPDF_REAL _                          ' HPDF_REAL  k
 ) AS HPDF_STATUS                             ' HPDF_STATUS
' ========================================================================================

' ========================================================================================
DECLARE FUNCTION HPDF_Page_SetCMYKStroke HPDF_CALLCONV LIB "LIBHPDF.DLL" ALIAS "HPDF_Page_SetCMYKStroke" ( _
   BYVAL HPDF_Page _                          ' HPDF_Page  page
 , BYVAL HPDF_REAL _                          ' HPDF_REAL  c
 , BYVAL HPDF_REAL _                          ' HPDF_REAL  m
 , BYVAL HPDF_REAL _                          ' HPDF_REAL  y
 , BYVAL HPDF_REAL _                          ' HPDF_REAL  k
 ) AS HPDF_STATUS                             ' HPDF_STATUS
' ========================================================================================

'/*--- Shading patterns ---------------------------------------------------*/

'/* sh --not implemented yet */

'/*--- In-line images -----------------------------------------------------*/

'/* BI --not implemented yet */
'/* ID --not implemented yet */
'/* EI --not implemented yet */

'/*--- XObjects -----------------------------------------------------------*/

' ========================================================================================
DECLARE FUNCTION HPDF_Page_ExecuteXObject HPDF_CALLCONV LIB "LIBHPDF.DLL" ALIAS "HPDF_Page_ExecuteXObject" ( _
   BYVAL HPDF_Page _                          ' HPDF_Page  page
 , BYVAL HPDF_XObject _                       ' HPDF_XObject  obj
 ) AS HPDF_STATUS                             ' HPDF_STATUS
' ========================================================================================

'/*--- Marked content -----------------------------------------------------*/

'/* BMC --not implemented yet */
'/* BDC --not implemented yet */
'/* EMC --not implemented yet */
'/* MP --not implemented yet */
'/* DP --not implemented yet */

'/*--- Compatibility ------------------------------------------------------*/

'/* BX --not implemented yet */
'/* EX --not implemented yet */

' ========================================================================================
DECLARE FUNCTION HPDF_Page_DrawImage HPDF_CALLCONV LIB "LIBHPDF.DLL" ALIAS "HPDF_Page_DrawImage" ( _
   BYVAL HPDF_Page _                          ' HPDF_Page    page
 , BYVAL HPDF_Image _                         ' HPDF_Image   image
 , BYVAL HPDF_REAL _                          ' HPDF_REAL    x
 , BYVAL HPDF_REAL _                          ' HPDF_REAL    y
 , BYVAL HPDF_REAL _                          ' HPDF_REAL    width
 , BYVAL HPDF_REAL _                          ' HPDF_REAL    height
 ) AS HPDF_STATUS                             ' HPDF_STATUS
' ========================================================================================

' ========================================================================================
DECLARE FUNCTION HPDF_Page_Circle HPDF_CALLCONV LIB "LIBHPDF.DLL" ALIAS "HPDF_Page_Circle" ( _
   BYVAL HPDF_Page _                          ' HPDF_Page     page
 , BYVAL HPDF_REAL _                          ' HPDF_REAL     x
 , BYVAL HPDF_REAL _                          ' HPDF_REAL     y
 , BYVAL HPDF_REAL _                          ' HPDF_REAL     ray
 ) AS HPDF_STATUS                             ' HPDF_STATUS
' ========================================================================================

' ========================================================================================
DECLARE FUNCTION HPDF_Page_Ellipse HPDF_CALLCONV LIB "LIBHPDF.DLL" ALIAS "HPDF_Page_Ellipse" ( _
   BYVAL HPDF_Page _                          ' HPDF_Page     page
 , BYVAL HPDF_REAL _                          ' HPDF_REAL     x
 , BYVAL HPDF_REAL _                          ' HPDF_REAL     y
 , BYVAL HPDF_REAL _                          ' HPDF_REAL     xray
 , BYVAL HPDF_REAL _                          ' HPDF_REAL     yray
 ) AS HPDF_STATUS                             ' HPDF_STATUS
' ========================================================================================

' ========================================================================================
DECLARE FUNCTION HPDF_Page_Arc HPDF_CALLCONV LIB "LIBHPDF.DLL" ALIAS "HPDF_Page_Arc" ( _
   BYVAL HPDF_Page _                          ' HPDF_Page     page
 , BYVAL HPDF_REAL _                          ' HPDF_REAL     x
 , BYVAL HPDF_REAL _                          ' HPDF_REAL     y
 , BYVAL HPDF_REAL _                          ' HPDF_REAL     ray
 , BYVAL HPDF_REAL _                          ' HPDF_REAL     ang1
 , BYVAL HPDF_REAL _                          ' HPDF_REAL     ang2
 ) AS HPDF_STATUS                             ' HPDF_STATUS
' ========================================================================================

' ========================================================================================
DECLARE FUNCTION HPDF_Page_TextOut HPDF_CALLCONV LIB "LIBHPDF.DLL" ALIAS "HPDF_Page_TextOut" ( _
   BYVAL HPDF_Page _                          ' HPDF_Page    page
 , BYVAL HPDF_REAL _                          ' HPDF_REAL    xpos
 , BYVAL HPDF_REAL _                          ' HPDF_REAL    ypos
 , BYREF ASCIIZ _                             ' const char  *text
 ) AS HPDF_STATUS                             ' HPDF_STATUS
' ========================================================================================

' ========================================================================================
DECLARE FUNCTION HPDF_Page_TextRect HPDF_CALLCONV LIB "LIBHPDF.DLL" ALIAS "HPDF_Page_TextRect" ( _
   BYVAL HPDF_Page _                          ' HPDF_Page            page
 , BYVAL HPDF_REAL _                          ' HPDF_REAL            left
 , BYVAL HPDF_REAL _                          ' HPDF_REAL            top
 , BYVAL HPDF_REAL _                          ' HPDF_REAL            right
 , BYVAL HPDF_REAL _                          ' HPDF_REAL            bottom
 , BYREF ASCIIZ _                             ' const char          *text
 , BYVAL HPDF_TextAlignment _                 ' HPDF_TextAlignment   align
 , BYREF HPDF_UINT _                          ' HPDF_UINT           *len
 ) AS HPDF_STATUS                             ' HPDF_STATUS
' ========================================================================================

' ========================================================================================
DECLARE FUNCTION HPDF_Page_SetSlideShow HPDF_CALLCONV LIB "LIBHPDF.DLL" ALIAS "HPDF_Page_SetSlideShow" ( _
   BYVAL HPDF_Page _                          ' HPDF_Page              page
 , BYVAL HPDF_TransitionStyle _               ' HPDF_TransitionStyle   type
 , BYVAL HPDF_REAL _                          ' HPDF_REAL              disp_time
 , BYVAL HPDF_REAL _                          ' HPDF_REAL              trans_time
 ) AS HPDF_STATUS                             ' HPDF_STATUS
' ========================================================================================

#ENDIF   ' #IF NOT %DEF(%HPDF_INC)
