' ########################################################################################
' * << Haru Free PDF Library 2.0.0 >> -- image_demo.bas
' * It is provided "as is" without express or implied warranty.
' ########################################################################################

' SED_PBWIN - Use the PBWIN compiler
#COMPILE EXE
#DIM ALL
#INCLUDE ONCE "windows.inc"
#INCLUDE ONCE "hpdf.inc"

' ========================================================================================
' Callback error handler procedure
' ========================================================================================
SUB HPDF_Error_Handler HPDF_CALLCONV() ( _
   BYVAL error_no AS HPDF_STATUS, _
   BYVAL detail_no AS HPDF_STATUS, _
   BYVAL user_data AS DWORD)

   LOCAL strMsg AS STRING

   strMsg = "Error number = " & STR$(error_no) & " [&H" & HEX$(error_no) & "]" & $CRLF
   strMsg = strMsg & "Detail number = " & STR$(detail_no) & " [&H" & HEX$(detail_no) & "]"
   ? strMsg

END SUB
' ========================================================================================

' ========================================================================================
' Shows the description
' ========================================================================================
SUB show_description ( _
   BYVAL hPage AS HPDF_Page, _
   BYVAL x AS SINGLE, _
   BYVAL y AS SINGLE, _
   BYREF szText AS ASCIIZ)

   LOCAL buf AS ASCIIZ * 255

   HPDF_Page_MoveTo (hPage, x, y - 10)
   HPDF_Page_LineTo (hPage, x, y + 10)
   HPDF_Page_MoveTo (hPage, x - 10, y)
   HPDF_Page_LineTo (hPage, x + 10, y)
   HPDF_Page_Stroke (hPage)

   HPDF_Page_SetFontAndSize (hPage, HPDF_Page_GetCurrentFont (hPage), 8)
   HPDF_Page_SetRGBFill (hPage, 0, 0, 0)

   HPDF_Page_BeginText (hPage)

   buf = "x=" & FORMAT$(x) & ",y=" & FORMAT$(y)
   HPDF_Page_MoveTextPos (hPage, x - HPDF_Page_TextWidth (hPage, buf) - 5, y - 10)
   HPDF_Page_ShowText (hPage, buf)
   HPDF_Page_EndText (hPage)

   HPDF_Page_BeginText (hPage)
   HPDF_Page_MoveTextPos (hPage, x - 20, y - 25)
   HPDF_Page_ShowText (hPage, szText)
   HPDF_Page_EndText (hPage)

END SUB
' ========================================================================================

' ========================================================================================
' Main
' ========================================================================================
FUNCTION PBMAIN

   LOCAL pdf AS HPDF_Doc
   LOCAL hFont AS HPDF_Font
   LOCAL hPage AS HPDF_Page
   LOCAL fname AS ASCIIZ * 256
   LOCAL dst AS HPDF_Destination
   LOCAL hImage AS HPDF_Image
   LOCAL hImage1 AS HPDF_Image
   LOCAL hImage2 AS HPDF_Image
   LOCAL hImage3 AS HPDF_Image

   LOCAL x AS DOUBLE
   LOCAL y AS DOUBLE
   LOCAL angle AS DOUBLE
   LOCAL angle1 AS DOUBLE
   LOCAL angle2 AS DOUBLE
   LOCAL rad AS DOUBLE
   LOCAL rad1 AS DOUBLE
   LOCAL rad2 AS DOUBLE

   LOCAL iw AS DOUBLE
   LOCAL ih AS DOUBLE

   fname = "image_demo.pdf"

   pdf = HPDF_New(CODEPTR(HPDF_Error_Handler), %NULL)
   IF pdf = %NULL THEN
      ? "Error: cannot create PdfDoc object"
      EXIT FUNCTION
   END IF

   HPDF_SetCompressionMode (pdf, %HPDF_COMP_ALL)

   ' /* create default-font */
   hFont = HPDF_GetFont (pdf, "Helvetica", BYVAL %NULL)

   ' /* add a new page object. */
   hPage = HPDF_AddPage (pdf)

   HPDF_Page_SetWidth (hPage, 550)
   HPDF_Page_SetHeight (hPage, 500)

   dst = HPDF_Page_CreateDestination (hPage)
   HPDF_Destination_SetXYZ (dst, 0, HPDF_Page_GetHeight (hPage), 1)
   HPDF_SetOpenAction(pdf, dst)

   HPDF_Page_BeginText (hPage)
   HPDF_Page_SetFontAndSize (hPage, hFont, 20)
   HPDF_Page_MoveTextPos (hPage, 220, HPDF_Page_GetHeight (hPage) - 70)
   HPDF_Page_ShowText (hPage, "Image Demo")
   HPDF_Page_EndText (hPage)

   ' /* load image file. */
   hImage = HPDF_LoadPngImageFromFile (pdf, "pngsuite/basn3p02.png")

   ' /* image1 is masked by image2. */
   hImage1 = HPDF_LoadPngImageFromFile (pdf, "pngsuite/basn3p02.png")

   ' /* image2 is a mask image. */
   hImage2 = HPDF_LoadPngImageFromFile (pdf, "pngsuite/basn0g01.png")

   ' /* image3 is a RGB-color image. we use this image for color-mask
   '  * demo.
   '  */
   hImage3 = HPDF_LoadPngImageFromFile (pdf, "pngsuite/maskimage.png")

   iw = HPDF_Image_GetWidth (hImage)
   ih = HPDF_Image_GetHeight (hImage)

   HPDF_Page_SetLineWidth (hPage, 0.5)

   x = 100
   y = HPDF_Page_GetHeight (hPage) - 150

   ' /* Draw image to the canvas. (normal-mode with actual size.)*/
   HPDF_Page_DrawImage (hPage, hImage, x, y, iw, ih)

   show_description (hPage, x, y, "Actual Size")

    x = x + 150

   ' /* Scalling image (X direction) */
   HPDF_Page_DrawImage (hPage, hImage, x, y, iw * 1.5, ih)

   show_description (hPage, x, y, "Scalling image (X direction)")

   x = x + 150

   ' /* Scalling image (Y direction). */
   HPDF_Page_DrawImage (hPage, hImage, x, y, iw, ih * 1.5)
   show_description (hPage, x, y, "Scalling image (Y direction)")

   x = 100
   y = y - 120

   ' /* Skewing image. */
   angle1 = 10
   angle2 = 20
   rad1 = angle1 / 180 * 3.141592
   rad2 = angle2 / 180 * 3.141592

   HPDF_Page_GSave (hPage)

   HPDF_Page_Concat (hPage, iw, TAN(rad1) * iw, TAN(rad2) * ih, ih, x, y)

   HPDF_Page_ExecuteXObject (hPage, hImage)
   HPDF_Page_GRestore (hPage)

   show_description (hPage, x, y, "Skewing image")

   x = x + 150

   ' /* Rotating image */
   angle = 30     ' /* rotation of 30 degrees. */
   rad = angle / 180 * 3.141592 ' /* Calculate the radian value. */

   HPDF_Page_GSave (hPage)

   HPDF_Page_Concat (hPage, iw * COS(rad), _
               iw * SIN(rad), _
               ih * -SIN(rad), _
               ih * COS(rad), _
               x, y)

   HPDF_Page_ExecuteXObject (hPage, hImage)
   HPDF_Page_GRestore (hPage)

   show_description (hPage, x, y, "Rotating image")

        x = x + 150

   ' /* draw masked image. */

   ' /* Set image2 to the mask image of image1 */
   HPDF_Image_SetMaskImage (hImage1, hImage2)

   HPDF_Page_SetRGBFill (hPage, 0, 0, 0)
   HPDF_Page_BeginText (hPage)
   HPDF_Page_MoveTextPos (hPage, x - 6, y + 14)
   HPDF_Page_ShowText (hPage, "MASKMASK")
   HPDF_Page_EndText (hPage)

   HPDF_Page_DrawImage (hPage, hImage1, x - 3, y - 3, iw + 6, ih + 6)

   show_description (hPage, x, y, "masked image")

        x = 100
        y = y - 120

   ' /* color mask. */
   HPDF_Page_SetRGBFill (hPage, 0, 0, 0)
   HPDF_Page_BeginText (hPage)
   HPDF_Page_MoveTextPos (hPage, x - 6, y + 14)
   HPDF_Page_ShowText (hPage, "MASKMASK")
   HPDF_Page_EndText (hPage)

   HPDF_Image_SetColorMask (hImage3, 0, 255, 0, 0, 0, 255)
   HPDF_Page_DrawImage (hPage, hImage3, x, y, iw, ih)

   show_description (hPage, x, y, "Color Mask")

   ' /* save the document to a file */
   HPDF_SaveToFile (pdf, fname)

   ' /* clean up */
   HPDF_Free (pdf)

   ' /* clean up */
   HPDF_Free (pdf)

   ? "Document created"

END FUNCTION
' ========================================================================================
