' ########################################################################################
' * << Haru Free PDF Library 2.0.0 >> -- line_demo.bas
' * It is provided "as is" without express or implied warranty.
' ########################################################################################

' SED_PBWIN - Use the PBWIN compiler
#COMPILE EXE
#DIM ALL
#INCLUDE ONCE "windows.inc"
#INCLUDE ONCE "hpdf.inc"

' ========================================================================================
' Callback error handler procedure
' ========================================================================================
SUB HPDF_Error_Handler HPDF_CALLCONV() ( _
   BYVAL error_no AS HPDF_STATUS, _
   BYVAL detail_no AS HPDF_STATUS, _
   BYVAL user_data AS DWORD)

   LOCAL strMsg AS STRING

   strMsg = "Error number = " & STR$(error_no) & " [&H" & HEX$(error_no) & "]" & $CRLF
   strMsg = strMsg & "Detail number = " & STR$(detail_no) & " [&H" & HEX$(detail_no) & "]"
   ? strMsg

END SUB
' ========================================================================================

' ========================================================================================
' Draws a line
' ========================================================================================
SUB draw_line ( _
   BYVAL hPage AS HPDF_Page, _
   BYVAL x AS SINGLE, _
   BYVAL y AS SINGLE, _
   BYREF szLabel AS ASCIIZ)

   HPDF_Page_BeginText (hPage)
   HPDF_Page_MoveTextPos (hPage, x, y - 10)
   HPDF_Page_ShowText (hPage, szLabel)
   HPDF_Page_EndText (hPage)

   HPDF_Page_MoveTo (hPage, x, y - 15)
   HPDF_Page_LineTo (hPage, x + 220, y - 15)
   HPDF_Page_Stroke (hPage)

END SUB
' ========================================================================================

' ========================================================================================
' Draws a line
' ========================================================================================
SUB draw_line2 ( _
   BYVAL hPage AS HPDF_Page, _
   BYVAL x AS SINGLE, _
   BYVAL y AS SINGLE, _
   BYREF szLabel AS ASCIIZ)

   HPDF_Page_BeginText (hPage)
   HPDF_Page_MoveTextPos (hPage, x, y)
   HPDF_Page_ShowText (hPage, szLabel)
   HPDF_Page_EndText (hPage)

   HPDF_Page_MoveTo (hPage, x + 30, y - 25)
   HPDF_Page_LineTo (hPage, x + 160, y - 25)
   HPDF_Page_Stroke (hPage)

END SUB
' ========================================================================================

' ========================================================================================
' Draws a rectangle
' ========================================================================================
SUB draw_rect ( _
   BYVAL hPage AS HPDF_Page, _
   BYVAL x AS DOUBLE, _
   BYVAL y AS DOUBLE, _
   BYREF szLabel AS ASCIIZ)

   HPDF_Page_BeginText (hPage)
   HPDF_Page_MoveTextPos (hPage, x, y - 10)
   HPDF_Page_ShowText (hPage, szLabel)
   HPDF_Page_EndText (hPage)

   HPDF_Page_Rectangle(hPage, x, y - 40, 220, 25)

END SUB
' ========================================================================================

' ========================================================================================
' Main
' ========================================================================================
FUNCTION PBMAIN

   LOCAL page_title AS ASCIIZ * 256

   page_title = "Line Example"

   LOCAL pdf AS HPDF_Doc
   LOCAL hFont AS HPDF_Font
   LOCAL hPage AS HPDF_Page
   LOCAL fname AS ASCIIZ * 256

   DIM DASH_MODE1(0) AS HPDF_UINT16
   DIM DASH_MODE2(1) AS HPDF_UINT16
   DIM DASH_MODE3(3) AS HPDF_UINT16

   ARRAY ASSIGN DASH_MODE1() = 3
   ARRAY ASSIGN DASH_MODE2() = 3, 7
   ARRAY ASSIGN DASH_MODE3() = 8, 7, 2, 7

   LOCAL x AS DOUBLE
   LOCAL y AS DOUBLE
   LOCAL x1 AS DOUBLE
   LOCAL y1 AS DOUBLE
   LOCAL x2 AS DOUBLE
   LOCAL y2 AS DOUBLE
   LOCAL x3 AS DOUBLE
   LOCAL y3 AS DOUBLE

   LOCAL tw AS SINGLE

   fname = "line_demo.pdf"

   pdf = HPDF_New(CODEPTR(HPDF_Error_Handler), %NULL)
   IF pdf = %NULL THEN
      ? "Error: cannot create PdfDoc object"
      EXIT FUNCTION
   END IF

   ' /* create default-font */
   hFont = HPDF_GetFont (pdf, "Helvetica", BYVAL %NULL)

   ' /* add a new page object. */
   hPage = HPDF_AddPage (pdf)

   ' /* print the lines of the page. */
   HPDF_Page_SetLineWidth (hPage, 1)
   HPDF_Page_Rectangle (hPage, 50, 50, HPDF_Page_GetWidth(hPage) - 100, _
               HPDF_Page_GetHeight (hPage) - 110)
   HPDF_Page_Stroke (hPage)

   ' /* print the title of the page (with positioning center). */
   HPDF_Page_SetFontAndSize (hPage, hFont, 24)
   tw = HPDF_Page_TextWidth (hPage, page_title)
   HPDF_Page_BeginText (hPage)
   HPDF_Page_MoveTextPos (hPage, (HPDF_Page_GetWidth(hPage) - tw) / 2, _
               HPDF_Page_GetHeight (hPage) - 50)
   HPDF_Page_ShowText (hPage, page_title)
   HPDF_Page_EndText (hPage)

   HPDF_Page_SetFontAndSize (hPage, hFont, 10)

   ' /* Draw various widths of lines. */
   HPDF_Page_SetLineWidth (hPage, 0)
   draw_line (hPage, 60, 770, "line width = 0")

   HPDF_Page_SetLineWidth (hPage, 1.0)
   draw_line (hPage, 60, 740, "line width = 1.0")

   HPDF_Page_SetLineWidth (hPage, 2.0)
   draw_line (hPage, 60, 710, "line width = 2.0")

   ' /* Line dash pattern */
   HPDF_Page_SetLineWidth (hPage, 1.0)

   HPDF_Page_SetDash (hPage, DASH_MODE1(0), 1, 1)
   draw_line (hPage, 60, 680, "dash_ptn=[3], phase=1 -- 2 on, 3 off, 3 on...")

   HPDF_Page_SetDash (hPage, DASH_MODE2(0), 2, 2)
   draw_line (hPage, 60, 650, "dash_ptn=[7, 3], phase=2 -- 5 on 3 off, 7 on,...")

   HPDF_Page_SetDash (hPage, DASH_MODE3(0), 4, 0)
   draw_line (hPage, 60, 620, "dash_ptn=[8, 7, 2, 7], phase=0")

   HPDF_Page_SetDash (hPage, BYVAL %NULL, 0, 0)

   HPDF_Page_SetLineWidth (hPage, 30)
   HPDF_Page_SetRGBStroke (hPage, 0.0, 0.5, 0.0)

   ' /* Line Cap Style */
   HPDF_Page_SetLineCap (hPage, %HPDF_BUTT_END)
   draw_line2 (hPage, 60, 570, "PDF_BUTT_END")

   HPDF_Page_SetLineCap (hPage, %HPDF_ROUND_END)
   draw_line2 (hPage, 60, 505, "PDF_ROUND_END")

   HPDF_Page_SetLineCap (hPage, %HPDF_PROJECTING_SCUARE_END)
   draw_line2 (hPage, 60, 440, "PDF_PROJECTING_SCUARE_END")

   ' /* Line Join Style */
   HPDF_Page_SetLineWidth (hPage, 30)
   HPDF_Page_SetRGBStroke (hPage, 0.0, 0.0, 0.5)

   HPDF_Page_SetLineJoin (hPage, %HPDF_MITER_JOIN)
   HPDF_Page_MoveTo (hPage, 120, 300)
   HPDF_Page_LineTo (hPage, 160, 340)
   HPDF_Page_LineTo (hPage, 200, 300)
   HPDF_Page_Stroke (hPage)

   HPDF_Page_BeginText (hPage)
   HPDF_Page_MoveTextPos (hPage, 60, 360)
   HPDF_Page_ShowText (hPage, "PDF_MITER_JOIN")
   HPDF_Page_EndText (hPage)

   HPDF_Page_SetLineJoin (hPage, %HPDF_ROUND_JOIN)
   HPDF_Page_MoveTo (hPage, 120, 195)
   HPDF_Page_LineTo (hPage, 160, 235)
   HPDF_Page_LineTo (hPage, 200, 195)
   HPDF_Page_Stroke (hPage)

   HPDF_Page_BeginText (hPage)
   HPDF_Page_MoveTextPos (hPage, 60, 255)
   HPDF_Page_ShowText (hPage, "PDF_ROUND_JOIN")
   HPDF_Page_EndText (hPage)

   HPDF_Page_SetLineJoin (hPage, %HPDF_BEVEL_JOIN)
   HPDF_Page_MoveTo (hPage, 120, 90)
   HPDF_Page_LineTo (hPage, 160, 130)
   HPDF_Page_LineTo (hPage, 200, 90)
   HPDF_Page_Stroke (hPage)

   HPDF_Page_BeginText (hPage)
   HPDF_Page_MoveTextPos (hPage, 60, 150)
   HPDF_Page_ShowText (hPage, "PDF_BEVEL_JOIN")
   HPDF_Page_EndText (hPage)

   ' /* Draw Rectangle */
   HPDF_Page_SetLineWidth (hPage, 2)
   HPDF_Page_SetRGBStroke (hPage, 0, 0, 0)
   HPDF_Page_SetRGBFill (hPage, 0.75, 0.0, 0.0)

   draw_rect (hPage, 300, 770, "Stroke")
   HPDF_Page_Stroke (hPage)

   draw_rect (hPage, 300, 720, "Fill")
   HPDF_Page_Fill (hPage)

   draw_rect (hPage, 300, 670, "Fill then Stroke")
   HPDF_Page_FillStroke (hPage)

   ' /* Clip Rect */
   HPDF_Page_GSave (hPage)  ' /* Save the current graphic state */
   draw_rect (hPage, 300, 620, "Clip Rectangle")
   HPDF_Page_Clip (hPage)
   HPDF_Page_Stroke (hPage)
   HPDF_Page_SetFontAndSize (hPage, hFont, 13)

   HPDF_Page_BeginText (hPage)
   HPDF_Page_MoveTextPos (hPage, 290, 600)
   HPDF_Page_SetTextLeading (hPage, 12)
   HPDF_Page_ShowText (hPage, _
               "Clip Clip Clip Clip Clip Clipi Clip Clip Clip")
   HPDF_Page_ShowTextNextLine (hPage, _
               "Clip Clip Clip Clip Clip Clip Clip Clip Clip")
   HPDF_Page_ShowTextNextLine (hPage, _
               "Clip Clip Clip Clip Clip Clip Clip Clip Clip")
   HPDF_Page_EndText (hPage)
   HPDF_Page_GRestore (hPage)

   ' /* Curve Example(CurveTo2) */
   x = 330
   y = 440
   x1 = 430
   y1 = 530
   x2 = 480
   y2 = 470
   x3 = 480
   y3 = 90

   HPDF_Page_SetRGBFill (hPage, 0, 0, 0)

   HPDF_Page_BeginText (hPage)
   HPDF_Page_MoveTextPos (hPage, 300, 540)
   HPDF_Page_ShowText (hPage, "CurveTo2(x1, y1, x2. y2)")
   HPDF_Page_EndText (hPage)

   HPDF_Page_BeginText (hPage)
   HPDF_Page_MoveTextPos (hPage, x + 5, y - 5)
   HPDF_Page_ShowText (hPage, "Current point")
   HPDF_Page_MoveTextPos (hPage, x1 - x, y1 - y)
   HPDF_Page_ShowText (hPage, "(x1, y1)")
   HPDF_Page_MoveTextPos (hPage, x2 - x1, y2 - y1)
   HPDF_Page_ShowText (hPage, "(x2, y2)")
   HPDF_Page_EndText (hPage)

   HPDF_Page_SetDash (hPage, DASH_MODE1(0), 1, 0)

   HPDF_Page_SetLineWidth (hPage, 0.5)
   HPDF_Page_MoveTo (hPage, x1, y1)
   HPDF_Page_LineTo (hPage, x2, y2)
   HPDF_Page_Stroke (hPage)

   HPDF_Page_SetDash (hPage, BYVAL %NULL, 0, 0)

   HPDF_Page_SetLineWidth (hPage, 1.5)

   HPDF_Page_MoveTo (hPage, x, y)
   HPDF_Page_CurveTo2 (hPage, x1, y1, x2, y2)
   HPDF_Page_Stroke (hPage)

   ' /* Curve Example(CurveTo3) */
   y = y - 150
   y1 = y1 - 150
   y2 = y2 - 150

   HPDF_Page_BeginText (hPage)
   HPDF_Page_MoveTextPos (hPage, 300, 390)
   HPDF_Page_ShowText (hPage, "CurveTo3(x1, y1, x2. y2)")
   HPDF_Page_EndText (hPage)

   HPDF_Page_BeginText (hPage)
   HPDF_Page_MoveTextPos (hPage, x + 5, y - 5)
   HPDF_Page_ShowText (hPage, "Current point")
   HPDF_Page_MoveTextPos (hPage, x1 - x, y1 - y)
   HPDF_Page_ShowText (hPage, "(x1, y1)")
   HPDF_Page_MoveTextPos (hPage, x2 - x1, y2 - y1)
   HPDF_Page_ShowText (hPage, "(x2, y2)")
   HPDF_Page_EndText (hPage)

   HPDF_Page_SetDash (hPage, DASH_MODE1(0), 1, 0)

   HPDF_Page_SetLineWidth (hPage, 0.5)
   HPDF_Page_MoveTo (hPage, x, y)
   HPDF_Page_LineTo (hPage, x1, y1)
   HPDF_Page_Stroke (hPage)

   HPDF_Page_SetDash (hPage, BYVAL %NULL, 0, 0)

   HPDF_Page_SetLineWidth (hPage, 1.5)
   HPDF_Page_MoveTo (hPage, x, y)
   HPDF_Page_CurveTo3 (hPage, x1, y1, x2, y2)
   HPDF_Page_Stroke (hPage)

   ' /* Curve Example(CurveTo) */
   y = y - 150
   y1 = y1 - 160
   y2 = y2 - 130
   x2 = x2 + 10

   HPDF_Page_BeginText (hPage)
   HPDF_Page_MoveTextPos (hPage, 300, 240)
   HPDF_Page_ShowText (hPage, "CurveTo(x1, y1, x2. y2, x3, y3)")
   HPDF_Page_EndText (hPage)

   HPDF_Page_BeginText (hPage)
   HPDF_Page_MoveTextPos (hPage, x + 5, y - 5)
   HPDF_Page_ShowText (hPage, "Current point")
   HPDF_Page_MoveTextPos (hPage, x1 - x, y1 - y)
   HPDF_Page_ShowText (hPage, "(x1, y1)")
   HPDF_Page_MoveTextPos (hPage, x2 - x1, y2 - y1)
   HPDF_Page_ShowText (hPage, "(x2, y2)")
   HPDF_Page_MoveTextPos (hPage, x3 - x2, y3 - y2)
   HPDF_Page_ShowText (hPage, "(x3, y3)")
   HPDF_Page_EndText (hPage)

   HPDF_Page_SetDash (hPage, DASH_MODE1(0), 1, 0)

   HPDF_Page_SetLineWidth (hPage, 0.5)
   HPDF_Page_MoveTo (hPage, x, y)
   HPDF_Page_LineTo (hPage, x1, y1)
   HPDF_Page_Stroke (hPage)
   HPDF_Page_MoveTo (hPage, x2, y2)
   HPDF_Page_LineTo (hPage, x3, y3)
   HPDF_Page_Stroke (hPage)

   HPDF_Page_SetDash (hPage, BYVAL %NULL, 0, 0)

   HPDF_Page_SetLineWidth (hPage, 1.5)
   HPDF_Page_MoveTo (hPage, x, y)
   HPDF_Page_CurveTo (hPage, x1, y1, x2, y2, x3, y3)
   HPDF_Page_Stroke (hPage)

   ' /* save the document to a file */
   HPDF_SaveToFile (pdf, fname)

   ' /* clean up */
   HPDF_Free (pdf)

   ? "Document created"

END FUNCTION
' ========================================================================================
