' ########################################################################################
' * << Haru Free PDF Library 2.0.0 >> -- link_annotation.bas
' * It is provided "as is" without express or implied warranty.
' ########################################################################################

' SED_PBWIN - Use the PBWIN compiler
#COMPILE EXE
#DIM ALL
#INCLUDE ONCE "windows.inc"
#INCLUDE ONCE "hpdf.inc"

' ========================================================================================
' Callback error handler procedure
' ========================================================================================
SUB HPDF_Error_Handler HPDF_CALLCONV() ( _
   BYVAL error_no AS HPDF_STATUS, _
   BYVAL detail_no AS HPDF_STATUS, _
   BYVAL user_data AS DWORD)

   LOCAL strMsg AS STRING

   strMsg = "Error number = " & STR$(error_no) & " [&H" & HEX$(error_no) & "]" & $CRLF
   strMsg = strMsg & "Detail number = " & STR$(detail_no) & " [&H" & HEX$(detail_no) & "]"
   ? strMsg

END SUB
' ========================================================================================

' ========================================================================================
' Print the page
' ========================================================================================
SUB print_page  (BYVAL hPage AS HPDF_Page, BYVAL hFont AS HPDF_Font, BYVAL page_num AS LONG)

   LOCAL buf AS ASCIIZ * 50

   HPDF_Page_SetWidth (hPage, 200)
   HPDF_Page_SetHeight (hPage, 200)

   HPDF_Page_SetFontAndSize (hPage, hFont, 20)

   HPDF_Page_BeginText (hPage)
   HPDF_Page_MoveTextPos (hPage, 50, 150)
   buf = "Page: " & FORMAT$(page_num)
   HPDF_Page_ShowText (hPage, buf)
   HPDF_Page_EndText (hPage)

END SUB
' ========================================================================================

' ========================================================================================
' Main
' ========================================================================================
FUNCTION PBMAIN

   LOCAL pdf AS HPDF_Doc
   LOCAL hFont AS HPDF_Font
   LOCAL index_page AS HPDF_Page
   DIM   pages(0 TO 6) AS HPDF_Page
   LOCAL dst AS HPDF_Destination
   LOCAL fname AS ASCIIZ * 256
   LOCAL rc AS HPDF_Rect
   LOCAL tp AS HPDF_Point
   LOCAL tp2 AS HPDF_Point
   LOCAL annot AS HPDF_Annotation
   LOCAL i AS LONG
   LOCAL uri AS ASCIIZ * 256

   uri = "http://sourceforge.net/projects/libharu"

   fname = "link_annotation.pdf"

   pdf = HPDF_New(CODEPTR(HPDF_Error_Handler), %NULL)
   IF pdf = %NULL THEN
      ? "Error: cannot create PdfDoc object"
      EXIT FUNCTION
   END IF

   ' /* create default-font */
   hFont = HPDF_GetFont (pdf, "Helvetica", BYVAL %NULL)

   ' /* create index page */
   index_page = HPDF_AddPage (pdf)
   HPDF_Page_SetWidth (index_page, 300)
   HPDF_Page_SetHeight (index_page, 220)

   ' /* Add 7 pages to the document. */
   FOR i = 0 TO 6
      pages(i) = HPDF_AddPage (pdf)
      print_page(pages(i), hFont, i + 1)
   NEXT

   HPDF_Page_BeginText (index_page)
   HPDF_Page_SetFontAndSize (index_page, hFont, 10)
   HPDF_Page_MoveTextPos (index_page, 15, 200)
   HPDF_Page_ShowText (index_page, "Link Annotation Demo")
   HPDF_Page_EndText (index_page)

   ' /*
   '  * Create Link-Annotation object on index page.
   '  */
   HPDF_Page_BeginText(index_page)
   HPDF_Page_SetFontAndSize (index_page, hFont, 8)
   HPDF_Page_MoveTextPos (index_page, 20, 180)
   HPDF_Page_SetTextLeading (index_page, 23)

   ' /* page1 (HPDF_ANNOT_NO_HIGHTLIGHT) */
   HPDF_Page_GetCurrentTextPos2 (index_page, tp)

   HPDF_Page_ShowText (index_page, "Jump to Page1 (HilightMode=HPDF_ANNOT_NO_HIGHTLIGHT)")
   rc.left = tp.x - 4
   rc.bottom = tp.y - 4
   HPDF_Page_GetCurrentTextPos2 (index_page, tp2)
   rc.right = tp2.x + 4
   rc.top = tp.y + 10

   HPDF_Page_MoveToNextLine (index_page)

   dst = HPDF_Page_CreateDestination (pages(0))

   annot = HPDF_Page_CreateLinkAnnot (index_page, rc, dst)

   HPDF_LinkAnnot_SetHighlightMode (annot, %HPDF_ANNOT_NO_HIGHTLIGHT)

   ' /* page2 (HPDF_ANNOT_INVERT_BOX) */
   HPDF_Page_GetCurrentTextPos2 (index_page, tp)

   HPDF_Page_ShowText (index_page, "Jump to Page2 (HilightMode=HPDF_ANNOT_INVERT_BOX)")
   rc.left = tp.x - 4
   rc.bottom = tp.y - 4
   HPDF_Page_GetCurrentTextPos2 (index_page, tp2)
   rc.right = tp2.x + 4
   rc.top = tp.y + 10

   HPDF_Page_MoveToNextLine (index_page)

   dst = HPDF_Page_CreateDestination (pages(1))

   annot = HPDF_Page_CreateLinkAnnot (index_page, rc, dst)

   HPDF_LinkAnnot_SetHighlightMode (annot, %HPDF_ANNOT_INVERT_BOX)

   ' /* page3 (HPDF_ANNOT_INVERT_BORDER) */
   HPDF_Page_GetCurrentTextPos2 (index_page, tp)

   HPDF_Page_ShowText (index_page, "Jump to Page3 (HilightMode=HPDF_ANNOT_INVERT_BORDER)")
   rc.left = tp.x - 4
   rc.bottom = tp.y - 4
   HPDF_Page_GetCurrentTextPos2 (index_page, tp2)
   rc.right = tp2.x + 4
   rc.top = tp.y + 10

   HPDF_Page_MoveToNextLine (index_page)

   dst = HPDF_Page_CreateDestination (pages(2))

   annot = HPDF_Page_CreateLinkAnnot (index_page, rc, dst)

   HPDF_LinkAnnot_SetHighlightMode (annot, %HPDF_ANNOT_INVERT_BORDER)

   ' /* page4 (HPDF_ANNOT_DOWN_APPEARANCE) */
   HPDF_Page_GetCurrentTextPos2 (index_page, tp)

   HPDF_Page_ShowText (index_page, "Jump to Page4 (HilightMode=HPDF_ANNOT_DOWN_APPEARANCE)")
   rc.left = tp.x - 4
   rc.bottom = tp.y - 4
   HPDF_Page_GetCurrentTextPos2 (index_page, tp2)
   rc.right = tp2.x + 4
   rc.top = tp.y + 10

   HPDF_Page_MoveToNextLine (index_page)

   dst = HPDF_Page_CreateDestination (pages(3))

   annot = HPDF_Page_CreateLinkAnnot (index_page, rc, dst)

   HPDF_LinkAnnot_SetHighlightMode (annot, %HPDF_ANNOT_DOWN_APPEARANCE)

   ' /* page5 (dash border) */
   HPDF_Page_GetCurrentTextPos2 (index_page, tp)

   HPDF_Page_ShowText (index_page, "Jump to Page5 (dash border)")
   rc.left = tp.x - 4
   rc.bottom = tp.y - 4
   HPDF_Page_GetCurrentTextPos2 (index_page, tp2)
   rc.right = tp2.x + 4
   rc.top = tp.y + 10

   HPDF_Page_MoveToNextLine (index_page)

   dst = HPDF_Page_CreateDestination (pages(4))

   annot = HPDF_Page_CreateLinkAnnot (index_page, rc, dst)

   HPDF_LinkAnnot_SetBorderStyle (annot, 1, 3, 2)


   ' /* page6 (no border) */
   HPDF_Page_GetCurrentTextPos2 (index_page, tp)

   HPDF_Page_ShowText (index_page, "Jump to Page6 (no border)")
   rc.left = tp.x - 4
   rc.bottom = tp.y - 4
   HPDF_Page_GetCurrentTextPos2 (index_page, tp2)
   rc.right = tp2.x + 4
   rc.top = tp.y + 10

   HPDF_Page_MoveToNextLine (index_page)

   dst = HPDF_Page_CreateDestination (pages(5))

   annot = HPDF_Page_CreateLinkAnnot (index_page, rc, dst)

   HPDF_LinkAnnot_SetBorderStyle (annot, 0, 0, 0)


   ' /* page7 (bold border) */
   HPDF_Page_GetCurrentTextPos2 (index_page, tp)

   HPDF_Page_ShowText (index_page, "Jump to Page7 (bold border)")
   rc.left = tp.x - 4
   rc.bottom = tp.y - 4
   HPDF_Page_GetCurrentTextPos2 (index_page, tp2)
   rc.right = tp2.x + 4
   rc.top = tp.y + 10

   HPDF_Page_MoveToNextLine (index_page)

   dst = HPDF_Page_CreateDestination (pages(6))

   annot = HPDF_Page_CreateLinkAnnot (index_page, rc, dst)

   HPDF_LinkAnnot_SetBorderStyle (annot, 2, 0, 0)

   ' /* URI link */
   HPDF_Page_GetCurrentTextPos2 (index_page, tp)

   HPDF_Page_ShowText (index_page, "URI (")
   HPDF_Page_ShowText (index_page, uri)
   HPDF_Page_ShowText (index_page, ")")

   rc.left = tp.x - 4
   rc.bottom = tp.y - 4
   HPDF_Page_GetCurrentTextPos2 (index_page, tp2)
   rc.right = tp2.x + 4
   rc.top = tp.y + 10

   HPDF_Page_CreateURILinkAnnot (index_page, rc, uri)

   HPDF_Page_EndText (index_page)

   ' /* save the document to a file */
   HPDF_SaveToFile (pdf, fname)

   ' /* clean up */
   HPDF_Free (pdf)

   ? "Document created"

END FUNCTION
' ========================================================================================
