' ########################################################################################
' * << Haru Free PDF Library 2.0.0 >> -- outline_demo.bas
' * It is provided "as is" without express or implied warranty.
' ########################################################################################

' SED_PBWIN - Use the PBWIN compiler
#COMPILE EXE
#DIM ALL
#INCLUDE ONCE "windows.inc"
#INCLUDE ONCE "hpdf.inc"

' ========================================================================================
' Callback error handler procedure
' ========================================================================================
SUB HPDF_Error_Handler HPDF_CALLCONV() ( _
   BYVAL error_no AS HPDF_STATUS, _
   BYVAL detail_no AS HPDF_STATUS, _
   BYVAL user_data AS DWORD)

   LOCAL strMsg AS STRING

   strMsg = "Error number = " & STR$(error_no) & " [&H" & HEX$(error_no) & "]" & $CRLF
   strMsg = strMsg & "Detail number = " & STR$(detail_no) & " [&H" & HEX$(detail_no) & "]"
   ? strMsg

END SUB
' ========================================================================================

' ========================================================================================
' Print the page
' ========================================================================================
SUB print_page (BYVAL hPage AS HPDF_Page, BYVAL page_num AS LONG)

   LOCAL buf AS ASCIIZ * 50

   HPDF_Page_SetWidth (hPage, 800)
   HPDF_Page_SetHeight (hPage, 800)

   HPDF_Page_BeginText (hPage)
   HPDF_Page_MoveTextPos (hPage, 30, 740)
   buf = "Page: " & FORMAT$(page_num)
   HPDF_Page_ShowText (hPage, buf)
   HPDF_Page_EndText (hPage)

END SUB
' ========================================================================================

' ========================================================================================
' Main
' ========================================================================================
FUNCTION PBMAIN

   LOCAL pdf AS HPDF_Doc
   LOCAL hFont AS HPDF_Font
   DIM   pages(0 TO 3) AS HPDF_Page
   LOCAL root AS HPDF_Outline
   DIM outline(0 TO 3) AS HPDF_Outline
   LOCAL dst AS HPDF_Destination
   LOCAL fname AS ASCIIZ * 256

   fname = "outline_demo.pdf"

   pdf = HPDF_New(CODEPTR(HPDF_Error_Handler), %NULL)
   IF pdf = %NULL THEN
      ? "Error: cannot create PdfDoc object"
      EXIT FUNCTION
   END IF

   ' /* create default-font */
   hFont = HPDF_GetFont (pdf, "Helvetica", BYVAL %NULL)

   ' /* Set page mode to use outlines. */
   HPDF_SetPageMode(pdf, %HPDF_PAGE_MODE_USE_OUTLINE)

   ' /* Add 3 pages to the document. */
   pages(0) = HPDF_AddPage (pdf)
   HPDF_Page_SetFontAndSize (pages(0), hFont, 30)
   print_page(pages(0), 1)

   pages(1) = HPDF_AddPage (pdf)
   HPDF_Page_SetFontAndSize (pages(1), hFont, 30)
   print_page(pages(1), 2)

   pages(2) = HPDF_AddPage (pdf)
   HPDF_Page_SetFontAndSize (pages(2), hFont, 30)
   print_page(pages(2), 3)

   ' /* create outline root. */
   root = HPDF_CreateOutline (pdf, %NULL, "OutlineRoot", %NULL)
   HPDF_Outline_SetOpened (root, %HPDF_TRUE)

   outline(0) = HPDF_CreateOutline (pdf, root, "page1", %NULL)
   outline(1) = HPDF_CreateOutline (pdf, root, "page2", %NULL)

   ' /* create outline with test which is ISO8859-2 encoding */
   outline(2) = HPDF_CreateOutline (pdf, root, "ISO8859-2 text ", _
                    HPDF_GetEncoder (pdf, "ISO8859-2"))

   ' /* create destination objects on each pages
   '  * and link it to outline items.
   '  */
   dst = HPDF_Page_CreateDestination (pages(0))
   HPDF_Destination_SetXYZ(dst, 0, HPDF_Page_GetHeight(pages(0)), 1)
   HPDF_Outline_SetDestination(outline(0), dst)
   '//  HPDF_Catalog_SetOpenAction(dst)

   dst = HPDF_Page_CreateDestination (pages(1))
   HPDF_Destination_SetXYZ(dst, 0, HPDF_Page_GetHeight(pages(1)), 1)
   HPDF_Outline_SetDestination(outline(1), dst)

   dst = HPDF_Page_CreateDestination (pages(2))
   HPDF_Destination_SetXYZ(dst, 0, HPDF_Page_GetHeight(pages(2)), 1)
   HPDF_Outline_SetDestination(outline(2), dst)

   ' /* save the document to a file */
   HPDF_SaveToFile (pdf, fname)

   ' /* clean up */
   HPDF_Free (pdf)

   ? "Document created"

END FUNCTION
' ========================================================================================
