' ########################################################################################
' * << Haru Free PDF Library 2.0.0 >> -- png_demo.bas
' * It is provided "as is" without express or implied warranty.
' ########################################################################################

' SED_PBWIN - Use the PBWIN compiler
#COMPILE EXE
#DIM ALL
#INCLUDE ONCE "windows.inc"
#INCLUDE ONCE "hpdf.inc"

' ========================================================================================
' Callback error handler procedure
' ========================================================================================
SUB HPDF_Error_Handler HPDF_CALLCONV() ( _
   BYVAL error_no AS HPDF_STATUS, _
   BYVAL detail_no AS HPDF_STATUS, _
   BYVAL user_data AS DWORD)

   LOCAL strMsg AS STRING

   strMsg = "Error number = " & STR$(error_no) & " [&H" & HEX$(error_no) & "]" & $CRLF
   strMsg = strMsg & "Detail number = " & STR$(detail_no) & " [&H" & HEX$(detail_no) & "]"
   ? strMsg

END SUB
' ========================================================================================

' ========================================================================================
' Draws the image
' ========================================================================================
SUB draw_image ( _
   BYVAL pdf AS HPDF_Doc, _
   BYREF fname AS ASCIIZ, _
   BYVAL x AS SINGLE, _
   BYVAL y AS SINGLE, _
   BYREF szText AS ASCIIZ)

   LOCAL fname1 AS ASCIIZ * 255
   LOCAL hPage AS HPDF_Page
   LOCAL hImage AS HPDF_Image

   hPage = HPDF_GetCurrentPage (pdf)

   fname1 = "pngsuite/" & fname

   hImage = HPDF_LoadPngImageFromFile (pdf, fname1)

   ' /* Draw image to the canvas. */
   HPDF_Page_DrawImage (hPage, hImage, x, y, HPDF_Image_GetWidth (hImage), _
                   HPDF_Image_GetHeight (hImage))

   ' /* Print the text. */
   HPDF_Page_BeginText (hPage)
   HPDF_Page_SetTextLeading (hPage, 16)
   HPDF_Page_MoveTextPos (hPage, x, y)
   HPDF_Page_ShowTextNextLine (hPage, fname)
   HPDF_Page_ShowTextNextLine (hPage, szText)
   HPDF_Page_EndText (hPage)

END SUB
' ========================================================================================

' ========================================================================================
' Main
' ========================================================================================
FUNCTION PBMAIN

   LOCAL pdf AS HPDF_Doc
   LOCAL hFont AS HPDF_Font
   LOCAL hPage AS HPDF_Page
   LOCAL fname AS ASCIIZ * 256
   LOCAL dst AS HPDF_Destination

   fname = "png_demo.pdf"

   pdf = HPDF_New(CODEPTR(HPDF_Error_Handler), %NULL)
   IF pdf = %NULL THEN
      ? "Error: cannot create PdfDoc object"
      EXIT FUNCTION
   END IF

   HPDF_SetCompressionMode (pdf, %HPDF_COMP_ALL)

   ' /* create default-font */
   hFont = HPDF_GetFont (pdf, "Helvetica", BYVAL %NULL)

   ' /* add a new page object. */
   hPage = HPDF_AddPage (pdf)

   HPDF_Page_SetWidth (hPage, 550)
   HPDF_Page_SetHeight (hPage, 650)

   dst = HPDF_Page_CreateDestination (hPage)
   HPDF_Destination_SetXYZ (dst, 0, HPDF_Page_GetHeight (hPage), 1)
   HPDF_SetOpenAction(pdf, dst)

   HPDF_Page_BeginText (hPage)
   HPDF_Page_SetFontAndSize (hPage, hFont, 20)
   HPDF_Page_MoveTextPos (hPage, 220, HPDF_Page_GetHeight (hPage) - 70)
   HPDF_Page_ShowText (hPage, "PNG Demo")
   HPDF_Page_EndText (hPage)

   HPDF_Page_SetFontAndSize (hPage, hFont, 12)

   draw_image (pdf, "basn0g01.png", 100, HPDF_Page_GetHeight (hPage) - 150, _
               "1bit grayscale.")
   draw_image (pdf, "basn0g02.png", 200, HPDF_Page_GetHeight (hPage) - 150, _
               "2bit grayscale.")
   draw_image (pdf, "basn0g04.png", 300, HPDF_Page_GetHeight (hPage) - 150, _
               "4bit grayscale.")
   draw_image (pdf, "basn0g08.png", 400, HPDF_Page_GetHeight (hPage) - 150, _
               "8bit grayscale.")

   draw_image (pdf, "basn2c08.png", 100, HPDF_Page_GetHeight (hPage) - 250, _
               "8bit color.")
   draw_image (pdf, "basn2c16.png", 200, HPDF_Page_GetHeight (hPage) - 250, _
               "16bit color.")

   draw_image (pdf, "basn3p01.png", 100, HPDF_Page_GetHeight (hPage) - 350, _
               "1bit pallet.")
   draw_image (pdf, "basn3p02.png", 200, HPDF_Page_GetHeight (hPage) - 350, _
               "2bit pallet.")
   draw_image (pdf, "basn3p04.png", 300, HPDF_Page_GetHeight (hPage) - 350, _
               "4bit pallet.")
   draw_image (pdf, "basn3p08.png", 400, HPDF_Page_GetHeight (hPage) - 350, _
               "8bit pallet.")

   draw_image (pdf, "basn4a08.png", 100, HPDF_Page_GetHeight (hPage) - 450, _
               "8bit alpha.")
   draw_image (pdf, "basn4a16.png", 200, HPDF_Page_GetHeight (hPage) - 450, _
               "16bit alpha.")

   draw_image (pdf, "basn6a08.png", 100, HPDF_Page_GetHeight (hPage) - 550, _
               "8bit alpha.")
   draw_image (pdf, "basn6a16.png", 200, HPDF_Page_GetHeight (hPage) - 550, _
               "16bit alpha.")

   ' /* save the document to a file */
   HPDF_SaveToFile (pdf, fname)

   ' /* clean up */
   HPDF_Free (pdf)

   ? "Document created"

END FUNCTION
' ========================================================================================

