' ########################################################################################
' * << Haru Free PDF Library 2.0.0 >> -- raw_image_demo.bas
' * It is provided "as is" without express or implied warranty.
' ########################################################################################

' SED_PBWIN - Use the PBWIN compiler
#COMPILE EXE
#DIM ALL
#INCLUDE ONCE "windows.inc"
#INCLUDE ONCE "hpdf.inc"

' ========================================================================================
' Callback error handler procedure
' ========================================================================================
SUB HPDF_Error_Handler HPDF_CALLCONV() ( _
   BYVAL error_no AS HPDF_STATUS, _
   BYVAL detail_no AS HPDF_STATUS, _
   BYVAL user_data AS DWORD)

   LOCAL strMsg AS STRING

   strMsg = "Error number = " & STR$(error_no) & " [&H" & HEX$(error_no) & "]" & $CRLF
   strMsg = strMsg & "Detail number = " & STR$(detail_no) & " [&H" & HEX$(detail_no) & "]"
   ? strMsg

END SUB
' ========================================================================================

' ========================================================================================
' Main
' ========================================================================================
FUNCTION PBMAIN

   LOCAL pdf AS HPDF_Doc
   LOCAL hFont AS HPDF_Font
   LOCAL hPage AS HPDF_Page
   LOCAL fname AS ASCIIZ * 256
   LOCAL hImage AS HPDF_Image

   LOCAL x AS HPDF_REAL
   LOCAL y AS HPDF_REAL

   DIM RAW_IMAGE_DATA (0 TO 127) AS HPDF_BYTE

   ARRAY ASSIGN RAW_IMAGE_DATA () = _
         &Hff, &Hff, &Hff, &Hfe, &Hff, &Hff, &Hff, &Hfc, _
         &Hff, &Hff, &Hff, &Hf8, &Hff, &Hff, &Hff, &Hf0, _
         &Hf3, &Hf3, &Hff, &He0, &Hf3, &Hf3, &Hff, &Hc0, _
         &Hf3, &Hf3, &Hff, &H80, &Hf3, &H33, &Hff, &H00, _
         &Hf3, &H33, &Hfe, &H00, &Hf3, &H33, &Hfc, &H00, _
         &Hf8, &H07, &Hf8, &H00, &Hf8, &H07, &Hf0, &H00, _
         &Hfc, &Hcf, &He0, &H00, &Hfc, &Hcf, &Hc0, &H00, _
         &Hff, &Hff, &H80, &H00, &Hff, &Hff, &H00, &H00, _
         &Hff, &Hfe, &H00, &H00, &Hff, &Hfc, &H00, &H00, _
         &Hff, &Hf8, &H0f, &He0, &Hff, &Hf0, &H0f, &He0, _
         &Hff, &He0, &H0c, &H30, &Hff, &Hc0, &H0c, &H30, _
         &Hff, &H80, &H0f, &He0, &Hff, &H00, &H0f, &He0, _
         &Hfe, &H00, &H0c, &H30, &Hfc, &H00, &H0c, &H30, _
         &Hf8, &H00, &H0f, &He0, &Hf0, &H00, &H0f, &He0, _
         &He0, &H00, &H00, &H00, &Hc0, &H00, &H00, &H00, _
         &H80, &H00, &H00, &H00, &H00, &H00, &H00, &H00

   fname = "raw_image_demo.pdf"

   pdf = HPDF_New(CODEPTR(HPDF_Error_Handler), %NULL)
   IF pdf = %NULL THEN
      ? "Error: cannot create PdfDoc object"
      EXIT FUNCTION
   END IF

   HPDF_SetCompressionMode (pdf, %HPDF_COMP_ALL)

   ' /* create default-font */
   hFont = HPDF_GetFont (pdf, "Helvetica", BYVAL %NULL)

   ' /* add a new page object. */
   hPage = HPDF_AddPage (pdf)

   HPDF_Page_SetWidth (hPage, 172)
   HPDF_Page_SetHeight (hPage, 80)

   HPDF_Page_BeginText (hPage)
   HPDF_Page_SetFontAndSize (hPage, hFont, 20)
   HPDF_Page_MoveTextPos (hPage, 220, HPDF_Page_GetHeight (hPage) - 70)
   HPDF_Page_ShowText (hPage, "Raw Image Demo")
   HPDF_Page_EndText (hPage)

   ' /* load RGB raw-image file. */
   hImage = HPDF_LoadRawImageFromFile (pdf, "rawimage/32_32_rgb.dat", _
            32, 32, %HPDF_CS_DEVICE_RGB)

   x = 20
   y = 20

   ' /* Draw image to the canvas. (normal-mode with actual size.)*/
   HPDF_Page_DrawImage (hPage, hImage, x, y, 32, 32)

   ' /* load GrayScale raw-image file. */
   hImage = HPDF_LoadRawImageFromFile (pdf, "rawimage/32_32_gray.dat", _
            32, 32, %HPDF_CS_DEVICE_GRAY)

   x = 70
   y = 20

   ' /* Draw image to the canvas. (normal-mode with actual size.)*/
   HPDF_Page_DrawImage (hPage, hImage, x, y, 32, 32)

   ' /* load GrayScale raw-image (1bit) file from memory. */
   hImage = HPDF_LoadRawImageFromMem (pdf, RAW_IMAGE_DATA(0), 32, 32, _
               %HPDF_CS_DEVICE_GRAY, 1)

   x = 120
   y = 20

   ' /* Draw image to the canvas. (normal-mode with actual size.)*/
   HPDF_Page_DrawImage (hPage, hImage, x, y, 32, 32)

   ' /* save the document to a file */
   HPDF_SaveToFile (pdf, fname)

   ' /* clean up */
   HPDF_Free (pdf)

   ? "Document created"

END FUNCTION
' ========================================================================================


