' ########################################################################################
' * << Haru Free PDF Library 2.0.6 >> -- slideshow_demo.bas
' * It is provided "as is" without express or implied warranty.
' ########################################################################################

' SED_PBWIN - Use the PBWIN compiler
#COMPILE EXE
#DIM ALL
#INCLUDE ONCE "windows.inc"
#INCLUDE ONCE "hpdf.inc"

' ========================================================================================
' Callback error handler procedure
' ========================================================================================
SUB HPDF_Error_Handler HPDF_CALLCONV() ( _
   BYVAL error_no AS HPDF_STATUS, _
   BYVAL detail_no AS HPDF_STATUS, _
   BYVAL user_data AS DWORD)

   LOCAL strMsg AS STRING

   strMsg = "Error number = " & STR$(error_no) & " [&H" & HEX$(error_no) & "]" & $CRLF
   strMsg = strMsg & "Detail number = " & STR$(detail_no) & " [&H" & HEX$(detail_no) & "]"
   ? strMsg

END SUB
' ========================================================================================

%RAND_MAX = &H7fff

' ========================================================================================
' Print the page
' ========================================================================================
SUB print_page (BYVAL hPage AS HPDF_Page, BYREF caption AS ASCIIZ, BYVAL hFont AS HPDF_Font, _
    BYVAL style AS HPDF_TransitionStyle, BYVAL prevPage AS HPDF_Page, BYVAL nextPage AS HPDF_Page)

   LOCAL r AS SINGLE
   LOCAL g AS SINGLE
   LOCAL b AS SINGLE

   r = RND(1, %RAND_MAX) / %RAND_MAX
   g = RND(1, %RAND_MAX) / %RAND_MAX
   b = RND(1, %RAND_MAX) / %RAND_MAX

   LOCAL rc AS HPDF_Rect
   LOCAL dst AS HPDF_Destination
   LOCAL annot AS HPDF_Annotation

   HPDF_Page_SetWidth (hPage, 800)
   HPDF_Page_SetHeight (hPage, 600)

   HPDF_Page_SetRGBFill (hPage, r, g, b)

   HPDF_Page_Rectangle (hPage, 0, 0, 800, 600)
   HPDF_Page_Fill (hPage)

   HPDF_Page_SetRGBFill (hPage, 1.0! - r, 1.0! - g, 1.0! - b)

   HPDF_Page_SetFontAndSize (hPage, hFont, 30)

   HPDF_Page_BeginText (hPage)
   HPDF_Page_SetTextMatrix (hPage, 0.8!, 0.0!, 0.0!, 1.0!, 0.0!, 0.0!)
   HPDF_Page_TextOut (hPage, 50, 530, caption)

   HPDF_Page_SetTextMatrix (hPage, 1.0!, 0.0!, 0.0!, 1.0!, 0.0!, 0.0!)
   HPDF_Page_SetFontAndSize (hPage, hFont, 20)
   HPDF_Page_TextOut (hPage, 55, 300, _
           "Type Ctrl+L in order to return from full screen mode.")
   HPDF_Page_EndText (hPage)

   HPDF_Page_SetSlideShow (hPage, style, 5.0, 1.0)

   HPDF_Page_SetFontAndSize (hPage, hFont, 20)

   IF (nextPage) THEN
      HPDF_Page_BeginText (hPage)
      HPDF_Page_TextOut (hPage, 680, 50, "Next=>")
      HPDF_Page_EndText (hPage)
      rc.left = 680
      rc.right = 750
      rc.top = 70
      rc.bottom = 50
      dst = HPDF_Page_CreateDestination (nextPage)
      HPDF_Destination_SetFit(dst)
      annot = HPDF_Page_CreateLinkAnnot (hPage, rc, dst)
      HPDF_LinkAnnot_SetBorderStyle (annot, 0, 0, 0)
      HPDF_LinkAnnot_SetHighlightMode (annot, %HPDF_ANNOT_INVERT_BOX)
   END IF

   IF (prevPage) THEN
      HPDF_Page_BeginText (hPage)
      HPDF_Page_TextOut (hPage, 50, 50, "<=Prev")
      HPDF_Page_EndText (hPage)

      rc.left = 50
      rc.right = 110
      rc.top = 70
      rc.bottom = 50
      dst = HPDF_Page_CreateDestination (prevPage)
      HPDF_Destination_SetFit(dst)
      annot = HPDF_Page_CreateLinkAnnot (hPage, rc, dst)
      HPDF_LinkAnnot_SetBorderStyle (annot, 0, 0, 0)
      HPDF_LinkAnnot_SetHighlightMode (annot, %HPDF_ANNOT_INVERT_BOX)
   END IF

END SUB
' ========================================================================================

' ========================================================================================
' Main
' ========================================================================================
FUNCTION PBMAIN

   LOCAL pdf AS HPDF_Doc
   LOCAL hFont AS HPDF_Font
   DIM   pages (0 TO 16) AS HPDF_Page
   LOCAL fname AS ASCIIZ * 256

   fname = "slide_show_demo.pdf"

   pdf = HPDF_New(CODEPTR(HPDF_Error_Handler), %NULL)
   IF pdf = %NULL THEN
      ? "Error: cannot create PdfDoc object"
      EXIT FUNCTION
   END IF

   ' /* create default-font */
   hFont = HPDF_GetFont (pdf, "Courier", BYVAL %NULL)

   ' /* Add 17 pages to the document. */
   pages(0) = HPDF_AddPage (pdf)
   pages(1) = HPDF_AddPage (pdf)
   pages(2) = HPDF_AddPage (pdf)
   pages(3) = HPDF_AddPage (pdf)
   pages(4) = HPDF_AddPage (pdf)
   pages(5) = HPDF_AddPage (pdf)
   pages(6) = HPDF_AddPage (pdf)
   pages(7) = HPDF_AddPage (pdf)
   pages(8) = HPDF_AddPage (pdf)
   pages(9) = HPDF_AddPage (pdf)
   pages(10) = HPDF_AddPage (pdf)
   pages(11) = HPDF_AddPage (pdf)
   pages(12) = HPDF_AddPage (pdf)
   pages(13) = HPDF_AddPage (pdf)
   pages(14) = HPDF_AddPage (pdf)
   pages(15) = HPDF_AddPage (pdf)
   pages(16) = HPDF_AddPage (pdf)

   print_page(pages(0), "HPDF_TS_WIPE_RIGHT", hFont, _
      %HPDF_TS_WIPE_RIGHT, %NULL, pages(1))
   print_page(pages(1), "HPDF_TS_WIPE_UP", hFont, _
      %HPDF_TS_WIPE_UP, pages(0), pages(2))
   print_page(pages(2), "HPDF_TS_WIPE_LEFT", hFont, _
      %HPDF_TS_WIPE_LEFT, pages(1), pages(3))
   print_page(pages(3), "HPDF_TS_WIPE_DOWN", hFont, _
      %HPDF_TS_WIPE_DOWN, pages(2), pages(4))
   print_page(pages(4), "HPDF_TS_BARN_DOORS_HORIZONTAL_OUT", hFont, _
      %HPDF_TS_BARN_DOORS_HORIZONTAL_OUT, pages(3), pages(5))
   print_page(pages(5), "HPDF_TS_BARN_DOORS_HORIZONTAL_IN", hFont, _
      %HPDF_TS_BARN_DOORS_HORIZONTAL_IN, pages(4), pages(6))
   print_page(pages(6), "HPDF_TS_BARN_DOORS_VERTICAL_OUT", hFont, _
      %HPDF_TS_BARN_DOORS_VERTICAL_OUT, pages(5), pages(7))
   print_page(pages(7), "HPDF_TS_BARN_DOORS_VERTICAL_IN", hFont, _
      %HPDF_TS_BARN_DOORS_VERTICAL_IN, pages(6), pages(8))
   print_page(pages(8), "HPDF_TS_BOX_OUT", hFont, _
      %HPDF_TS_BOX_OUT, pages(7), pages(9))
   print_page(pages(9), "HPDF_TS_BOX_IN", hFont, _
      %HPDF_TS_BOX_IN, pages(8), pages(10))
   print_page(pages(10), "HPDF_TS_BLINDS_HORIZONTAL", hFont, _
      %HPDF_TS_BLINDS_HORIZONTAL, pages(9), pages(11))
   print_page(pages(11), "HPDF_TS_BLINDS_VERTICAL", hFont, _
      %HPDF_TS_BLINDS_VERTICAL, pages(10), pages(12))
   print_page(pages(12), "HPDF_TS_DISSOLVE", hFont, _
      %HPDF_TS_DISSOLVE, pages(11), pages(13))
   print_page(pages(13), "HPDF_TS_GLITTER_RIGHT", hFont, _
      %HPDF_TS_GLITTER_RIGHT, pages(12), pages(14))
   print_page(pages(14), "HPDF_TS_GLITTER_DOWN", hFont, _
      %HPDF_TS_GLITTER_DOWN, pages(13), pages(15))
   print_page(pages(15), "HPDF_TS_GLITTER_TOP_LEFT_TO_BOTTOM_RIGHT", hFont, _
      %HPDF_TS_GLITTER_TOP_LEFT_TO_BOTTOM_RIGHT, pages(14), pages(16))
   print_page(pages(16), "HPDF_TS_REPLACE", hFont, _
      %HPDF_TS_REPLACE, pages(15), %NULL)

   HPDF_SetPageMode (pdf, %HPDF_PAGE_MODE_FULL_SCREEN)

   ' /* save the document to a file */
   HPDF_SaveToFile (pdf, fname)

   ' /* clean up */
   HPDF_Free (pdf)

   ? "Document created"

END FUNCTION
' ========================================================================================
