' ########################################################################################
' * << Haru Free PDF Library 2.0.0 >> -- text_annotation.bas
' * It is provided "as is" without express or implied warranty.
' ########################################################################################

' SED_PBWIN - Use the PBWIN compiler
#COMPILE EXE
#DIM ALL
#INCLUDE ONCE "windows.inc"
#INCLUDE ONCE "hpdf.inc"

' ========================================================================================
' Callback error handler procedure
' ========================================================================================
SUB HPDF_Error_Handler HPDF_CALLCONV() ( _
   BYVAL error_no AS HPDF_STATUS, _
   BYVAL detail_no AS HPDF_STATUS, _
   BYVAL user_data AS DWORD)

   LOCAL strMsg AS STRING

   strMsg = "Error number = " & STR$(error_no) & " [&H" & HEX$(error_no) & "]" & $CRLF
   strMsg = strMsg & "Detail number = " & STR$(detail_no) & " [&H" & HEX$(detail_no) & "]"
   ? strMsg

END SUB
' ========================================================================================

' ========================================================================================
' Main
' ========================================================================================
FUNCTION PBMAIN

   LOCAL rect1 AS HPDF_Rect
   LOCAL rect2 AS HPDF_Rect
   LOCAL rect3 AS HPDF_Rect
   LOCAL rect4 AS HPDF_Rect
   LOCAL rect5 AS HPDF_Rect
   LOCAL rect6 AS HPDF_Rect
   LOCAL rect7 AS HPDF_Rect
   LOCAL rect8 AS HPDF_Rect

   rect1.left =  50 : rect1.bottom = 350 : rect1.right = 150 : rect1.top = 400
   rect2.left = 210 : rect2.bottom = 350 : rect2.right = 350 : rect2.top = 400
   rect3.left =  50 : rect3.bottom = 250 : rect3.right = 150 : rect3.top = 300
   rect4.left = 210 : rect4.bottom = 250 : rect4.right = 350 : rect4.top = 300
   rect5.left =  50 : rect5.bottom = 150 : rect5.right = 150 : rect5.top = 200
   rect6.left = 210 : rect6.bottom = 150 : rect6.right = 350 : rect6.top = 200
   rect7.left =  50 : rect7.bottom =  50 : rect7.right = 150 : rect7.top = 100
   rect8.left = 210 : rect8.bottom =  50 : rect8.right = 350 : rect8.top = 100

   LOCAL pdf AS HPDF_Doc
   LOCAL fname AS ASCIIZ * 256
   LOCAL hPage AS HPDF_Page
   LOCAL hFont AS HPDF_Font
   LOCAL encoding AS HPDF_Encoder
   LOCAL annot AS HPDF_Annotation

   fname = "text_annotation.pdf"

   pdf = HPDF_New(CODEPTR(HPDF_Error_Handler), %NULL)
   IF pdf = %NULL THEN
      ? "Error: cannot create PdfDoc object"
      EXIT FUNCTION
   END IF

   ' /* use Times-Roman font. */
   hFont = HPDF_GetFont (pdf, "Times-Roman", "WinAnsiEncoding")

   hPage = HPDF_AddPage (pdf)

   HPDF_Page_SetWidth (hPage, 400)
   HPDF_Page_SetHeight (hPage, 500)

   HPDF_Page_BeginText (hPage)
   HPDF_Page_SetFontAndSize (hPage, hFont, 16)
   HPDF_Page_MoveTextPos (hPage, 130, 450)
   HPDF_Page_ShowText (hPage, "Annotation Demo")
   HPDF_Page_EndText (hPage)

   annot = HPDF_Page_CreateTextAnnot (hPage, rect1, "Annotation with Comment Icon." & $CRLF & _
               "This annotation set to be opened initially.", %NULL)

   HPDF_TextAnnot_SetIcon (annot, %HPDF_ANNOT_ICON_COMMENT)
   HPDF_TextAnnot_SetOpened (annot, %HPDF_TRUE)

   annot = HPDF_Page_CreateTextAnnot (hPage, rect2, _
               "Annotation with Key Icon", %NULL)
   HPDF_TextAnnot_SetIcon (annot, %HPDF_ANNOT_ICON_PARAGRAPH)

   annot = HPDF_Page_CreateTextAnnot (hPage, rect3, _
               "Annotation with Note Icon", %NULL)
   HPDF_TextAnnot_SetIcon (annot, %HPDF_ANNOT_ICON_NOTE)

   annot = HPDF_Page_CreateTextAnnot (hPage, rect4, _
               "Annotation with Help Icon", %NULL)
   HPDF_TextAnnot_SetIcon (annot, %HPDF_ANNOT_ICON_HELP)

   annot = HPDF_Page_CreateTextAnnot (hPage, rect5, _
               "Annotation with NewParagraph Icon", %NULL)
   HPDF_TextAnnot_SetIcon (annot, %HPDF_ANNOT_ICON_NEW_PARAGRAPH)

   annot = HPDF_Page_CreateTextAnnot (hPage, rect6, _
               "Annotation with Paragraph Icon", %NULL)
   HPDF_TextAnnot_SetIcon (annot, %HPDF_ANNOT_ICON_PARAGRAPH)

   annot = HPDF_Page_CreateTextAnnot (hPage, rect7, _
               "Annotation with Insert Icon", %NULL)
   HPDF_TextAnnot_SetIcon (annot, %HPDF_ANNOT_ICON_INSERT)

   encoding = HPDF_GetEncoder (pdf, "ISO8859-2")

   HPDF_Page_CreateTextAnnot (hPage, rect8, _
               "Annotation with ISO8859 text ", encoding)

   HPDF_Page_SetFontAndSize (hPage, hFont, 11)

   HPDF_Page_BeginText (hPage)
   HPDF_Page_MoveTextPos (hPage, rect1.left + 35, rect1.top - 20)
   HPDF_Page_ShowText (hPage, "Comment Icon.")
   HPDF_Page_EndText (hPage)

   HPDF_Page_BeginText (hPage)
   HPDF_Page_MoveTextPos (hPage, rect2.left + 35, rect2.top - 20)
   HPDF_Page_ShowText (hPage, "Key Icon")
   HPDF_Page_EndText (hPage)

   HPDF_Page_BeginText (hPage)
   HPDF_Page_MoveTextPos (hPage, rect3.left + 35, rect3.top - 20)
   HPDF_Page_ShowText (hPage, "Note Icon.")
   HPDF_Page_EndText (hPage)

   HPDF_Page_BeginText (hPage)
   HPDF_Page_MoveTextPos (hPage, rect4.left + 35, rect4.top - 20)
   HPDF_Page_ShowText (hPage, "Help Icon")
   HPDF_Page_EndText (hPage)

   HPDF_Page_BeginText (hPage)
   HPDF_Page_MoveTextPos (hPage, rect5.left + 35, rect5.top - 20)
   HPDF_Page_ShowText (hPage, "NewParagraph Icon")
   HPDF_Page_EndText (hPage)

   HPDF_Page_BeginText (hPage)
   HPDF_Page_MoveTextPos (hPage, rect6.left + 35, rect6.top - 20)
   HPDF_Page_ShowText (hPage, "Paragraph Icon")
   HPDF_Page_EndText (hPage)

   HPDF_Page_BeginText (hPage)
   HPDF_Page_MoveTextPos (hPage, rect7.left + 35, rect7.top - 20)
   HPDF_Page_ShowText (hPage, "Insert Icon")
   HPDF_Page_EndText (hPage)

    HPDF_Page_BeginText (hPage)
    HPDF_Page_MoveTextPos (hPage, rect8.left + 35, rect8.top - 20)
    HPDF_Page_ShowText (hPage, "Text Icon(ISO8859-2 text)")
    HPDF_Page_EndText (hPage)

   ' /* save the document to a file */
   HPDF_SaveToFile (pdf, fname)

   ' /* clean up */
   HPDF_Free (pdf)

   ? "Document created"

END FUNCTION
' ========================================================================================
