' ########################################################################################
' * << Haru Free PDF Library 2.0.0 >> -- text_demo.bas
' * It is provided "as is" without express or implied warranty.
' ########################################################################################

' SED_PBWIN - Use the PBWIN compiler
#COMPILE EXE
#DIM ALL
#INCLUDE ONCE "windows.inc"
#INCLUDE ONCE "hpdf.inc"
#INCLUDE ONCE "grid_sheet.inc"

' ========================================================================================
' Callback error handler procedure
' ========================================================================================
SUB HPDF_Error_Handler HPDF_CALLCONV() ( _
   BYVAL error_no AS HPDF_STATUS, _
   BYVAL detail_no AS HPDF_STATUS, _
   BYVAL user_data AS DWORD)

   LOCAL strMsg AS STRING

   strMsg = "Error number = " & STR$(error_no) & " [&H" & HEX$(error_no) & "]" & $CRLF
   strMsg = strMsg & "Detail number = " & STR$(detail_no) & " [&H" & HEX$(detail_no) & "]"
   ? strMsg

END SUB
' ========================================================================================

' ========================================================================================
' Show pattern
' ========================================================================================
SUB show_pattern (BYVAL hPage AS HPDF_Page, BYVAL x AS HPDF_REAL, BYVAL y AS HPDF_REAL)

   LOCAL iy AS HPDF_UINT

   WHILE (iy < 50)
      HPDF_Page_SetRGBStroke (hPage, 0.0, 0.0, 0.5)
      HPDF_Page_SetLineWidth (hPage, 1)
      HPDF_Page_MoveTo (hPage, x, y + iy)
      HPDF_Page_LineTo (hPage, x + HPDF_Page_TextWidth (hPage, "ABCabc123"), y + iy)
      HPDF_Page_Stroke (hPage)
      iy = iy + 3
   WEND

   HPDF_Page_SetLineWidth (hPage, 2.5)

END SUB
' ========================================================================================

' ========================================================================================
' Show description
' ========================================================================================
SUB show_description ( _
   BYVAL hPage AS HPDF_Page, _
   BYVAL x AS HPDF_REAL, _
   BYVAL y AS HPDF_REAL, _
   BYREF szText AS ASCIIZ)

   LOCAL fsize AS SINGLE
   LOCAL hFont AS HPDF_Font
   LOCAL c AS HPDF_RGBColor PTR
   LOCAL cc AS DWORD

   fsize = HPDF_Page_GetCurrentFontSize (hPage)
   hFont = HPDF_Page_GetCurrentFont (hPage)

   ' It crashed at the end of the program if HPDF_Page_GetRGBFill is called
'   cc = HPDF_Page_GetRGBFill (hPage)
'   c = cc

   HPDF_Page_BeginText (hPage)
   HPDF_Page_SetRGBFill (hPage, 0, 0, 0)
   HPDF_Page_SetTextRenderingMode (hPage, %HPDF_FILL)
   HPDF_Page_SetFontAndSize (hPage, hFont, 10)
   HPDF_Page_TextOut (hPage, x, y - 12, szText)
   HPDF_Page_EndText (hPage)

   HPDF_Page_SetFontAndSize (hPage, hFont, fsize)
'   HPDF_Page_SetRGBFill (hPage, @c.r, @c.g, @c.b)

END SUB
' ========================================================================================

' ========================================================================================
' Main
' ========================================================================================
FUNCTION PBMAIN

   LOCAL page_title AS ASCIIZ * 256

   page_title = "Text Demo"

   LOCAL pdf AS HPDF_Doc
   LOCAL hFont AS HPDF_Font
   LOCAL hPage AS HPDF_Page
   LOCAL fname AS ASCIIZ * 256
   LOCAL samp_text AS ASCIIZ * 256
   LOCAL samp_text2 AS ASCIIZ * 256

   samp_text = "abcdefgABCDEFG123!#$%&+-@?"
   samp_text2 = "The quick brown fox jumps over the lazy dog."

   LOCAL tw AS SINGLE
   LOCAL fsize AS SINGLE
   LOCAL i AS LONG
   LOCAL buf AS ASCIIZ * 50
   LOCAL length AS LONG

   LOCAL angle1 AS SINGLE
   LOCAL angle2 AS SINGLE
   LOCAL rad1 AS SINGLE
   LOCAL rad2 AS SINGLE

   LOCAL ypos AS SINGLE

   LOCAL r AS SINGLE
   LOCAL b AS SINGLE
   LOCAL g AS SINGLE

   fname = "text_demo.pdf"

   pdf = HPDF_New(CODEPTR(HPDF_Error_Handler), %NULL)
   IF pdf = %NULL THEN
      ? "Error: cannot create PdfDoc object"
      EXIT FUNCTION
   END IF

   ' /* set compression mode */
   HPDF_SetCompressionMode (pdf, %HPDF_COMP_ALL)

   ' /* create default-font */
   hFont = HPDF_GetFont (pdf, "Helvetica", BYVAL %NULL)

   ' /* add a new page object. */
   hPage = HPDF_AddPage (pdf)

   ' /* draw grid to the page */
   print_grid  (pdf, hPage)

   ' /* print the lines of the page.
'   HPDF_Page_SetLineWidth (page, 1)
'   HPDF_Page_Rectangle (page, 50, 50, HPDF_Page_GetWidth(page) - 100, _
'               HPDF_Page_GetHeight (page) - 110)
'   HPDF_Page_Stroke (page)
   ' */

   ' /* print the title of the page (with positioning center). */
   HPDF_Page_SetFontAndSize (hPage, hFont, 24)
   tw = HPDF_Page_TextWidth (hPage, page_title)
   HPDF_Page_BeginText (hPage)
   HPDF_Page_TextOut (hPage, (HPDF_Page_GetWidth(hPage) - tw) / 2, _
               HPDF_Page_GetHeight (hPage) - 50, page_title)
   HPDF_Page_EndText (hPage)

   HPDF_Page_BeginText (hPage)
   HPDF_Page_MoveTextPos (hPage, 60, HPDF_Page_GetHeight(hPage) - 60)

   ' /*
   '  * font size
   '  */
   fsize = 8
   WHILE (fsize < 60)
      ' /* set style and size of font. */
      HPDF_Page_SetFontAndSize(hPage, hFont, fsize)

      ' /* set the position of the text. */
      HPDF_Page_MoveTextPos (hPage, 0, -5 - fsize)

      ' /* measure the number of characters to include in the page. */
      buf = samp_text
      length = HPDF_Page_MeasureText (hPage, samp_text, _
                     HPDF_Page_GetWidth(hPage) - 120, %HPDF_FALSE, BYVAL %NULL)

      ' /* truncate the text. */
      buf = LEFT$(buf, length)

      HPDF_Page_ShowText (hPage, buf)

      ' /* print the description. */
      HPDF_Page_MoveTextPos (hPage, 0, -10)
      HPDF_Page_SetFontAndSize(hPage, hFont, 8)
      buf = "Fontsize=" & FORMAT$(fsize)
      HPDF_Page_ShowText (hPage, buf)

      fsize = fsize * 1.5
   WEND

   ' /*
   '  * font color
   '  */
   HPDF_Page_SetFontAndSize(hPage, hFont, 8)
   HPDF_Page_MoveTextPos (hPage, 0, -30)
   HPDF_Page_ShowText (hPage, "Font color")

   HPDF_Page_SetFontAndSize (hPage, hFont, 18)
   HPDF_Page_MoveTextPos (hPage, 0, -20)
   length = LEN(samp_text)
   FOR i = 0 TO length - 1
      r = i / length
      g = 1 - (i / length)
      buf = MID$(samp_text, i + 1, 1)
      HPDF_Page_SetRGBFill (hPage, r, g, 0.0)
      HPDF_Page_ShowText (hPage, buf)
   NEXT
   HPDF_Page_MoveTextPos (hPage, 0, -25)

   FOR i = 0 TO length - 1
      r = i / length
      b = 1 - (i / length)
      buf = MID$(samp_text, i + 1, 1)
      HPDF_Page_SetRGBFill (hPage, r, 0.0, b)
      HPDF_Page_ShowText (hPage, buf)
   NEXT
   HPDF_Page_MoveTextPos (hPage, 0, -25)

   FOR i = 0 TO length - 1
      b = i / length
      g = 1 - (i / length)
      buf = MID$(samp_text, i + 1, 1)
      HPDF_Page_SetRGBFill (hPage, 0.0, g, b)
      HPDF_Page_ShowText (hPage, buf)
   NEXT
   HPDF_Page_MoveTextPos (hPage, 0, -25)

   HPDF_Page_EndText (hPage)

   ypos = 450

   ' /*
   '  * Font rendering mode
   '  */
   HPDF_Page_SetFontAndSize(hPage, hFont, 32)
   HPDF_Page_SetRGBFill (hPage, 0.5, 0.5, 0.0)
   HPDF_Page_SetLineWidth (hPage, 1.5)

   ' /* PDF_FILL */
   show_description (hPage, 60, ypos, "RenderingMode=PDF_FILL")
   HPDF_Page_SetTextRenderingMode (hPage, %HPDF_FILL)
   HPDF_Page_BeginText (hPage)
   HPDF_Page_TextOut (hPage, 60, ypos, "ABCabc123")
   HPDF_Page_EndText (hPage)

   ' /* PDF_STROKE */
   show_description (hPage, 60, ypos - 50, "RenderingMode=PDF_STROKE")
   HPDF_Page_SetTextRenderingMode (hPage, %HPDF_STROKE)
   HPDF_Page_BeginText (hPage)
   HPDF_Page_TextOut (hPage, 60, ypos - 50, "ABCabc123")
   HPDF_Page_EndText (hPage)

   ' /* PDF_FILL_THEN_STROKE */
   show_description (hPage, 60, ypos - 100, "RenderingMode=PDF_FILL_THEN_STROKE")
   HPDF_Page_SetTextRenderingMode (hPage, %HPDF_FILL_THEN_STROKE)
   HPDF_Page_BeginText (hPage)
   HPDF_Page_TextOut (hPage, 60, ypos - 100, "ABCabc123")
   HPDF_Page_EndText (hPage)

   ' /* PDF_FILL_CLIPPING */
   show_description (hPage, 60, ypos - 150, "RenderingMode=PDF_FILL_CLIPPING")
   HPDF_Page_GSave (hPage)
   HPDF_Page_SetTextRenderingMode (hPage, %HPDF_FILL_CLIPPING)
   HPDF_Page_BeginText (hPage)
   HPDF_Page_TextOut (hPage, 60, ypos - 150, "ABCabc123")
   HPDF_Page_EndText (hPage)
   show_pattern (hPage, 60, ypos - 150)
   HPDF_Page_GRestore (hPage)

   ' /* PDF_STROKE_CLIPPING */
   show_description (hPage, 60, ypos - 200, "RenderingMode=PDF_STROKE_CLIPPING")
   HPDF_Page_GSave (hPage)
   HPDF_Page_SetTextRenderingMode (hPage, %HPDF_STROKE_CLIPPING)
   HPDF_Page_BeginText (hPage)
   HPDF_Page_TextOut (hPage, 60, ypos - 200, "ABCabc123")
   HPDF_Page_EndText (hPage)
   show_pattern (hPage, 60, ypos - 200)
   HPDF_Page_GRestore (hPage)

   ' /* PDF_FILL_STROKE_CLIPPING */
   show_description (hPage, 60, ypos - 250, "RenderingMode=PDF_FILL_STROKE_CLIPPING")
   HPDF_Page_GSave (hPage)
   HPDF_Page_SetTextRenderingMode (hPage, %HPDF_FILL_STROKE_CLIPPING)
   HPDF_Page_BeginText (hPage)
   HPDF_Page_TextOut (hPage, 60, ypos - 250, "ABCabc123")
   HPDF_Page_EndText (hPage)
   show_pattern (hPage, 60, ypos - 250)
   HPDF_Page_GRestore (hPage)

   ' /* Reset text attributes */
   HPDF_Page_SetTextRenderingMode (hPage, %HPDF_FILL)
   HPDF_Page_SetRGBFill (hPage, 0, 0, 0)
   HPDF_Page_SetFontAndSize(hPage, hFont, 30)

   ' /*
   '  * Rotating text
   '  */
   angle1 = 30                     ' /* A rotation of 30 degrees. */
   rad1 = angle1 / 180 * 3.141592  ' /* Calcurate the radian value. */

   show_description (hPage, 320, ypos - 60, "Rotating text")
   HPDF_Page_BeginText (hPage)
   HPDF_Page_SetTextMatrix (hPage, COS(rad1), SIN(rad1), -SIN(rad1), COS(rad1), _
               330, ypos - 60)
   HPDF_Page_ShowText (hPage, "ABCabc123")
   HPDF_Page_EndText (hPage)

   ' /*
   '  * Skewing text.
   '  */
   show_description (hPage, 320, ypos - 120, "Skewing text")
   HPDF_Page_BeginText (hPage)

   angle1 = 10
   angle2 = 20
   rad1 = angle1 / 180 * 3.141592
   rad2 = angle2 / 180 * 3.141592

   HPDF_Page_SetTextMatrix (hPage, 1, TAN(rad1), TAN(rad2), 1, 320, ypos - 120)
   HPDF_Page_ShowText (hPage, "ABCabc123")
   HPDF_Page_EndText (hPage)

   ' /*
   '  * scaling text (X direction)
   '  */
   show_description (hPage, 320, ypos - 175, "Scaling text (X direction)")
   HPDF_Page_BeginText (hPage)
   HPDF_Page_SetTextMatrix (hPage, 1.5, 0, 0, 1, 320, ypos - 175)
   HPDF_Page_ShowText (hPage, "ABCabc12")
   HPDF_Page_EndText (hPage)

   ' /*
   '  * scaling text (Y direction)
   '  */
   show_description (hPage, 320, ypos - 250, "Scaling text (Y direction)")
   HPDF_Page_BeginText (hPage)
   HPDF_Page_SetTextMatrix (hPage, 1, 0, 0, 2, 320, ypos - 250)
   HPDF_Page_ShowText (hPage, "ABCabc123")
   HPDF_Page_EndText (hPage)

   ' /*
   '  * char spacing, word spacing
   '  */

   show_description (hPage, 60, 140, "char-spacing 0")
   show_description (hPage, 60, 100, "char-spacing 1.5")
   show_description (hPage, 60, 60, "char-spacing 1.5, word-spacing 2.5")

   HPDF_Page_SetFontAndSize (hPage, hFont, 20)
   HPDF_Page_SetRGBFill (hPage, 0.1, 0.3, 0.1)

   ' /* char-spacing 0 */
   HPDF_Page_BeginText (hPage)
   HPDF_Page_TextOut (hPage, 60, 140, samp_text2)
   HPDF_Page_EndText (hPage)

   ' /* char-spacing 1.5 */
   HPDF_Page_SetCharSpace (hPage, 1.5)

   HPDF_Page_BeginText (hPage)
   HPDF_Page_TextOut (hPage, 60, 100, samp_text2)
   HPDF_Page_EndText (hPage)

   ' /* char-spacing 1.5, word-spacing 3.5 */
   HPDF_Page_SetWordSpace (hPage, 2.5)

   HPDF_Page_BeginText (hPage)
   HPDF_Page_TextOut (hPage, 60, 60, samp_text2)
   HPDF_Page_EndText (hPage)

   ' /* save the document to a file */
   HPDF_SaveToFile (pdf, fname)

   ' /* clean up */
   HPDF_Free (pdf)

   ? "Document created"

END FUNCTION
' ========================================================================================
