' ########################################################################################
' * << Alternative PDF Library 1.0.0 >> -- text_demo2.bas
' * It is provided "as is" without express or implied warranty.
' ########################################################################################

' SED_PBWIN - Use the PBWIN compiler
#COMPILE EXE
#DIM ALL
#INCLUDE ONCE "windows.inc"
#INCLUDE ONCE "hpdf.inc"
#INCLUDE ONCE "grid_sheet.inc"

' ========================================================================================
' Callback error handler procedure
' ========================================================================================
SUB HPDF_Error_Handler HPDF_CALLCONV() ( _
   BYVAL error_no AS HPDF_STATUS, _
   BYVAL detail_no AS HPDF_STATUS, _
   BYVAL user_data AS DWORD)

   LOCAL strMsg AS STRING

   strMsg = "Error number = " & STR$(error_no) & " [&H" & HEX$(error_no) & "]" & $CRLF
   strMsg = strMsg & "Detail number = " & STR$(detail_no) & " [&H" & HEX$(detail_no) & "]"
   ? strMsg

END SUB
' ========================================================================================

$SAMP_TXT = "The quick brown fox jumps over the lazy dog. "

' ========================================================================================
' Main
' ========================================================================================
FUNCTION PBMAIN

   LOCAL pdf AS HPDF_Doc
   LOCAL hPage AS HPDF_Page
   LOCAL fname AS ASCIIZ * 256
   LOCAL hFont AS HPDF_Font
   LOCAL angle1 AS SINGLE
   LOCAL angle2 AS SINGLE
   LOCAL rad1 AS SINGLE
   LOCAL rad2 AS SINGLE
   LOCAL page_height AS HPDF_REAL
   LOCAL rc AS HPDF_Rect
   LOCAL i AS LONG
   LOCAL buf AS ASCIIZ * 2
   LOCAL x AS SINGLE
   LOCAL y AS SINGLE

   fname = "text_demo2.pdf"

   pdf = HPDF_New(CODEPTR(HPDF_Error_Handler), %NULL)
   IF pdf = %NULL THEN
      ? "Error: cannot create PdfDoc object"
      EXIT FUNCTION
   END IF

   ' /* add a new page object. */
   hPage = HPDF_AddPage (pdf)
   HPDF_Page_SetSize (hPage, %HPDF_PAGE_SIZE_A5, %HPDF_PAGE_PORTRAIT)

   print_grid  (pdf, hPage)

   page_height = HPDF_Page_GetHeight (hPage)

   hFont = HPDF_GetFont (pdf, "Helvetica", BYVAL %NULL)
   HPDF_Page_SetTextLeading (hPage, 20)

   ' /* text_rect method */

   ' /* HPDF_TALIGN_LEFT */
   rc.left = 25
   rc.top = 545
   rc.right = 200
   rc.bottom = rc.top - 40

   HPDF_Page_Rectangle (hPage, rc.left, rc.bottom, rc.right - rc.left, rc.top - rc.bottom)
   HPDF_Page_Stroke (hPage)

   HPDF_Page_BeginText (hPage)

   HPDF_Page_SetFontAndSize (hPage, hFont, 10)
   HPDF_Page_TextOut (hPage, rc.left, rc.top + 3, "HPDF_TALIGN_LEFT")

   HPDF_Page_SetFontAndSize (hPage, hFont, 13)
   HPDF_Page_TextRect (hPage, rc.left, rc.top, rc.right, rc.bottom, _
               $SAMP_TXT, %HPDF_TALIGN_LEFT, BYVAL %NULL)

   HPDF_Page_EndText (hPage)

   ' /* HPDF_TALIGN_RIGTH */
   rc.left = 220
   rc.right = 395

   HPDF_Page_Rectangle (hPage, rc.left, rc.bottom, rc.right - rc.left, rc.top - rc.bottom)
   HPDF_Page_Stroke (hPage)

   HPDF_Page_BeginText (hPage)

   HPDF_Page_SetFontAndSize (hPage, hFont, 10)
   HPDF_Page_TextOut (hPage, rc.left, rc.top + 3, "HPDF_TALIGN_RIGTH")

   HPDF_Page_SetFontAndSize (hPage, hFont, 13)
   HPDF_Page_TextRect (hPage, rc.left, rc.top, rc.right, rc.bottom, _
               $SAMP_TXT, %HPDF_TALIGN_RIGHT, BYVAL %NULL)

   HPDF_Page_EndText (hPage)

   ' /* HPDF_TALIGN_CENTER */
   rc.left = 25
   rc.top = 475
   rc.right = 200
   rc.bottom = rc.top - 40

   HPDF_Page_Rectangle (hPage, rc.left, rc.bottom, rc.right - rc.left, rc.top - rc.bottom)
   HPDF_Page_Stroke (hPage)

   HPDF_Page_BeginText (hPage)

   HPDF_Page_SetFontAndSize (hPage, hFont, 10)
   HPDF_Page_TextOut (hPage, rc.left, rc.top + 3, "HPDF_TALIGN_CENTER")

   HPDF_Page_SetFontAndSize (hPage, hFont, 13)
   HPDF_Page_TextRect (hPage, rc.left, rc.top, rc.right, rc.bottom, _
               $SAMP_TXT, %HPDF_TALIGN_CENTER, BYVAL %NULL)

   HPDF_Page_EndText (hPage)

   ' /* HPDF_TALIGN_JUSTIFY */
   rc.left = 220
   rc.right = 395

   HPDF_Page_Rectangle (hPage, rc.left, rc.bottom, rc.right - rc.left, rc.top - rc.bottom)
   HPDF_Page_Stroke (hPage)

   HPDF_Page_BeginText (hPage)

   HPDF_Page_SetFontAndSize (hPage, hFont, 10)
   HPDF_Page_TextOut (hPage, rc.left, rc.top + 3, "HPDF_TALIGN_JUSTIFY")

   HPDF_Page_SetFontAndSize (hPage, hFont, 13)
   HPDF_Page_TextRect (hPage, rc.left, rc.top, rc.right, rc.bottom, _
               $SAMP_TXT, %HPDF_TALIGN_JUSTIFY, BYVAL %NULL)

   HPDF_Page_EndText (hPage)


   ' /* Skewed coordinate system */
   HPDF_Page_GSave (hPage)

   angle1 = 5
   angle2 = 10
   rad1 = angle1 / 180 * 3.141592
   rad2 = angle2 / 180 * 3.141592

   HPDF_Page_Concat (hPage, 1, tan(rad1), tan(rad2), 1, 25, 350)
   rc.left = 0
   rc.top = 40
   rc.right = 175
   rc.bottom = 0

   HPDF_Page_Rectangle (hPage, rc.left, rc.bottom, rc.right - rc.left, rc.top - rc.bottom)
   HPDF_Page_Stroke (hPage)

   HPDF_Page_BeginText (hPage)

   HPDF_Page_SetFontAndSize (hPage, hFont, 10)
   HPDF_Page_TextOut (hPage, rc.left, rc.top + 3, "Skewed coordinate system")

   HPDF_Page_SetFontAndSize (hPage, hFont, 13)
   HPDF_Page_TextRect (hPage, rc.left, rc.top, rc.right, rc.bottom, _
               $SAMP_TXT, %HPDF_TALIGN_LEFT, BYVAL %NULL)

   HPDF_Page_EndText (hPage)

   HPDF_Page_GRestore (hPage)


   ' /* Rotated coordinate system */
   HPDF_Page_GSave (hPage)

   angle1 = 5
   rad1 = angle1 / 180 * 3.141592

   HPDF_Page_Concat (hPage, COS(rad1), SIN(rad1), -SIN(rad1), COS(rad1), 220, 350)
   rc.left = 0
   rc.top = 40
   rc.right = 175
   rc.bottom = 0

   HPDF_Page_Rectangle (hPage, rc.left, rc.bottom, rc.right - rc.left, rc.top - rc.bottom)
   HPDF_Page_Stroke (hPage)

   HPDF_Page_BeginText (hPage)

   HPDF_Page_SetFontAndSize (hPage, hFont, 10)
   HPDF_Page_TextOut (hPage, rc.left, rc.top + 3, "Rotated coordinate system")

   HPDF_Page_SetFontAndSize (hPage, hFont, 13)
   HPDF_Page_TextRect (hPage, rc.left, rc.top, rc.right, rc.bottom, _
               $SAMP_TXT, %HPDF_TALIGN_LEFT, BYVAL %NULL)

   HPDF_Page_EndText (hPage)

   HPDF_Page_GRestore (hPage)


   ' /* text along a circle */
   HPDF_Page_SetGrayStroke (hPage, 0)
   HPDF_Page_Circle (hPage, 210, 190, 145)
   HPDF_Page_Circle (hPage, 210, 190, 113)
   HPDF_Page_Stroke (hPage)

   angle1 = 360 / LEN($SAMP_TXT)
   angle2 = 180

   HPDF_Page_BeginText (hPage)
   hFont = HPDF_GetFont (pdf, "Courier-Bold", BYVAL %NULL)
   HPDF_Page_SetFontAndSize (hPage, hFont, 30)

   FOR i = 0 TO LEN($SAMP_TXT) - 1
      rad1 = (angle2 - 90) / 180 * 3.141592
      rad2 = angle2 / 180 * 3.141592
      x = 210 + cos(rad2) * 122
      y = 190 + sin(rad2) * 122
      HPDF_Page_SetTextMatrix(hPage, COS(rad1), SIN(rad1), -SIN(rad1), COS(rad1), x, y)
      buf = MID$($SAMP_TXT, i + 1, 1)
      HPDF_Page_ShowText (hPage, buf)
      angle2 = angle2 - angle1
   NEXT

   HPDF_Page_EndText (hPage)

   ' /* save the document to a file */
   HPDF_SaveToFile (pdf, fname)

   ' /* clean up */
   HPDF_Free (pdf)

   ? "Document created"

END FUNCTION
' ========================================================================================
