' ########################################################################################
' * << Haru Free PDF Library 2.0.0 >> -- ttfont_demo.bas
' * It is provided "as is" without express or implied warranty.
' ########################################################################################

' SED_PBWIN - Use the PBWIN compiler
#COMPILE EXE
#DIM ALL
#INCLUDE ONCE "windows.inc"
#INCLUDE ONCE "hpdf.inc"

' ========================================================================================
' Callback error handler procedure
' ========================================================================================
SUB HPDF_Error_Handler HPDF_CALLCONV() ( _
   BYVAL error_no AS HPDF_STATUS, _
   BYVAL detail_no AS HPDF_STATUS, _
   BYVAL user_data AS DWORD)

   LOCAL strMsg AS STRING

   strMsg = "Error number = " & STR$(error_no) & " [&H" & HEX$(error_no) & "]" & $CRLF
   strMsg = strMsg & "Detail number = " & STR$(detail_no) & " [&H" & HEX$(detail_no) & "]"
   ? strMsg

END SUB
' ========================================================================================

$SAMP_TXT = "The quick brown fox jumps over the lazy dog."

' ========================================================================================
' Main
' ========================================================================================
FUNCTION PBMAIN

   LOCAL pdf AS HPDF_Doc
   LOCAL fname AS ASCIIZ * 256
   LOCAL hPage AS HPDF_Page
   LOCAL title_font AS HPDF_Font
   LOCAL detail_font AS HPDF_Font
   LOCAL pv AS DWORD
   LOCAL detail_font_name AS ASCIIZ PTR
   LOCAL embed AS HPDF_BOOL
   LOCAL page_height AS HPDF_REAL
   LOCAL page_width AS HPDF_REAL
   LOCAL pw AS HPDF_REAL

   fname = "ttfont_demo.pdf"

   pdf = HPDF_New(CODEPTR(HPDF_Error_Handler), %NULL)
   IF pdf = %NULL THEN
      ? "Error: cannot create PdfDoc object"
      EXIT FUNCTION
   END IF

   ' /* Add a new page object. */
   hPage = HPDF_AddPage (pdf)

   title_font = HPDF_GetFont (pdf, "Helvetica", BYVAL %NULL)

   embed = %HPDF_TRUE

   pv = HPDF_LoadTTFontFromFile (pdf, "ttfont/PenguinAttack.ttf", embed)
   detail_font_name = pv

   detail_font = HPDF_GetFont (pdf, @detail_font_name, BYVAL %NULL)

   HPDF_Page_SetFontAndSize (hPage, title_font, 10)

   HPDF_Page_BeginText (hPage)

   ' /* Move the position of the text to top of the page. */
   HPDF_Page_MoveTextPos(hPage, 10, 190)
   HPDF_Page_ShowText (hPage, @detail_font_name)

   IF embed THEN HPDF_Page_ShowText (hPage, "(Embedded Subset)")

   HPDF_Page_SetFontAndSize (hPage, detail_font, 15)
   HPDF_Page_MoveTextPos (hPage, 10, -20)
   HPDF_Page_ShowText (hPage, "abcdefghijklmnopqrstuvwxyz")
   HPDF_Page_MoveTextPos (hPage, 0, -20)
   HPDF_Page_ShowText (hPage, "ABCDEFGHIJKLMNOPQRSTUVWXYZ")
   HPDF_Page_MoveTextPos (hPage, 0, -20)
   HPDF_Page_ShowText (hPage, "1234567890")
   HPDF_Page_MoveTextPos (hPage, 0, -20)

   HPDF_Page_SetFontAndSize (hPage, detail_font, 10)
   HPDF_Page_ShowText (hPage, $SAMP_TXT)
   HPDF_Page_MoveTextPos (hPage, 0, -18)

   HPDF_Page_SetFontAndSize (hPage, detail_font, 16)
   HPDF_Page_ShowText (hPage, $SAMP_TXT)
   HPDF_Page_MoveTextPos (hPage, 0, -27)

   HPDF_Page_SetFontAndSize (hPage, detail_font, 23)
   HPDF_Page_ShowText (hPage, $SAMP_TXT)
   HPDF_Page_MoveTextPos (hPage, 0, -36)

   HPDF_Page_SetFontAndSize (hPage, detail_font, 30)
   HPDF_Page_ShowText (hPage, $SAMP_TXT)
   HPDF_Page_MoveTextPos (hPage, 0, -36)

   pw = HPDF_Page_TextWidth (hPage, $SAMP_TXT)
   page_height = 210
   page_width = pw + 40

   HPDF_Page_SetWidth (hPage, page_width)
   HPDF_Page_SetHeight (hPage, page_height)

   ' /* Finish to print text. */
   HPDF_Page_EndText (hPage)

   HPDF_Page_SetLineWidth (hPage, 0.5)

   HPDF_Page_MoveTo (hPage, 10, page_height - 25)
   HPDF_Page_LineTo (hPage, page_width - 10, page_height - 25)
   HPDF_Page_Stroke (hPage)

   HPDF_Page_MoveTo (hPage, 10, page_height - 85)
   HPDF_Page_LineTo (hPage, page_width - 10, page_height - 85)
   HPDF_Page_Stroke (hPage)

   HPDF_SaveToFile (pdf, fname)

   ' /* clean up */
   HPDF_Free (pdf)

   ? "Document created"

END FUNCTION
' ========================================================================================

